C                                                                       00000100
C SHELX-76 UPDATED 1.7.77   ...FOR NEUTRON DATA                         00000200
C                                                                       00000300
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,A(14026)            00000400
C                                                                       00000500
C LM IS DIMENSION OF A, AND MUST BE AT LEAST 14026.                     00000600
C MBF IS DIMENSION OF F AND HENCE INTERNAL BUFFER SIZE FOR UNITS LA     00000700
C LC, AND LF.   MBF MUST BE GREATER THAN 83, AND DIVISIBLE BY 6.        00000800
C IF MBF IS CHANGED, THE DIMENSION OF F IN ALL SUBROUTINES (AND E       00000900
C IN SMERG) MUST BE CHANGED ACCORDINGLY.                                00001000
C                                                                       00001100
      LM=14026                                                          00001200
      MBF=84                                                            00001300
C                                                                       00001400
C LOGICAL UNIT NUMBERS FOR INSTRUCTIONS, HKLF INPUT, LINEPRINTER, PUNCH,00001500
C THREE SCRATCH FILES AND DATA FILE FOLLOW.  ALL SHOULD BE DIFFERENT.   00001600
C                                                                       00001700
      LR=5                                                              00001800
      LH=1                                                              00001900
      LI=6                                                              00002000
      LP=7                                                              00002100
      LA=2                                                              00002200
      LB=4                                                              00002300
      LC=8                                                              00002400
      LF=3                                                              00002500
C                                                                       00002600
C LU=1 IF INTEGER WORD LENGTH IS HALF REAL WORD LENGTH (OR LESS),       00002700
C OTHERWISE LU=0.  N.B. INTEGERS MUST BE AT LEAST 24 BITS.  IF LU=1,    00002800
C THE MINIMUM VALUE OF LM IS REDUCED TO 10700.                          00002900
C                                                                       00003000
      LU=0                                                              00003100
C                                                                       00003200
C HA AND HD ARE NUMBER OF CHARACTERS PER INCH ACROSS AND DOWN           00003300
C PRINTER PAGE RESPECTIVELY.                                            00003400
C                                                                       00003500
      HA=10.                                                            00003600
      HD=6.                                                             00003700
C                                                                       00003800
      LV=MBF-5                                                          00003900
      CALL INIT                                                         00004000
      CALL XDRED                                                        00004100
      CALL SMERG                                                        00004200
      CALL ATFIX                                                        00004300
      CALL XREF                                                         00004400
      CALL ABOND                                                        00004500
      CALL XCEN                                                         00004600
      CALL XTPR                                                         00004700
      CALL CONV                                                         00004800
      CALL PHEX                                                         00004900
      CALL QUAT                                                         00005000
      CALL XMAP                                                         00005100
      CALL XERR                                                         00005200
      STOP                                                              00005300
      END                                                               00005400
C                                                                       00005500
      SUBROUTINE HKL(Q,X,Y,Z)                                           00005600
      Z=AINT(0.0001*Q+SIGN(0.5,Q))                                      00005700
      X=(AINT(Q+SIGN(0.5,Q))-10000.*Z)*0.01                             00005800
      Y=AINT(X+SIGN(0.5,X+0.1))                                         00005900
      X=AINT(101.*(X-Y))                                                00006000
      RETURN                                                            00006100
      END                                                               00006200
C                                                                       00006300
      SUBROUTINE INIT                                                   00006400
      DIMENSION IH(71),E(228),EW(36)                                    00006500
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,  00006600
     *IT(40),H(100),F(84),C(1740),JN(160),IN(660),IR(76),IG(48),        00006700
     *B(645),CF(100),A(200),G(52),IS(76),IP(20),D(100)                  00006800
      DATA IH(1)/1H0/,IH(2)/1H1/,IH(3)/1H2/,IH(4)/1H3/,IH(5)/1H4/       00006900
      DATA IH(6)/1H5/,IH(7)/1H6/,IH(8)/1H7/,IH(9)/1H8/,IH(10)/1H9/      00007000
      DATA IH(11)/1H./,IH(12)/1H-/,IH(13)/1H+/,IH(14)/1HX/,IH(15)/1HY/  00007100
      DATA IH(16)/1HZ/,IH(17)/1H,/,IH(18)/1H=/,IH(19)/4HCELL/           00007200
      DATA IH(20)/4HEND /,IH(21)/4HHKLF/,IH(22)/4HLATT/,IH(23)/4HBLOC/  00007300
      DATA IH(24)/4HSFAC/,IH(25)/4HUNIT/,IH(26)/4HAXIS/,IH(27)/4HILSF/  00007400
      DATA IH(28)/4HGRID/,IH(29)/4HANIS/,IH(30)/4HTANG/,IH(31)/4HAFIX/  00007500
      DATA IH(32)/4HFVAR/,IH(33)/4HBOND/,IH(34)/4HWGHT/,IH(35)/4HABSC/  00007600
      DATA IH(36)/4HFMAP/,IH(37)/4HL.S./,IH(38)/4HPHIX/,IH(39)/4HEEES/  00007700
      DATA IH(40)/4HDFIX/,IH(41)/4HUNDO/,IH(42)/4HLIST/,IH(43)/4HOMIT/  00007800
      DATA IH(44)/4HPLAN/,IH(45)/4HFACE/,IH(46)/4HMERG/,IH(47)/4HAFLS/  00007900
C                                                                       00008000
C GAUSSIAN COEFFICIENTS                                                 00008100
C                                                                       00008200
      DATA E(1)/.5773503/,E(2)/.8611363/,E(3)/.3399810/,E(4)/.9324695/  00008300
      DATA E(5)/.6612094/,E(6)/.2386192/,E(7)/.9602899/,E(8)/.7966665/  00008400
      DATA E(9)/.5255324/,E(10)/.1834346/,E(11)/.9739065/               00008500
      DATA E(12)/.8650634/,E(13)/.6794096/,E(14)/.4333954/              00008600
      DATA E(15)/.1488743/,E(16)/.9815606/,E(17)/.9041173/              00008700
      DATA E(18)/.7699027/,E(19)/.5873180/,E(20)/.3678315/              00008800
      DATA E(21)/.1252334/,E(22)/.9862838/,E(23)/.9284349/              00008900
      DATA E(24)/.8272013/,E(25)/.6872929/,E(26)/.5152486/              00009000
      DATA E(27)/.3191124/,E(28)/.1080549/,E(29)/.9894009/              00009100
      DATA E(30)/.9445750/,E(31)/.8656312/,E(32)/.7554044/              00009200
      DATA E(33)/.6178762/,E(34)/.4580168/,E(35)/.2816036/              00009300
      DATA E(36)/.0950125/,EW(1)/1./,EW(2)/.3478548/,EW(3)/.6521452/    00009400
      DATA EW(4)/.1713245/,EW(5)/.3607616/,EW(6)/.4679139/              00009500
      DATA EW(7)/.1012285/,EW(8)/.2223810/,EW(9)/.3137066/              00009600
      DATA EW(10)/.3626838/,EW(11)/.0666713/,EW(12)/.1494513/           00009700
      DATA EW(13)/.2190864/,EW(14)/.2692667/,EW(15)/.2955242/           00009800
      DATA EW(16)/.0471753/,EW(17)/.1069393/,EW(18)/.1600783/           00009900
      DATA EW(19)/.2031674/,EW(20)/.2334925/,EW(21)/.2491470/           00010000
      DATA EW(22)/.0351195/,EW(23)/.0801581/,EW(24)/.1215186/           00010100
      DATA EW(25)/.1572032/,EW(26)/.1855384/,EW(27)/.2051985/           00010200
      DATA EW(28)/.2152639/,EW(29)/.0271525/,EW(30)/.0622535/           00010300
      DATA EW(31)/.0951585/,EW(32)/.1246290/,EW(33)/.1495960/           00010400
      DATA EW(34)/.1691565/,EW(35)/.1826034/,EW(36)/.1894506/           00010500
C                                                                       00010600
C SFAC C  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00010700
C                                                                       00010800
      DATA IH(48)/1HC/,IH(49)/1H /,E(37)/1.93/,E(38)/12.72/,E(39)/1.878/00010900
      DATA E(40)/28.6/,E(41)/1.574/,E(42)/.5965/,E(43)/.371/,E(44)/65./ 00011000
      DATA E(45)/.247/,E(46)/.002/,E(47)/.002/,E(48)/5.98/,E(49)/.75/   00011100
      DATA E(50)/.017/,E(51)/.009/,E(52)/77.8/                          00011200
C                                                                       00011300
C SFAC N  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00011400
C                                                                       00011500
      DATA IH(50)/1HN/,IH(51)/1H /,E(53)/12.791/,E(54)/.02064/          00011600
      DATA E(55)/3.287/,E(56)/10.7/,E(57)/1.767/,E(58)/30.8/,E(59)/.547/00011700
      DATA E(60)/1.48/,E(61)/-11.392/,E(62)/.004/,E(63)/.003/,E(64)/14./00011800
      DATA E(65)/.7/,E(66)/.029/,E(67)/.018/,E(68)/156./                00011900
C                                                                       00012000
C SFAC O  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00012100
C                                                                       00012200
      DATA IH(52)/1HO/,IH(53)/1H /,E(69)/2.957/,E(70)/13.9/             00012300
      DATA E(71)/2.452/,E(72)/5.92/,E(73)/1.505/,E(74)/.3454/           00012400
      DATA E(75)/.782/,E(76)/34.1/,E(77)/.304/,E(78)/.008/,E(79)/.006/  00012500
      DATA E(80)/23.9/,E(81)/.67/,E(82)/.047/,E(83)/.032/,E(84)/279./   00012600
C                                                                       00012700
C SFAC F  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00012800
C                                                                       00012900
      DATA IH(54)/1HF/,IH(55)/1H /,E(85)/3.304/,E(86)/11.265/           00013000
      DATA E(87)/3.018/,E(88)/4.665/,E(89)/1.358/,E(90)/.3376/          00013100
      DATA E(91)/.836/,E(92)/28./,E(93)/.484/,E(94)/.014/,E(95)/.01/    00013200
      DATA E(96)/41./,E(97)/.65/,E(98)/.069/,E(99)/.053/,E(100)/464./   00013300
C                                                                       00013400
C SFAC SI ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00013500
C                                                                       00013600
      DATA IH(56)/1HS/,IH(57)/1HI/,E(101)/5.794/,E(102)/2.571/          00013700
      DATA E(103)/3.224/,E(104)/34.18/,E(105)/2.428/,E(106)/.869/       00013800
      DATA E(107)/1.322/,E(108)/85.3/,E(109)/1.232/,E(110)/.072/        00013900
      DATA E(111)/.071/,E(112)/284./,E(113)/1.05/,E(114)/.244/          00014000
      DATA E(115)/.33/,E(116)/2868./                                    00014100
C                                                                       00014200
C SFAC P  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00014300
C                                                                       00014400
      DATA IH(58)/1HP/,IH(59)/1H /,E(117)/6.921/,E(118)/1.838/          00014500
      DATA E(119)/4.144/,E(120)/27./,E(121)/2.017/,E(122)/.2132/        00014600
      DATA E(123)/1.539/,E(124)/67.1/,E(125)/.379/,E(126)/.09/          00014700
      DATA E(127)/.095/,E(128)/375./,E(129)/1.05/,E(130)/.283/          00014800
      DATA E(131)/.434/,E(132)/3764./                                   00014900
C                                                                       00015000
C SFAC S  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00015100
C                                                                       00015200
      DATA IH(60)/1HS/,IH(61)/1H /,E(133)/7.187/,E(134)/1.433/          00015300
      DATA E(135)/5.887/,E(136)/.02865/,E(137)/5.159/,E(138)/22.1/      00015400
      DATA E(139)/1.644/,E(140)/55.5/,E(141)/-3.877/,E(142)/.11/        00015500
      DATA E(143)/.124/,E(144)/495./,E(145)/1.1/,E(146)/.319/           00015600
      DATA E(147)/.557/,E(148)/4834./                                   00015700
C                                                                       00015800
C SFAC CL ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00015900
C                                                                       00016000
      DATA IH(62)/1HC/,IH(63)/1HL/,E(149)/9.84/,E(150)/-0.00053/        00016100
      DATA E(151)/7.532/,E(152)/1.111/,E(153)/6.071/,E(154)/18.085/     00016200
      DATA E(155)/1.871/,E(156)/45.4/,E(157)/-8.314/,E(158)/.132/       00016300
      DATA E(159)/.159/,E(160)/636./,E(161)/1.1/,E(162)/.348/           00016400
      DATA E(163)/.702/,E(164)/6099./                                   00016500
C                                                                       00016600
C SFAC B  ACTA CRYST. A24 (1968) 321 AND J.CHEM.PHYS. 53 (1970) 1891    00016700
C                                                                       00016800
      DATA IH(64)/1HB/,IH(65)/1H /,E(165)/2.0397/,E(166)/23.09/         00016900
      DATA E(167)/1.415/,E(168)/.9784/,E(169)/1.1167/,E(170)/59.9/      00017000
      DATA E(171)/.7327/,E(172)/.0854/,E(173)/-0.3041/,E(174)/0./       00017100
      DATA E(175)/.001/,E(176)/3.593/,E(177)/.70/,E(178)/.008/          00017200
      DATA E(179)/.004/,E(180)/34.13/                                   00017300
C                                                                       00017400
C SFAC BR  ACTA CRYST. A24 (1968) 390 AND J.CHEM.PHYS. 53 (1970)1891    00017500
C                                                                       00017600
      DATA IH(66)/1HB/,IH(67)/1HR/,E(181)/17.18/,E(182)/2.172/          00017700
      DATA E(183)/5.238/,E(184)/16.58/,E(185)/5.638/,E(186)/.2609/      00017800
      DATA E(187)/3.988/,E(188)/41.4/,E(189)/2.956/,E(190)/-.374/       00017900
      DATA E(191)/2.456/,E(192)/9818./,E(193)/1.2/,E(194)/-.767/        00018000
      DATA E(195)/1.283/,E(196)/11145./                                 00018100
C                                                                       00018200
C SFAC SN  ACTA CRYST. A24 (1968) 390 AND J.CHEM.PHYS. 53 (1970)1891    00018300
C                                                                       00018400
      DATA IH(68)/1HS/,IH(69)/1HN/,E(197)/19.19/,E(198)/5.83/           00018500
      DATA E(199)/19.1/,E(200)/.5031/,E(201)/4.46/,E(202)/26.9/         00018600
      DATA E(203)/2.47/,E(204)/84./,E(205)/4.78/,E(206)/-.873/          00018700
      DATA E(207)/1.424/,E(208)/5695./,E(209)/1.45/,E(210)/-0.194/      00018800
      DATA E(211)/5.459/,E(212)/47416./                                 00018900
C                                                                       00019000
C SFAC H  D.T. CROMER, PERSONAL COMMUNICATION BASED ON BONDED SPHERICAL 00019100
C         ATOM MODEL, R.F. STEWART ET AL., J.CHEM.PHYS. 42 (1965) 3175  00019200
C                                                                       00019300
      DATA IH(70)/1HH/,IH(71)/1H /,E(213)/.493/,E(214)/10.511/          00019400
      DATA E(215)/.323/,E(216)/26.126/,E(217)/.1402/,E(218)/3.1424/     00019500
      DATA E(219)/.0408/,E(220)/57.8/,E(221)/.003/,E(222)/0./           00019600
      DATA E(223)/0./,E(224)/.06/,E(225)/.33/,E(226)/0./                00019700
      DATA E(227)/0./,E(228)/.07/                                       00019800
C                                                                       00019900
      WRITE(LI,1)                                                       00020000
1     FORMAT(1H1)                                                       00020100
      DO 2 I=1,40                                                       00020200
2     IT(I)=IH(49)                                                      00020300
      DO 3 I=1,47                                                       00020400
3     IG(I)=IH(I)                                                       00020500
      IG(48)=IH(49)                                                     00020600
      DO 4 I=48,71                                                      00020700
4     IN(I+589)=IH(I)                                                   00020800
      DO 5 I=37,228                                                     00020900
5     C(I+1512)=E(I)                                                    00021000
      BN=0.                                                             00021100
      KZ=0                                                              00021200
      ME=0                                                              00021300
      MF=1                                                              00021400
      KF=-3                                                             00021500
C                                                                       00021600
C INTEGRATION COEFFICIENTS                                              00021700
C                                                                       00021800
      M=1                                                               00021900
      K=1                                                               00022000
      DO 6 I=1,8                                                        00022100
      L=M                                                               00022200
      M=M+I+I                                                           00022300
      DO 6 J=1,I                                                        00022400
      N=M-J                                                             00022500
      B(L)=E(K)*0.5+0.5                                                 00022600
      B(L+72)=EW(K)*0.5                                                 00022700
      B(N)=1.-B(L)                                                      00022800
      B(N+72)=B(L+72)                                                   00022900
      K=K+1                                                             00023000
6     L=L+1                                                             00023100
      DO 7 I=145,645                                                    00023200
7     B(I)=EXP(FLOAT(145-I)*0.03125)                                    00023300
C                                                                       00023400
C SET UP IN AND C                                                       00023500
C                                                                       00023600
      DO 8 I=1,636                                                      00023700
8     IN(I)=0                                                           00023800
      DO 9 I=1,1548                                                     00023900
9     C(I)=0.                                                           00024000
      C(26)=-99.                                                        00024100
      C(31)=1.E5                                                        00024200
      DO 10 I=33,35                                                     00024300
      C(I)=-2.                                                          00024400
10    C(I+3)=2.                                                         00024500
      C(39)=-999.                                                       00024600
      C(40)=99.                                                         00024700
      C(43)=.25                                                         00024800
      C(44)=.95                                                         00024900
      C(46)=1.                                                          00025000
      C(48)=-999.                                                       00025100
      C(50)=1.08                                                        00025200
      C(51)=1.42                                                        00025300
      C(52)=1.395                                                       00025400
      C(59)=1.                                                          00025500
      C(60)=1.E9                                                        00025600
      C(61)=1.                                                          00025700
      C(65)=1.                                                          00025800
      C(69)=1.                                                          00025900
      IN(1)=61                                                          00026000
      IN(2)=-99                                                         00026100
      IN(6)=17                                                          00026200
      IN(9)=-9999                                                       00026300
      IN(13)=-999                                                       00026400
      IN(16)=28                                                         00026500
      IN(17)=100                                                        00026600
      IN(18)=1                                                          00026700
      RETURN                                                            00026800
      END                                                               00026900
C                                                                       00027000
      SUBROUTINE XDRED                                                  00027100
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,  00027200
     *IT(40),H(100),F(84),C(1740),JN(160),IN(660),IR(76),IH(48),        00027300
     *B(645),CF(100),A(200),E(52),IS(76),IP(20),D(100)                  00027400
      DATA JT/4HTITL/,JY/4HSYMM/,JZ/4H    /                             00027500
1     FORMAT(A4,76A1)                                                   00027600
2     FORMAT(1H ,A4,76A1)                                               00027700
      MJ=0                                                              00027800
      MP=0                                                              00027900
      JS=0                                                              00028000
      JB=0                                                              00028100
      L=73                                                              00028200
      NY=0                                                              00028300
      NX=1                                                              00028400
      NQ=0                                                              00028500
      NF=0                                                              00028600
C                                                                       00028700
C READ IN FREE FORMAT                                                   00028800
C                                                                       00028900
3     READ(LR,1)I,IR                                                    00029000
      WRITE(LI,2)I,IR                                                   00029100
      IF(I.EQ.JZ)GOTO 3                                                 00029200
      IF(I.EQ.JT)GOTO 127                                               00029300
      N=0                                                               00029400
      NK=47                                                             00029500
      NER=-9                                                            00029600
      IF(1740-L)23,4,4                                                  00029700
4     IF(I.EQ.IH(NK)) GOTO 5                                            00029800
      NK=NK-1                                                           00029900
      IF(18-NK)4,5,5                                                    00030000
5     NK=NK-17                                                          00030100
      NER=-1                                                            00030200
      ASSIGN 16 TO JJ                                                   00030300
      IF(I.NE.JY)GOTO 24                                                00030400
      NJ=L-5                                                            00030500
      L=L+9                                                             00030600
6     W=1.                                                              00030700
7     V=0.                                                              00030800
      NB=0                                                              00030900
      Y=1.                                                              00031000
      U=10.                                                             00031100
      Z=1.                                                              00031200
      GOTO 10                                                           00031300
8     Z=Y*Z                                                             00031400
      V=U*ABS(V)+Z*X                                                    00031500
      NB=1                                                              00031600
      IF(V)9,10,9                                                       00031700
9     V=SIGN(V,W)                                                       00031800
      W=V                                                               00031900
10    N=N+1                                                             00032000
      K=10                                                              00032100
      IF(76-N)15,11,11                                                  00032200
11    X=0.                                                              00032300
      DO 12 M=1,10                                                      00032400
      IF(IR(N).EQ.IH(M)) GOTO 8                                         00032500
12    X=X+1.                                                            00032600
      GOTO 14                                                           00032700
13    IF(IR(N).EQ.IH(K+9)) GOTO 15                                      00032800
14    K=K-1                                                             00032900
      IF(K-2)15,13,13                                                   00033000
15    GOTO JJ,(16,26)                                                   00033100
16    GOTO(10,17,31,31,18,18,18,19,21,19),K                             00033200
17    U=1.                                                              00033300
      Y=0.1                                                             00033400
      GOTO 10                                                           00033500
18    K=K+NJ                                                            00033600
      C(K)=W                                                            00033700
      GOTO 6                                                            00033800
19    C(L)=C(L)+V                                                       00033900
      L=L+1                                                             00034000
      NJ=NJ+3                                                           00034100
      IF(L-NJ-9)20,6,6                                                  00034200
20    IN(1)=IN(1)+12                                                    00034300
      IF(L-12-IN(1))22,3,22                                             00034400
21    READ(LR,1)M,IR                                                    00034500
      WRITE(LI,2)M,IR                                                   00034600
      N=0                                                               00034700
      IF(JZ.EQ.M)GOTO 6                                                 00034800
22    IN(1)=I                                                           00034900
23    IN(20)=NER                                                        00035000
      GOTO 147                                                          00035100
24    DO 25 J=1,200                                                     00035200
25    A(J)=0.                                                           00035300
      NA=0                                                              00035400
      ASSIGN 26 TO JJ                                                   00035500
      GOTO 6                                                            00035600
26    IF(K-2)27,17,27                                                   00035700
27    NA=NA+NB                                                          00035800
      IF(200-NA)22,28,28                                                00035900
28    IF(-NA)29,30,30                                                   00036000
29    A(NA)=V+A(NA)                                                     00036100
30    IF(K-9)32,21,34                                                   00036200
31    C(L)=V                                                            00036300
32    IF(K-3)6,33,6                                                     00036400
33    W=-1.                                                             00036500
      GOTO 7                                                            00036600
34    GOTO(83,35,133,132,40,122,41,60,125,77,125,67,125,102,83,125,     00036700
     *118,68,120,114,64,124,103,105,119,130,129,74,72,114),NK           00036800
C                                                                       00036900
C UNITCELL                                                              00037000
C                                                                       00037100
35    IF(7-NA)22,36,22                                                  00037200
36    DO 37 J=1,7                                                       00037300
      IF(0.01-A(J))37,22,22                                             00037400
37    C(J)=A(J)                                                         00037500
      U=2.*A(2)*A(3)*A(4)                                               00037600
      DO 38 J=2,4                                                       00037700
      C(J+9)=U*COS(.0174533*A(J+3))/A(J)                                00037800
      A(J+9)=C(J+9)*C(J+9)                                              00037900
38    C(J+6)=A(J)*A(J)                                                  00038000
      V=U*U                                                             00038100
      U=V-C(8)*A(11)-C(9)*A(12)-C(10)*A(13)+C(11)*C(12)*C(13)           00038200
      C(32)=0.5*SQRT(U)                                                 00038300
      U=39.4784/U                                                       00038400
      DO 39 J=8,10                                                      00038500
      C(J+6)=0.5*U*((V/C(J))-A(J+3))                                    00038600
39    C(J+9)=-2.*U*C(J)*C(J+3)                                          00038700
      C(17)=C(17)+U*C(12)*C(13)                                         00038800
      C(18)=C(18)+U*C(11)*C(13)                                         00038900
      C(19)=C(19)+U*C(11)*C(12)                                         00039000
      C(20)=SQRT(C(15)*C(16))*2.                                        00039100
      C(21)=SQRT(C(14)*C(16))*2.                                        00039200
      C(22)=SQRT(C(14)*C(15))*2.                                        00039300
      UT=78.95684/(C(1)*C(1))                                           00039400
      GOTO 3                                                            00039500
C                                                                       00039600
C LATT                                                                  00039700
C                                                                       00039800
40    C(23)=0.5-SIGN(0.5,A(1)+0.01)                                     00039900
      IN(18)=INT(ABS(A(1)))                                             00040000
      IF(1-NA)22,3,3                                                    00040100
C                                                                       00040200
C SFAC                                                                  00040300
C                                                                       00040400
41    IF(-IN(2))42,43,43                                                00040500
42    IF(IN(2)+103-L)22,43,22                                           00040600
43    IN(2)=L                                                           00040700
      IF(-IN(3))22,44,44                                                00040800
44    NJ=77                                                             00040900
      IF(NA)45,45,51                                                    00041000
45    NJ=0                                                              00041100
46    NJ=NJ+1                                                           00041200
      IF(75-NJ)3,47,47                                                  00041300
47    DO 48 J=637,659,2                                                 00041400
      IF(IN(J).NE.IR(NJ))GOTO 48                                        00041500
      IF(IN(J+1).EQ.IR(NJ+1))GOTO 49                                    00041600
48    CONTINUE                                                          00041700
      IF(IR(NJ).EQ.IH(48))GOTO 46                                       00041800
      NER=-13                                                           00041900
      GOTO 23                                                           00042000
49    NJ=NJ+1                                                           00042100
      IN(2)=L                                                           00042200
      J=(8*J)-3547                                                      00042300
      K=(INT(C(1))*4)+J                                                 00042400
      NA=13                                                             00042500
      DO 50 M=1,13                                                      00042600
      A(M)=C(J)                                                         00042700
50    J=J+1                                                             00042800
      A(10)=C(K+9)                                                      00042900
      A(11)=C(K+10)                                                     00043000
      A(12)=C(K+11)                                                     00043100
51    NF=NF+1                                                           00043200
      C(L)=A(13)                                                        00043300
      L=L+1                                                             00043400
      C(L)=A(11)                                                        00043500
      W=0.                                                              00043600
      IF(C(1).LT.0.001)GOTO 58                                          00043700
      IF(A(13).GT.2.0)WRITE(LI,53)                                      00043800
      IF(A(12).LT.0.)GOTO 22                                            00043900
      X=A(1)+A(3)+A(5)+A(7)+A(9)                                        00044000
      IF(ABS(AMOD(X+0.5,1.)-0.5).LT.0.02+0.002*X)GOTO 52                00044100
      WRITE(LI,53)                                                      00044200
53    FORMAT(16H ** DUBIOUS SFAC/)                                      00044300
52    Z=0.004/(C(1)*C(1))                                               00044400
      DO 56 N=1,51                                                      00044500
      X=0.                                                              00044600
      Y=0.                                                              00044700
      DO 55 K=1,6                                                       00044800
      M=L+K                                                             00044900
      C(M)=A(9)+A(10)                                                   00045000
      DO 54 J=1,7,2                                                     00045100
      V=-A(J+1)*(W+X)                                                   00045200
      IF(V.GT.-15.)C(M)=C(M)+A(J)*EXP(V)                                00045300
54    CONTINUE                                                          00045400
      X=X+Z                                                             00045500
55    Y=Y+C(M)                                                          00045600
      C(L+2)=1.25*Y-3.75*(C(L+1)+C(L+6))                                00045700
      L=L+2                                                             00045800
56    W=W+5.*Z                                                          00045900
      H(NF)=C(L-101)-A(10)                                              00046000
      H(NF+50)=A(12)                                                    00046100
      IF(NA-13)22,46,22                                                 00046200
57    I=IH(25)                                                          00046300
      GOTO 59                                                           00046400
58    I=IH(19)                                                          00046500
59    NER=-10                                                           00046600
      GOTO 22                                                           00046700
C                                                                       00046800
C UNIT                                                                  00046900
C                                                                       00047000
60    I=IH(24)                                                          00047100
      IF(NA.NE.NF)GOTO 59                                               00047200
      X=0.                                                              00047300
      C(53)=0.                                                          00047400
      DO 61 K=1,NA                                                      00047500
      C(53)=C(53)+H(K+50)*A(K)/C(32)                                    00047600
61    X=X+H(K)*A(K)                                                     00047700
      DO 62 J=1,51                                                      00047800
      E(J)=0.                                                           00047900
      F(J)=0.                                                           00048000
      M=IN(1)+J+J+12                                                    00048100
      DO 62 K=1,NF                                                      00048200
      Y=C(M)*C(M)*A(K)                                                  00048300
      E(J)=E(J)+Y                                                       00048400
      F(J)=F(J)+Y*C(M)                                                  00048500
62    M=M+103                                                           00048600
      IF(F(14).LT.0.001)GOTO 22                                         00048700
      C(45)=2.*F(14)/(E(14)*SQRT(E(14)))                                00048800
      C(58)=E(1)                                                        00048900
63    FORMAT(/4H V =,F8.2,12H    F(000) =,F8.2,8H    MU =,F8.2/)        00049000
      WRITE(LI,63)C(32),X,C(53)                                         00049100
      IN(3)=L-6                                                         00049200
      GOTO 3                                                            00049300
C                                                                       00049400
C PHIX                                                                  00049500
C                                                                       00049600
64    IF(IN(3).NE.L-6)GOTO 22                                           00049700
      IN(3)=L                                                           00049800
      U=0.                                                              00049900
      M=IN(1)                                                           00050000
      DO 65 J=61,M,12                                                   00050100
65    U=AMAX1(U,ABS(A(1)*C(J)+A(2)*C(J+3)+A(3)*C(J+6)+100.*(A(1)*C(J+1)+00050200
     *A(2)*C(J+4)+A(3)*C(J+7)+100.*(A(1)*C(J+2)+A(2)*C(J+5)+A(3)*C(J+8) 00050300
     *))))                                                              00050400
      C(L)=U                                                            00050500
      MP=L                                                              00050600
      L=L+1                                                             00050700
      DO 66 J=4,8                                                       00050800
      C(L)=A(J)                                                         00050900
66    L=L+1                                                             00051000
      IF(7-NA)22,3,3                                                    00051100
C                                                                       00051200
C ANIS                                                                  00051300
C                                                                       00051400
67    NY=-INT(A(1))                                                     00051500
      IF(NA-1)22,3,22                                                   00051600
C                                                                       00051700
C ABSC                                                                  00051800
C                                                                       00051900
68    C(26)=5.                                                          00052000
      C(30)=1.                                                          00052100
      KF=-3                                                             00052200
      IF(NA-1)71,70,69                                                  00052300
69    C(53)=A(2)                                                        00052400
70    C(26)=2.5/AMAX1(ABS(A(1)),0.01)                                   00052500
      C(30)=SIGN(1.,A(1)+0.0001)                                        00052600
71    IF(2-NA)22,3,3                                                    00052700
C                                                                       00052800
C MERG                                                                  00052900
C                                                                       00053000
72    IF(NA.LT.1)GOTO 22                                                00053100
      DO 73 J=1,NA                                                      00053200
73    C(J+53)=A(J)                                                      00053300
      IF(4-NA)22,3,3                                                    00053400
C                                                                       00053500
C FACE                                                                  00053600
C                                                                       00053700
74    IF(A(4).LT.0.00001)GOTO 22                                        00053800
      IF(KF.GT.96)GOTO 22                                               00053900
      A(4)=0.1*A(4)                                                     00054000
      X=C(14)*A(1)*A(1)+C(15)*A(2)*A(2)+C(16)*A(3)*A(3)+                00054100
     *C(17)*A(2)*A(3)+C(18)*A(1)*A(3)+C(19)*A(1)*A(2)                   00054200
      IF(0.0001.GT.X)GOTO 22                                            00054300
      X=SQRT(19.73921/X)                                                00054400
      DO 75 J=1,3                                                       00054500
75    A(J)=A(J)*X                                                       00054600
      DO 76 J=1,4                                                       00054700
      CF(KF+4)=A(J)                                                     00054800
76    KF=KF+1                                                           00054900
      IF(NA-4)22,3,22                                                   00055000
C                                                                       00055100
C ILSF                                                                  00055200
C                                                                       00055300
77    N=4                                                               00055400
      J=1                                                               00055500
      IF(-IN(4))78,79,79                                                00055600
78    IF(IN(4)+1-L)22,81,22                                             00055700
79    IN(4)=L                                                           00055800
      IN(12)=A(1)                                                       00055900
      C(L)=1.                                                           00056000
      J=1                                                               00056100
80    L=L+1                                                             00056200
      J=J+1                                                             00056300
81    IF(NA-J)3,82,82                                                   00056400
82    C(L)=A(J)                                                         00056500
      IN(N)=L                                                           00056600
      GOTO 80                                                           00056700
C                                                                       00056800
C FVAR ETC                                                              00056900
C                                                                       00057000
83    N=5                                                               00057100
      J=1                                                               00057200
      IF(-IN(4))85,84,84                                                00057300
84    IN(4)=L                                                           00057400
      C(L)=1.                                                           00057500
      L=L+1                                                             00057600
85    IF(-IN(5))88,86,86                                                00057700
86    C(L)=1.                                                           00057800
      C(L+1)=1.                                                         00057900
      IN(5)=L+1                                                         00058000
      L=L+2                                                             00058100
      IF(NK-11)89,87,87                                                 00058200
87    C(L-2)=A(1)                                                       00058300
      J=2                                                               00058400
88    IF(NK-11)89,81,81                                                 00058500
C                                                                       00058600
C ATOMS                                                                 00058700
C                                                                       00058800
89    IF(IN(7))90,90,22                                                 00058900
90    IN(6)=IN(6)+4                                                     00059000
      K=IN(6)                                                           00059100
      IF(660-K)101,91,91                                                00059200
91    NER=-14                                                           00059300
      IF(NQ.LT.0)GOTO 22                                                00059400
      NER=-1                                                            00059500
      MJ=MJ-1                                                           00059600
      IF(MJ*(NX/10).LT.0)GOTO 22                                        00059700
      IN(K+1)=NX+NQ                                                     00059800
      NQ=A(1)                                                           00059900
      IF(IN(2)-(103*NQ)-IN(1)+91)22,92,92                               00060000
92    IN(K+2)=NQ+NQ+10                                                  00060100
      NQ=0                                                              00060200
      JS=JS+1                                                           00060300
      JN(JS)=I                                                          00060400
      IN(K+3)=JB                                                        00060500
      IF(NA-4)22,93,94                                                  00060600
93    A(5)=11.                                                          00060700
      A(6)=0.05                                                         00060800
      NA=6                                                              00060900
94    DO 95 J=2,NA                                                      00061000
      C(L)=A(J)                                                         00061100
95    L=L+1                                                             00061200
      IN(K)=10                                                          00061300
      IF(NA-6)22,97,96                                                  00061400
96    IF(NA-11)22,3,22                                                  00061500
97    IF(NY)99,98,98                                                    00061600
98    IN(K)=5                                                           00061700
      GOTO 3                                                            00061800
99    C(L)=A(6)                                                         00061900
      C(L+1)=A(6)                                                       00062000
      L=L+2                                                             00062100
      DO 100 J=17,19                                                    00062200
      C(L)=A(6)-AMOD(A(6),10.)*(1.-C(J)/C(J+3))                         00062300
100   L=L+1                                                             00062400
      NY=NY+1                                                           00062500
      GOTO 3                                                            00062600
101   I=160                                                             00062700
      NER=-3                                                            00062800
      GOTO 22                                                           00062900
C                                                                       00063000
C AFIX                                                                  00063100
C                                                                       00063200
102   NQ=MAX0(0,MOD(INT(A(1)),10)-5)                                    00063300
      NX=INT(A(1)+1.1)-NQ                                               00063400
      MJ=MIN0(6,NX/10)                                                  00063500
      IF(MJ.EQ.4)MJ=1                                                   00063600
      IF(1-NA)22,3,3                                                    00063700
C                                                                       00063800
C DFIX                                                                  00063900
C                                                                       00064000
103   IF(IN(7).LT.1)IN(7)=L                                             00064100
      IF(NA.LT.4)GOTO 22                                                00064200
      DO 104 J=3,NA,2                                                   00064300
      U=A(J)*4.+17.1                                                    00064400
      V=A(J+1)*4.+17.1                                                  00064500
      C(L)=A(1)                                                         00064600
      C(L+1)=AMAX1(A(2),0.0001)                                         00064700
      C(L+2)=U                                                          00064800
      C(L+3)=V                                                          00064900
104   L=L+4                                                             00065000
      C(L)=0.                                                           00065100
      IF(MOD(NA,2))22,3,22                                              00065200
C                                                                       00065300
C UNDO                                                                  00065400
C                                                                       00065500
105   NA=MAX0(NA,1)                                                     00065600
      DO 113 M=1,NA                                                     00065700
      N=A(M)                                                            00065800
      X=0.                                                              00065900
      IF(N)106,113,107                                                  00066000
106   X=1.                                                              00066100
107   K=17                                                              00066200
      N=N+IN(4)+1                                                       00066300
      P=AMOD(C(N)+2.,10.)-2.5                                           00066400
      J=IN(5)                                                           00066500
108   K=K+4                                                             00066600
      IF(IN(6)-K)113,109,109                                            00066700
109   DO 110 NI=1,3                                                     00066800
      J=J+1                                                             00066900
110   C(J)=20.*AINT(0.1*C(J)+SIGN(0.5,C(J)+1.E-6))*X+C(J)*(1.-2.*X)     00067000
      J=J-3                                                             00067100
      NJ=IN(K)                                                          00067200
      DO 112 NI=1,NJ                                                    00067300
      J=J+1                                                             00067400
      IF(5.-ABS(ABS(C(J))-10.*A(M)))112,111,111                         00067500
111   Q=SIGN(0.5,C(J)+5.)                                               00067600
      R=AMOD(C(J)+5.,10.)-10.*Q                                         00067700
      C(J)=R*(Q+P)                                                      00067800
112   CONTINUE                                                          00067900
      GOTO 108                                                          00068000
113   CONTINUE                                                          00068100
      GOTO 3                                                            00068200
C                                                                       00068300
C L.S.                                                                  00068400
C                                                                       00068500
114   IF(NA-2)117,116,115                                               00068600
115   C(47)=A(3)                                                        00068700
116   C(46)=A(2)                                                        00068800
117   IN(13)=INT(ABS(A(1))+0.1)                                         00068900
      IF(NK.LT.25)IN(13)=-IN(13)                                        00069000
      IF(3-NA)22,3,3                                                    00069100
C                                                                       00069200
C WGHT                                                                  00069300
C                                                                       00069400
118   C(60)=A(1)                                                        00069500
      IN(19)=A(2)                                                       00069600
      IN(8)=A(3)                                                        00069700
      IF(3-NA)22,3,3                                                    00069800
C                                                                       00069900
C LIST                                                                  00070000
C                                                                       00070100
119   IN(10)=A(1)                                                       00070200
      IN(11)=A(2)                                                       00070300
      IF(2-NA)22,3,3                                                    00070400
C                                                                       00070500
C FMAP                                                                  00070600
C                                                                       00070700
120   K=MIN0(4,MAX0(NA,1))                                              00070800
      C(24)=A(5)                                                        00070900
      DO 121 J=1,K                                                      00071000
121   IN(J+13)=A(J)                                                     00071100
      IF(5-NA)22,3,3                                                    00071200
C                                                                       00071300
C BLOC                                                                  00071400
C                                                                       00071500
122   JB=1                                                              00071600
      IF(NX.EQ.3)NQ=-1                                                  00071700
      IF(NA.EQ.0)GOTO 3                                                 00071800
      DO 123 J=1,NA                                                     00071900
      K=A(J)                                                            00072000
      IF(MIN0(K,21-K).LT.1)GOTO 22                                      00072100
123   JB=JB+2**K                                                        00072200
      GOTO 3                                                            00072300
C                                                                       00072400
C EEES                                                                  00072500
C                                                                       00072600
124   C(40)=12.                                                         00072700
      C(42)=0.7                                                         00072800
      C(43)=0.5                                                         00072900
      C(41)=4.                                                          00073000
      C(44)=-1.                                                         00073100
      NK=13                                                             00073200
      IF(C(23).GT.0.5)GOTO 22                                           00073300
C                                                                       00073400
C TANG, GRID, AXIS, BOND                                                00073500
C                                                                       00073600
125   K=3*NK                                                            00073700
      NA=MAX0(NA,1)                                                     00073800
      DO 126 J=1,NA                                                     00073900
      C(K)=A(J)                                                         00074000
126   K=K+1                                                             00074100
      IF(5+MOD(NK,2)-NA)22,3,3                                          00074200
C                                                                       00074300
C TITL                                                                  00074400
C                                                                       00074500
127   DO 128 J=1,40                                                     00074600
128   IT(J)=IR(J)                                                       00074700
      GOTO 3                                                            00074800
C                                                                       00074900
C PLAN                                                                  00075000
C                                                                       00075100
129   K=A(1)                                                            00075200
      J=A(2)                                                            00075300
      IN(9)=K+1000*J                                                    00075400
      GOTO 3                                                            00075500
C                                                                       00075600
C OMIT                                                                  00075700
C                                                                       00075800
130   IF(NA.EQ.3)GOTO 131                                               00075900
      C(31)=A(1)                                                        00076000
      IF(NA-1)22,3,22                                                   00076100
131   KZ=KZ+1                                                           00076200
      H(KZ)=A(1)+100.*(A(2)+100.*A(3))                                  00076300
      IF(KZ-100)3,3,22                                                  00076400
C                                                                       00076500
C HKLF                                                                  00076600
C                                                                       00076700
132   IF(C(45).LT.1.E-6)GOTO 57                                         00076800
      ME=NA                                                             00076900
      CALL FREAD                                                        00077000
      IF(IN(20))147,3,3                                                 00077100
C                                                                       00077200
C END                                                                   00077300
C                                                                       00077400
133   IF(A(1)-0.9)135,134,134                                           00077500
134   LR=A(1)                                                           00077600
      GOTO 3                                                            00077700
135   X=IN(18)                                                          00077800
      IF(X-4.5)137,136,136                                              00077900
136   X=2.                                                              00078000
137   C(25)=(2.-C(23))*X                                                00078100
      IF(C(45).LT.1.E-6)GOTO 57                                         00078200
      C(45)=C(45)*SQRT(X)                                               00078300
      C(46)=UT*C(46)*C(46)                                              00078400
      IN(5)=MAX0(IN(5),IN(4)+2,IN(3)+5)                                 00078500
      I=IH(34)                                                          00078600
      IF(MIN0(IN(8),IN(19)).LT.0)GOTO 22                                00078700
      IF(MAX0(IN(8),IN(19))+IN(4).GT.IN(5)-1)GOTO 22                    00078800
      J=IABS(IN(14))                                                    00078900
C                                                                       00079000
C SIM FOURIER COEFFICIENTS                                              00079100
C                                                                       00079200
      IF((3-J)*(5-J))143,138,143                                        00079300
138   IF(L.GT.1689)IN(20)=-9                                            00079400
      Y=.0833333*C(25)*FLOAT(IN(1)-49)                                  00079500
      I=17                                                              00079600
      K=IN(5)+4                                                         00079700
139   I=I+4                                                             00079800
      IF(I.GT.IN(6))GOTO 141                                            00079900
      M=IN(1)+103*((IN(I+2)-12)/2)+14                                   00080000
      L=MAX0(2,INT(ABS(C(K)*0.1)+1.5))+IN(4)                            00080100
      Q=SIGN(0.5,C(K)+5.)                                               00080200
      X=Y*(AMOD(C(K)+5.,10.)-10.*Q)*(Q+AMOD(C(L)+5.,10.)-5.5)           00080300
      DO 140 N=1,51                                                     00080400
      E(N)=E(N)-X*C(M)*C(M)                                             00080500
140   M=M+2                                                             00080600
      K=K+IN(I)                                                         00080700
      GOTO 139                                                          00080800
141   X=0.                                                              00080900
      Y=.0789568/(C(1)*C(1))                                            00081000
      DO 142 N=1,51                                                     00081100
      C(N+1689)=2.*EXP(X)/AMAX1(E(N),1.E-5)                             00081200
142   X=X+Y                                                             00081300
143   L=IABS(IN(10))                                                    00081400
      IF((2-J)*(3-J)*(5-J)*(1-L)*(5-L)*                                 00081500
     *MAX0(1-IABS(IN(11)),0))145,144,145                                00081600
144   IF(IN(13).LT.-998)IN(13)=0                                        00081700
145   IF(MIN0(IN(13)+998,20-IN(6)))147,146,146                          00081800
146   IN(20)=-7                                                         00081900
147   WRITE(LB)IT,JN,IN,C                                               00082000
      ENDFILE LB                                                        00082100
      REWIND LB                                                         00082200
      KF=IN(20)                                                         00082300
      RETURN                                                            00082400
      END                                                               00082500
C                                                                       00082600
      SUBROUTINE FREAD                                                  00082700
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,  00082800
     *IT(40),H(100),F(84),C(1740),JN(160),IN(660),IR(76),               00082900
     *IH(48),B(645),CF(100),A(200),E(52),IS(76),IP(20),D(100)           00083000
C                                                                       00083100
C INTERPRET HKLF CARD                                                   00083200
C                                                                       00083300
      NA=ME                                                             00083400
      IK=0                                                              00083500
      KK=0                                                              00083600
      MR=0                                                              00083700
      MS=0                                                              00083800
      MN=0                                                              00083900
      QM=.6332574*C(1)*C(1)                                             00084000
      PL=SQRT(ABS(C(8)*C(27)*C(27)+C(9)*C(28)*C(28)+C(10)*C(29)*C(29)   00084100
     *+C(11)*C(28)*C(29)+C(12)*C(27)*C(29)+C(13)*C(27)*C(28)))          00084200
      NN=0                                                              00084300
      TA=0.                                                             00084400
      TB=999.                                                           00084500
      WT=1.                                                             00084600
      LQ=LH                                                             00084700
      IF(A(1).GT.0.)GOTO 1                                              00084800
      LQ=LR                                                             00084900
1     UM=A(13)                                                          00085000
      IF(NA-12)3,2,2                                                    00085100
2     WT=A(12)                                                          00085200
      NA=11                                                             00085300
3     A(12)=-999.                                                       00085400
      ME=IABS(INT(A(1)))                                                00085500
      IF(MIN0(ME,5-ME).LT.1)GOTO 106                                    00085600
      IF(NA-1)106,4,5                                                   00085700
4     A(2)=1.                                                           00085800
5     IF(ME.EQ.4)A(2)=100.*A(2)                                         00085900
      IF(2-NA)7,6,6                                                     00086000
6     A(3)=1.                                                           00086100
      A(7)=1.                                                           00086200
      A(11)=1.                                                          00086300
      NA=11                                                             00086400
7     WT=WT*A(2)                                                        00086500
      IF(NA.NE.11)GOTO 106                                              00086600
C                                                                       00086700
C FIND CORNERS                                                          00086800
C                                                                       00086900
      IF(0.0001.GT.C(26))GOTO 46                                        00087000
      IF(KF.LT.0)GOTO 15                                                00087100
      KS=0                                                              00087200
      N=39                                                              00087300
      I=-3                                                              00087400
8     I=I+4                                                             00087500
      IF(I.EQ.KF)GOTO 14                                                00087600
      J=I                                                               00087700
9     J=J+4                                                             00087800
      IF(J.EQ.KF)GOTO 8                                                 00087900
      Z=CF(I)*CF(J+1)-CF(I+1)*CF(J)                                     00088000
      Y=CF(I+2)*CF(J)-CF(I)*CF(J+2)                                     00088100
      X=CF(I+1)*CF(J+2)-CF(I+2)*CF(J+1)                                 00088200
      K=J                                                               00088300
10    K=K+4                                                             00088400
      IF(K.GT.KF)GOTO 9                                                 00088500
      Q=CF(K)*X+CF(K+1)*Y+CF(K+2)*Z                                     00088600
      IF(.0001.GT.ABS(Q))GOTO 10                                        00088700
      U=(CF(I+3)*(CF(J+1)*CF(K+2)-CF(J+2)*CF(K+1))+CF(J+3)*(CF(I+2)*    00088800
     *CF(K+1)-CF(I+1)*CF(K+2))+CF(K+3)*X)/Q                             00088900
      V=(CF(I+3)*(CF(J+2)*CF(K)-CF(J)*CF(K+2))+CF(J+3)*(CF(I)*CF(K+2)-  00089000
     *CF(I+2)*CF(K))+CF(K+3)*Y)/Q                                       00089100
      W=(CF(I+3)*(CF(J)*CF(K+1)-CF(J+1)*CF(K))+CF(J+3)*(CF(I+1)*CF(K)-  00089200
     *CF(I)*CF(K+1))+CF(K+3)*Z)/Q                                       00089300
C                                                                       00089400
C REJECT CORNERS                                                        00089500
C                                                                       00089600
      M=39                                                              00089700
11    M=M+3                                                             00089800
      IF(M.GT.N)GOTO 12                                                 00089900
      IF(ABS(U-A(M))+ABS(V-A(M+1))+ABS(W-A(M+2)).LT..00001)GOTO 10      00090000
      GOTO 11                                                           00090100
12    DO 13 M=1,KF,4                                                    00090200
      IF(.00001.LT.CF(M)*U+CF(M+1)*V+CF(M+2)*W-CF(M+3))GOTO 10          00090300
13    CONTINUE                                                          00090400
      N=N+3                                                             00090500
      IF(N.GT.155)GOTO 16                                               00090600
      A(N)=U                                                            00090700
      A(N+1)=V                                                          00090800
      A(N+2)=W                                                          00090900
      GOTO 10                                                           00091000
14    IF(N.GT.50)GOTO 17                                                00091100
15    IN(20)=-2                                                         00091200
      GOTO 107                                                          00091300
16    IN(20)=-9                                                         00091400
      GOTO 107                                                          00091500
C                                                                       00091600
C COUNT EDGES AND FIND LARGEST DEL(X)                                   00091700
C                                                                       00091800
17    T=-1.                                                             00091900
      L=0                                                               00092000
      DO 20 M=42,N,3                                                    00092100
      DO 20 I=M,N,3                                                     00092200
      K=0                                                               00092300
      U=0.5*(A(M)+A(I))                                                 00092400
      V=0.5*(A(M+1)+A(I+1))                                             00092500
      W=0.5*(A(M+2)+A(I+2))                                             00092600
      DO 18 J=1,KF,4                                                    00092700
18    IF(.00001.GT.ABS(CF(J)*U+CF(J+1)*V+CF(J+2)*W-CF(J+3)))K=K+1       00092800
      U=ABS(A(M)-A(I))                                                  00092900
      IF(T.GT.U)GOTO 19                                                 00093000
      XB=A(I)                                                           00093100
      XA=A(M)-XB                                                        00093200
      T=U                                                               00093300
19    IF(K.NE.2)GOTO 20                                                 00093400
      L=L+1                                                             00093500
      IF(L.GT.76)GOTO 16                                                00093600
      IR(L)=M                                                           00093700
      IS(L)=I                                                           00093800
20    CONTINUE                                                          00093900
      I=(KF+3)/4                                                        00094000
      J=(N-39)/3                                                        00094100
      WRITE(LI,21)IT,I,J,L                                              00094200
21    FORMAT(27H1ABSORPTION CORRECTION FOR ,40A1/                       00094300
     */I5,9H FACES  +,I4,11H CORNERS  =,I4,12H EDGES  +  2)             00094400
      IF(I+J-L.NE.2)GOTO 15                                             00094500
C                                                                       00094600
C SET UP GRID                                                           00094700
C                                                                       00094800
      KG=I+3                                                            00094900
      MX=LM-KG-LV-4028+(539*LU)                                         00095000
22    NG=1-KG                                                           00095100
      VO=0.                                                             00095200
      M=MIN0(8,MAX0(1,INT(.5+C(26)*C(53)*C(2)*T)))                      00095300
      NK=M*M-M+1                                                        00095400
      NN=M*M+M                                                          00095500
      DO 29 I=NK,NN                                                     00095600
      P=T*B(I+72)                                                       00095700
      X=XA*B(I)+XB                                                      00095800
      U=-1.                                                             00095900
      J=0                                                               00096000
23    J=J+1                                                             00096100
      IF(J.EQ.L)GOTO 25                                                 00096200
      NI=IR(J)                                                          00096300
      NJ=IS(J)                                                          00096400
      IF(0..GT.(A(NI)-X)*(X-A(NJ)))GOTO 23                              00096500
      Y=(A(NI+1)-A(NJ+1))*(X-A(NJ))/(A(NI)-A(NJ))+A(NJ+1)               00096600
      K=J                                                               00096700
24    K=K+1                                                             00096800
      IF(K.GT.L)GOTO 23                                                 00096900
      NI=IR(K)                                                          00097000
      NJ=IS(K)                                                          00097100
      IF(0..GT.(A(NI)-X)*(X-A(NJ)))GOTO 24                              00097200
      Z=(A(NI+1)-A(NJ+1))*(X-A(NJ))/(A(NI)-A(NJ))+A(NJ+1)               00097300
      W=ABS(Z-Y)                                                        00097400
      IF(U.GT.W)GOTO 24                                                 00097500
      U=W                                                               00097600
      YB=Z                                                              00097700
      YA=Y-Z                                                            00097800
      GOTO 24                                                           00097900
25    M=MIN0(8,MAX0(1,INT(.5+C(26)*C(53)*C(3)*U)))                      00098000
      NI=M*M-M+1                                                        00098100
      NJ=M*M+M                                                          00098200
      DO 29 J=NI,NJ                                                     00098300
      Q=P*U*B(J+72)                                                     00098400
      Y=YA*B(J)+YB                                                      00098500
      W=1.E9                                                            00098600
      V=-1.E9                                                           00098700
      DO 27 K=1,KF,4                                                    00098800
      IF(1.E-5.GT.ABS(CF(K+2)))GOTO 27                                  00098900
      Z=(CF(K+3)-CF(K)*X-CF(K+1)*Y)/CF(K+2)                             00099000
      DO 26 M=1,KF,4                                                    00099100
      IF(.00001.LT.CF(M)*X+CF(M+1)*Y+CF(M+2)*Z-CF(M+3))GOTO 27          00099200
26    CONTINUE                                                          00099300
      V=AMAX1(V,Z)                                                      00099400
      W=AMIN1(W,Z)                                                      00099500
27    CONTINUE                                                          00099600
      V=V-W                                                             00099700
      M=MIN0(8,MAX0(1,INT(.5+C(26)*C(53)*C(4)*V)))                      00099800
      NO=M*M-M+1                                                        00099900
      K=M*M+M                                                           00100000
      DO 29 M=NO,K                                                      00100100
      NG=NG+KG                                                          00100200
      IF(NG.LT.MX)GOTO 28                                               00100300
      C(26)=0.95*C(26)                                                  00100400
      KS=1                                                              00100500
      GOTO 22                                                           00100600
28    D(NG+2)=V*Q*C(32)*B(M+72)                                         00100700
      VO=VO+D(NG+2)*1000.                                               00100800
      Z=V*B(M)+W                                                        00100900
      NA=NG+3                                                           00101000
      DO 29 NT=1,KF,4                                                   00101100
      D(NA)=(CF(NT+3)-X*CF(NT)-Y*CF(NT+1)-Z*CF(NT+2))*C(53)             00101200
29    NA=NA+1                                                           00101300
      NG=NG+3                                                           00101400
      NO=(NG/KG)+1                                                      00101500
      IF(KS.NE.0)WRITE(LI,30)                                           00101600
30    FORMAT(/21H ** PRECISION REDUCED)                                 00101700
      DO 31 I=1,L                                                       00101800
      IR(I)=(IR(I)-39)/3                                                00101900
31    IS(I)=(IS(I)-39)/3                                                00102000
      WRITE(LI,32)NO,VO,C(53),(IR(I),IS(I),I=1,L)                       00102100
32    FORMAT(/I6,31H GRID POINTS,  CRYSTAL VOLUME =,F12.8,              00102200
     *13H MM**3,  MU =,F8.2,5H CM-1//6H EDGES,14(I5,1H-,I2))            00102300
C                                                                       00102400
C DRAW CRYSTAL                                                          00102500
C                                                                       00102600
      Z=SIN(.0174533*C(7))*HD                                           00102700
      A(169)=SQRT(19.73921/C(15))*HA                                    00102800
      A(174)=SQRT(19.73921/C(14))*HA                                    00102900
      A(172)=C(3)*C(17)*Z/C(20)                                         00103000
      A(177)=-C(2)*C(18)*Z/C(21)                                        00103100
      Z=C(4)*HD                                                         00103200
      A(173)=-Z*SIN(.0174533*C(6))                                      00103300
      A(179)=Z*SIN(.0174533*C(5))                                       00103400
      DO 33 I=156,165,3                                                 00103500
      A(I)=9.E8                                                         00103600
33    A(I+1)=-9.E8                                                      00103700
      DO 34 M=42,N,3                                                    00103800
      DO 34 J=156,165,3                                                 00103900
      Z=A(J+12)*A(M)+A(J+13)*A(M+1)+A(J+14)*A(M+2)                      00104000
      A(J)=AMIN1(A(J),Z)                                                00104100
34    A(J+1)=AMAX1(A(J+1),Z)                                            00104200
      W=9.E8                                                            00104300
      DO 35 J=156,165,3                                                 00104400
35    W=AMIN1(W,AINT(132./(A(J+1)-A(J))))                               00104500
      WRITE(LI,36)W                                                     00104600
36    FORMAT(/16X,11HVIEW DOWN X,15X,20HCRYSTAL MAGNIFIED BY,           00104700
     *F8.0,15X,11HVIEW DOWN Y)                                          00104800
      L=0                                                               00104900
      DO 39 M=42,N,3                                                    00105000
      DO 37 I=1,10,3                                                    00105100
37    IP(I)=INT(2.001+.3937*W*(A(I+167)*A(M)+A(I+168)*A(M+1)+           00105200
     *A(I+169)*A(M+2)-A(I+155)))                                        00105300
      IP(7)=IP(7)+64                                                    00105400
      J=1                                                               00105500
      K=7                                                               00105600
      DO 38 I=1,KF,4                                                    00105700
      IF(ABS(A(M)*CF(I)+A(M+1)*CF(I+1)+A(M+2)*CF(I+2)-                  00105800
     *CF(I+3)).GT.0.00001)GOTO 38                                       00105900
      IF(CF(I).GT.0.)IP(J)=-IABS(IP(J))                                 00106000
      IF(CF(I+1).GT.0.)IP(K)=-IABS(IP(K))                               00106100
38    CONTINUE                                                          00106200
      IR(L+1)=IP(1)                                                     00106300
      IS(L+1)=IP(4)                                                     00106400
      L=L+2                                                             00106500
      IR(L)=IP(7)                                                       00106600
39    IS(L)=IP(10)                                                      00106700
      DO 43 I=1,54                                                      00106800
      DO 40 J=1,121                                                     00106900
40    JN(J)=IH(48)                                                      00107000
      N=1                                                               00107100
      DO 42 J=1,L                                                       00107200
      IF(IS(J).NE.I)GOTO 42                                             00107300
      K=IABS(IR(J))                                                     00107400
      IF(JN(K).EQ.IH(13))GOTO 41                                        00107500
      M=(J+21)/20                                                       00107600
      JN(K+1)=IH(M)                                                     00107700
      M=1+MOD((J+1)/2,10)                                               00107800
      JN(K+2)=IH(M)                                                     00107900
      N=MAX0(N,K+2)                                                     00108000
      NA=IH(12)                                                         00108100
      IF(IR(J).LT.0)NA=IH(13)                                           00108200
41    IF(JN(K).NE.IH(48))NA=IH(11)                                      00108300
      JN(K)=NA                                                          00108400
42    CONTINUE                                                          00108500
43    WRITE(LI,44)(JN(J),J=1,N)                                         00108600
44    FORMAT(121A1)                                                     00108700
      IF(C(30).LT.0.)WRITE(LI,45)                                       00108800
45    FORMAT(41H1  H   K   L   TRANSMISSION   SINSQ THETA,16X,4HMU*T/)  00108900
C                                                                       00109000
C READ CONDENSED DATA                                                   00109100
C                                                                       00109200
46    IF(ME-2)49,59,63                                                  00109300
47    X=1.                                                              00109400
48    UM=UM+X*ABS(FLOAT(IP(NP)))                                        00109500
      UM=AINT(UM+SIGN(0.3,UM))                                          00109600
      GOTO 51                                                           00109700
49    READ(LQ,50)IP                                                     00109800
      KK=MOD(KK,99)+1                                                   00109900
50    FORMAT(20I4)                                                      00110000
      NP=0                                                              00110100
51    NP=NP+1                                                           00110200
      X=100.                                                            00110300
      IF(NP.GT.20)GOTO 49                                               00110400
      IK=MOD(IK+KK*IP(NP),10000)                                        00110500
      IF(IP(NP))47,52,55                                                00110600
52    IF(20.GT.NP)GOTO 53                                               00110700
      READ(LQ,50)IP                                                     00110800
      NP=0                                                              00110900
53    NP=NP+1                                                           00111000
      IF(IP(NP).EQ.0)GOTO 66                                            00111100
      IN(20)=-6                                                         00111200
      IF(IP(NP).NE.IK)GOTO 107                                          00111300
      IN(20)=0                                                          00111400
      WRITE(LI,54)                                                      00111500
54    FORMAT(/14H CHECKSUM O.K.)                                        00111600
      GOTO 66                                                           00111700
55    J=IP(NP)/1000                                                     00111800
      IF(J)47,48,56                                                     00111900
56    UM=UM+FLOAT(J)                                                    00112000
      I=MOD(IP(NP)/100,10)-5                                            00112100
      W=WT/SQRT(FLOAT(MOD(IP(NP),100))*(10.**I))                        00112200
      NP=NP+1                                                           00112300
      IF(20-NP)57,58,58                                                 00112400
57    READ(LQ,50)IP                                                     00112500
      KK=MOD(KK,99)+1                                                   00112600
      NP=1                                                              00112700
58    J=(IP(NP)/1000)-4                                                 00112800
      IK=MOD(IK+KK*IP(NP),10000)                                        00112900
      T=FLOAT(MOD(IP(NP),1000))*(10.**J)                                00113000
      CALL HKL(UM,U,V,Z)                                                00113100
      NI=U                                                              00113200
      NJ=V                                                              00113300
      NK=Z                                                              00113400
      GOTO 70                                                           00113500
C                                                                       00113600
C MDM DATA                                                              00113700
C                                                                       00113800
59    READ(LQ,60)IP                                                     00113900
60    FORMAT(5(3I3,I7))                                                 00114000
      NP=-3                                                             00114100
61    NP=NP+4                                                           00114200
      IF(NP.GT.20)GOTO 59                                               00114300
      NI=IP(NP)                                                         00114400
      NJ=IP(NP+1)                                                       00114500
      NK=IP(NP+2)                                                       00114600
      T=IP(NP+3)                                                        00114700
      W=0.                                                              00114800
      NN=0                                                              00114900
      GOTO 65                                                           00115000
62    MN=MN+1                                                           00115100
      IF(ME-2)51,61,63                                                  00115200
C                                                                       00115300
C READ H,K,L, F OR I, SIGMA, N, COSINES                                 00115400
C                                                                       00115500
63    READ(LQ,64)NI,NJ,NK,T,W,NN,(A(I),I=51,56)                         00115600
64    FORMAT(3I4,2F8.2,I4,6F8.5)                                        00115700
C                                                                       00115800
C TEST FOR END OF DATA (H=0, K=0, L=0)                                  00115900
C                                                                       00116000
65    IF(-IABS(NI)-IABS(NJ)-IABS(NK))68,66,66                           00116100
66    WRITE(LI,67)MN,MR                                                 00116200
67    FORMAT(/I6,26H REFLEXIONS READ, OF WHICH,I5,9H REJECTED/)         00116300
      GOTO 107                                                          00116400
68    IF(T-0.0001)87,69,69                                              00116500
69    W=W*WT                                                            00116600
      U=NI                                                              00116700
      V=NJ                                                              00116800
      Z=NK                                                              00116900
70    X=U*A(3)+V*A(4)+Z*A(5)                                            00117000
      Y=U*A(6)+V*A(7)+Z*A(8)                                            00117100
      Z=U*A(9)+V*A(10)+Z*A(11)                                          00117200
      V=T*A(2)                                                          00117300
C                                                                       00117400
C SYSTEMATIC ABSENCES                                                   00117500
C                                                                       00117600
      U=ABS(AMOD(X,.9999))+ABS(AMOD(Y,.9999))+ABS(AMOD(Z,.9999))        00117700
      IF(0.1-U)83,71,71                                                 00117800
71    U=X+Y                                                             00117900
      J=IN(18)                                                          00118000
      GOTO(78,74,72,75,76,73,77),J                                      00118100
72    IF(.1-ABS(AMOD(U+X+Z,2.9999)))83,78,78                            00118200
73    U=X+Z                                                             00118300
      GOTO 77                                                           00118400
74    U=U+Z                                                             00118500
      GOTO 77                                                           00118600
75    IF(0.1-ABS(AMOD(U,1.9999)))83,76,76                               00118700
76    U=Y+Z                                                             00118800
77    IF(0.1-ABS(AMOD(U,1.9999)))83,78,78                               00118900
78    U=-999999.                                                        00119000
      P=0.                                                              00119100
      R=0.                                                              00119200
      J=IN(1)                                                           00119300
      DO 82 I=61,J,12                                                   00119400
      Q=X*C(I+2)+Y*C(I+5)+Z*C(I+8)                                      00119500
      CQ=X*C(I+1)+Y*C(I+4)+Z*C(I+7)                                     00119600
      CT=X*C(I)+Y*C(I+3)+Z*C(I+6)                                       00119700
      IF(49.5-AMAX1(ABS(CT),ABS(CQ)))87,87,79                           00119800
79    Q=CT+100.*(CQ+100.*Q)                                             00119900
      Q=ABS(Q)*(1.-C(23))+Q*C(23)                                       00120000
      IF(Q-U+.01)82,80,80                                               00120100
80    P=P+1.                                                            00120200
      O=6.283185*(X*C(I+9)+Y*C(I+10)+Z*C(I+11))                         00120300
      O=COS(O)+100.*SIN(O)*C(23)                                        00120400
      R=R+O                                                             00120500
      IF(Q-U-0.01)82,81,81                                              00120600
81    P=1.                                                              00120700
      R=O                                                               00120800
      U=Q                                                               00120900
82    CONTINUE                                                          00121000
      IF(ABS(R)-.01)83,91,91                                            00121100
C                                                                       00121200
C ERRORS IN REFLECTION DATA                                             00121300
C                                                                       00121400
83    WRITE(LI,89)NI,NJ,NK,T                                            00121500
      GOTO 87                                                           00121600
84    WRITE(LI,88)NI,NJ,NK,T                                            00121700
      GOTO 86                                                           00121800
85    WRITE(LI,90)NI,NJ,NK,T                                            00121900
86    MS=MS+1                                                           00122000
87    MR=MR+1                                                           00122100
      IF(250-MS)106,106,62                                              00122200
88    FORMAT(3I4,F8.2,24H   BAD DIRECTION COSINES)                      00122300
89    FORMAT(3I4,F8.2,24H   SYSTEMATICALLY ABSENT)                      00122400
90    FORMAT(3I4,F8.2,29H   SIN THETA GREATER THAN ONE)                 00122500
C                                                                       00122600
C REFLECTION GEOMETRY AND L.P.                                          00122700
C                                                                       00122800
91    QS=C(14)*X*X+C(15)*Y*Y+C(16)*Z*Z+C(17)*Y*Z+C(18)*X*Z+C(19)*X*Y    00122900
      O=QS*QM                                                           00123000
      S=0.02*O                                                          00123100
      Q=1.-S                                                            00123200
      IF(Q)85,92,92                                                     00123300
92    K=O                                                               00123400
      O=AMOD(O,1.)                                                      00123500
      EE=EXP(0.05*QS)/SQRT((O*(E(K+2)-E(K+1))+E(K+1))*P)                00123600
      R=1.                                                              00123700
      CL=0.                                                             00123800
      IF(PL.LT.1.E-5)GOTO 94                                            00123900
      ST=SQRT(S)                                                        00124000
      CT=SQRT(Q)                                                        00124100
      CQ=C(1)/(PL*2.*ST)                                                00124200
      CL=C(27)*X+C(28)*Y+C(29)*Z                                        00124300
      CO=CQ*CL                                                          00124400
      SO=SQRT(ABS(1.-CO*CO))                                            00124500
      R=ST*CT*SO/(0.5-Q*S)                                              00124600
      IF(0.0001.GT.C(26))GOTO 94                                        00124700
C                                                                       00124800
C EQUI-INCLINATION DIRECTION COSINES                                    00124900
C                                                                       00125000
      A(32)=Z                                                           00125100
      A(33)=-Y                                                          00125200
      A(34)=-Z                                                          00125300
      A(36)=X                                                           00125400
      A(37)=Y                                                           00125500
      A(38)=-X                                                          00125600
      A(21)=X*C(14)+0.5*(Z*C(18)+Y*C(19))                               00125700
      A(22)=Y*C(15)+0.5*(X*C(19)+Z*C(17))                               00125800
      A(23)=Z*C(16)+0.5*(X*C(18)+Y*C(17))                               00125900
      K=51                                                              00126000
      DO 93 I=1,3                                                       00126100
      SP=SQRT(C(I+13))*.2250791                                         00126200
      P=C(1)*A(I+20)/(ST*SP*39.47842)                                   00126300
      O=SQRT(ABS(1.-P*P))                                               00126400
      CP=C(I+26)/(PL*SP)                                                00126500
      CP=(P*CO-CP)/AMAX1(.0001,SO*O)                                    00126600
      SP=SQRT(ABS(1.-CP*CP))                                            00126700
      SP=SIGN(O*CT*SP,1.E-6+C(8)*A(I+30)*C(27)+C(9)*A(I+33)*C(28)+      00126800
     *C(10)*A(I+36)*C(29)+0.5*(C(11)*(A(I+33)*C(29)+A(I+36)*C(28))+     00126900
     *C(12)*(A(I+30)*C(29)+A(I+36)*C(27))+C(13)*(A(I+30)*C(28)+         00127000
     *A(I+33)*C(27))))                                                  00127100
      CP=P*ST                                                           00127200
      A(K)=CP+SP                                                        00127300
      A(K+1)=CP-SP                                                      00127400
93    K=K+2                                                             00127500
C                                                                       00127600
C CHECK DIRECTION COSINES                                               00127700
C                                                                       00127800
94    Q=0.                                                              00127900
      IF(0.0001.GT.C(26))GOTO 102                                       00128000
      J=14                                                              00128100
      DO 95 I=51,55,2                                                   00128200
      CQ=SQRT(C(J))*.2250791                                            00128300
      A(I)=A(I)*CQ                                                      00128400
      A(I+1)=A(I+1)*CQ                                                  00128500
95    J=J+1                                                             00128600
      DO 96 I=27,28                                                     00128700
      A(I)=0.5*C(1)*(X*A(I+24)+Y*A(I+26)+Z*A(I+28))                     00128800
96    CONTINUE                                                          00128900
      IF(.001.LT.C(30)*AMAX1(ABS(A(27)-S),ABS(A(28)-S)))GOTO 84         00129000
C                                                                       00129100
C EVALUATE TRANSMISSION                                                 00129200
C                                                                       00129300
      DO 97 I=1,NG,KG                                                   00129400
      D(I)=1.E9                                                         00129500
97    D(I+1)=1.E9                                                       00129600
      DO 99 I=1,KF,4                                                    00129700
      DO 99 J=1,2                                                       00129800
      P=CF(I)*A(J+50)+CF(I+1)*A(J+52)+CF(I+2)*A(J+54)                   00129900
      IF(P.LT..0001)GOTO 99                                             00130000
      P=1./P                                                            00130100
      N=(I+15)/4                                                        00130200
      DO 98 M=J,NG,KG                                                   00130300
      D(M)=AMIN1(D(M),D(N)*P)                                           00130400
98    N=N+KG                                                            00130500
99    CONTINUE                                                          00130600
      T=0.                                                              00130700
      DO 100 I=1,NG,KG                                                  00130800
      X=AMIN1(15.656,D(I)+D(I+1))                                       00130900
      J=INT(32.*X)                                                      00131000
      Z=D(I+2)*B(J+145)*(.9999229-.9845223*(X-.03125*FLOAT(J)))         00131100
100   T=T+Z                                                             00131200
      T=T*1000./VO                                                      00131300
      TA=AMAX1(TA,T)                                                    00131400
      TB=AMIN1(TB,T)                                                    00131500
      R=R/T                                                             00131600
      Q=-ALOG(T)                                                        00131700
      IF(C(30).LT.0.)WRITE(LI,101)NI,NJ,NK,T,S,A(27),A(28),Q            00131800
101   FORMAT(3I4,4F10.6,F10.4)                                          00131900
C                                                                       00132000
C STORE F(OBS) DATA                                                     00132100
C                                                                       00132200
102   IF(ABS(CL-A(12)).GT.0.001)BN=BN+1000.                             00132300
103   P=BN                                                              00132400
      IF(NN.NE.0)P=FLOAT(1000*NN)                                       00132500
      A(12)=CL                                                          00132600
      IF(IABS(ME-3).NE.1)GOTO 104                                       00132700
      V=SQRT(V*R)                                                       00132800
      W=W*R/(V+V)                                                       00132900
104   IF(W.LT.0.)QS=QS+UT                                               00133000
      F(MF+2)=1.E-10                                                    00133100
      IF(ABS(W).GT.0.00001)F(MF+2)=W*W                                  00133200
      F(MF)=U                                                           00133300
      F(MF+1)=V                                                         00133400
      F(MF+3)=QS                                                        00133500
      F(MF+4)=P+AMIN1(EE*V,900.)                                        00133600
      F(MF+5)=-0.5*Q                                                    00133700
      MF=MF+6                                                           00133800
      IF(MF-LV)62,62,105                                                00133900
105   WRITE(LF)F                                                        00134000
      MF=1                                                              00134100
      GOTO 62                                                           00134200
106   IN(20)=-15                                                        00134300
      GOTO 109                                                          00134400
107   IF(0.0001.LT.C(26))WRITE(LI,108)TA,TB                             00134500
108   FORMAT(45H MAXIMUM AND MINIMUM TRANSMISSION FACTORS ARE,2F9.4/)   00134600
109   RETURN                                                            00134700
      END                                                               00134800
C                                                                       00134900
      SUBROUTINE SMERG                                                  00135000
      DIMENSION E(84)                                                   00135100
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,ME,MF,KZ,KF,BN,UT,  00135200
     *IT(40),H(100),F(84),B(100)                                        00135300
      IF(KF.LT.0)GOTO 94                                                00135400
      KM=LM-LV-151+(19*LU)                                              00135500
      MM=B(54)                                                          00135600
      MG=IABS(MM)                                                       00135700
      TQ=B(31)                                                          00135800
      SS=TQ*TQ                                                          00135900
      IF(-1.E-6.GT.TQ)SS=0.                                             00136000
      BN=B(55)*6.28319                                                  00136100
      SM=B(56)*6.28319                                                  00136200
      SP=B(57)*6.28319                                                  00136300
      SL=SQRT(B(25))*0.96                                               00136400
      IF(ME.EQ.0)GOTO 1                                                 00136500
      F(MF)=0.                                                          00136600
      WRITE(LF)F                                                        00136700
      ENDFILE LF                                                        00136800
      REWIND LF                                                         00136900
1     IF(MG-1)79,57,2                                                   00137000
C                                                                       00137100
C FIND H(MIN), H(MAX) ETC.                                              00137200
C                                                                       00137300
2     DO 3 I=4,6                                                        00137400
      B(I)=999.                                                         00137500
3     B(I+3)=-999.                                                      00137600
      W=0.                                                              00137700
4     READ(LF)F                                                         00137800
      DO 5 I=1,LV,6                                                     00137900
      IF(0.5.GT.ABS(F(I)))GOTO 6                                        00138000
      CALL HKL(F(I),B(1),B(2),B(3))                                     00138100
      W=AMAX1(W,F(I+4))                                                 00138200
      DO 5 J=1,3                                                        00138300
      B(J+3)=AMIN1(B(J+3),B(J))                                         00138400
5     B(J+6)=AMAX1(B(J+6),B(J))                                         00138500
      GOTO 4                                                            00138600
6     REWIND LF                                                         00138700
      IF(0.001.GT.W)GOTO 93                                             00138800
      HB=B(7)-B(4)+1.                                                   00138900
      GD=B(8)-B(5)+1.                                                   00139000
      HC=1.5-B(4)-HB*(B(5)+GD*B(6))                                     00139100
      N=INT(0.001*W)                                                    00139200
      NN=1                                                              00139300
      B(1)=1.                                                           00139400
      IF(MIN0(MG-1,N).LT.2)GOTO 37                                      00139500
      NN=N                                                              00139600
C                                                                       00139700
C LAYER SCALING SORT                                                    00139800
C                                                                       00139900
      NM=((NN+3)*NN)/2                                                  00140000
      GA=FLOAT(NM)+HC                                                   00140100
      NI=NM+1                                                           00140200
      IF(NI+1000.GT.KM)GOTO 16                                          00140300
      DO 7 I=1,NM                                                       00140400
7     B(I)=0.                                                           00140500
      ASSIGN 8 TO NQ                                                    00140600
8     M=KM                                                              00140700
      L=KM+1                                                            00140800
      DO 9 I=NI,KM                                                      00140900
9     B(I)=0.                                                           00141000
      NT=0                                                              00141100
10    READ(LF)F                                                         00141200
      DO 11 I=1,LV,6                                                    00141300
      IF(0.5.GT.ABS(F(I)))GOTO 12                                       00141400
      CALL HKL(F(I),X,Y,Z)                                              00141500
      N=INT(GA+X+HB*(Y+GD*Z))                                           00141600
      IF(N.LT.NI)GOTO 11                                                00141700
      NT=MAX0(N,NT)                                                     00141800
      IF(N.GT.M)GOTO 11                                                 00141900
      B(N)=B(N)+1.                                                      00142000
      IF(M.EQ.KM)GOTO 11                                                00142100
      N=B(N)                                                            00142200
      IF(N.LT.L)B(N)=ALOG(F(I+1))+100.*AINT(0.001*F(I+4))+30.           00142300
11    CONTINUE                                                          00142400
      GOTO 10                                                           00142500
12    REWIND LF                                                         00142600
      IF(M.NE.KM)GOTO 17                                                00142700
      K=NM                                                              00142800
13    K=K+1                                                             00142900
      I=B(K)                                                            00143000
      B(K)=L                                                            00143100
      IF(K+I.GT.M)GOTO 15                                               00143200
      IF(I.LT.2)GOTO 14                                                 00143300
      M=M-I                                                             00143400
      B(K)=M                                                            00143500
14    IF(NT.GT.K)GOTO 13                                                00143600
      ASSIGN 21 TO NQ                                                   00143700
      K=K+1                                                             00143800
15    NJ=M                                                              00143900
      M=K-1                                                             00144000
      GOTO 10                                                           00144100
16    LV=-16                                                            00144200
      GOTO 94                                                           00144300
C                                                                       00144400
C L.S. SUMS FOR SCALE FACTORS                                           00144500
C                                                                       00144600
17    GA=GA-FLOAT(K-NI)                                                 00144700
18    K=K-1                                                             00144800
      IF(NI.GT.K)GOTO NQ,(8,21)                                         00144900
      I=B(K)                                                            00145000
      IF(I.GT.KM)GOTO 18                                                00145100
      M=NJ+1                                                            00145200
      NJ=I                                                              00145300
      DO 20 I=M,NJ                                                      00145400
      X=AMOD(B(I),100.)                                                 00145500
      NL=INT(B(I)*0.01)                                                 00145600
      NT=((NN+NN-NL+3)*NL)/2                                            00145700
      N=I                                                               00145800
19    N=N+1                                                             00145900
      IF(N.GT.NJ)GOTO 20                                                00146000
      L=INT(B(N)*0.01)                                                  00146100
      IF(L.EQ.NL)GOTO 19                                                00146200
      Y=AMOD(B(N),100.)-X                                               00146300
      B(NL)=B(NL)+Y                                                     00146400
      B(L)=B(L)-Y                                                       00146500
      NK=MIN0(NL,L)                                                     00146600
      NK=(((NN+NN-NK-1)*NK)/2)+L+NL                                     00146700
      B(NK)=B(NK)-1.                                                    00146800
      NK=((NN+NN-L+3)*L)/2                                              00146900
      B(NK)=B(NK)+1.                                                    00147000
      B(NT)=B(NT)+1.                                                    00147100
      GOTO 19                                                           00147200
20    CONTINUE                                                          00147300
      GOTO 18                                                           00147400
C                                                                       00147500
C INVERT MATRIX                                                         00147600
C                                                                       00147700
21    J=NM                                                              00147800
      DO 22 I=1,NN                                                      00147900
      J=J+1                                                             00148000
22    B(J)=B(I)                                                         00148100
      K=0                                                               00148200
      J=NN+1                                                            00148300
      DO 26 NI=1,NN                                                     00148400
      K=K+2                                                             00148500
      I=J-1                                                             00148600
      M=J+1                                                             00148700
      B(J)=1./(B(J)+0.1)                                                00148800
      IF(NI-NN)23,26,26                                                 00148900
23    B(K)=-B(J)*B(M)                                                   00149000
      M=M+1                                                             00149100
      K=K+1                                                             00149200
      IF(K-J)23,25,25                                                   00149300
24    B(M)=B(J)*B(L)+B(M)                                               00149400
      M=M+1                                                             00149500
      L=L+1                                                             00149600
      IF(I-L)25,24,24                                                   00149700
25    L=J+NI-NN                                                         00149800
      J=J+1                                                             00149900
      IF(I-L)26,24,24                                                   00150000
26    CONTINUE                                                          00150100
      NI=NN-1                                                           00150200
27    NI=NI-1                                                           00150300
      J=K                                                               00150400
      M=K+NI-NN                                                         00150500
      L=M-1                                                             00150600
      I=M+1                                                             00150700
      K=I+NI-NN                                                         00150800
28    B(I)=0.                                                           00150900
      I=I+1                                                             00151000
      IF(I-J)28,29,29                                                   00151100
29    M=M+1                                                             00151200
      B(M)=B(K)*B(J)+B(M)                                               00151300
      I=M                                                               00151400
      NK=K+1                                                            00151500
      IF(L-NK)31,30,30                                                  00151600
30    J=J+1                                                             00151700
      I=I+1                                                             00151800
      B(I)=B(K)*B(J)+B(I)                                               00151900
      B(M)=B(NK)*B(J)+B(M)                                              00152000
      NK=NK+1                                                           00152100
      IF(L-NK)31,30,30                                                  00152200
31    B(NK)=B(K)*B(M)+B(NK)                                             00152300
      J=J+1                                                             00152400
      K=K+1                                                             00152500
      IF(L-K)32,29,29                                                   00152600
32    IF(-NI)27,33,33                                                   00152700
33    DO 34 I=1,NN                                                      00152800
34    B(I)=0.                                                           00152900
      L=NN+1                                                            00153000
      DO 36 I=1,NN                                                      00153100
      NM=NM+1                                                           00153200
      B(I)=B(I)-B(L)*B(NM)                                              00153300
      N=NM                                                              00153400
      DO 35 K=I,NN                                                      00153500
      B(I)=B(L)*B(N)+B(I)                                               00153600
      B(K)=B(L)*B(NM)+B(K)                                              00153700
      N=N+1                                                             00153800
35    L=L+1                                                             00153900
36    B(I)=EXP(B(I))                                                    00154000
C                                                                       00154100
C SORT/MERGE                                                            00154200
C                                                                       00154300
37    GA=FLOAT(NN)+HC                                                   00154400
      WRITE(LI,38)IT                                                    00154500
38    FORMAT(16H1SORT-MERGE FOR ,40A1)                                  00154600
      NI=NN+1                                                           00154700
      ASSIGN 41 TO NQ                                                   00154800
      NE=-5                                                             00154900
      R=0.                                                              00155000
      S=0.                                                              00155100
      NM=0                                                              00155200
      IF(MG.GT.2)WRITE(LI,39)(B(I),I=1,NN)                              00155300
39    FORMAT(//26H INTER-LAYER SCALE FACTORS//(10F12.4))                00155400
      WRITE(LI,40)                                                      00155500
40    FORMAT(//16H INCONSISTENCIES//                                    00155600
     *33H   H   K   L   ESD/F  SIGMA/F   N/)                            00155700
41    DO 42 J=NI,KM                                                     00155800
42    B(J)=0.                                                           00155900
      NT=0                                                              00156000
      M=KM                                                              00156100
43    READ(LF)F                                                         00156200
      DO 45 I=1,LV,6                                                    00156300
      IF(0.5.GT.ABS(F(I)))GOTO 46                                       00156400
      CALL HKL(F(I),X,Y,Z)                                              00156500
      N=INT(GA+X+HB*(Y+GD*Z))                                           00156600
      IF(N.LT.NI)GOTO 45                                                00156700
      IF(N.GT.M)GOTO 45                                                 00156800
      IF(M.EQ.KM)GOTO 44                                                00156900
      N=B(N)                                                            00157000
      L=1                                                               00157100
      IF(MG.GT.2)L=INT(0.001*F(I+4))                                    00157200
      V=F(I+1)*B(L)                                                     00157300
      W=1./(F(I+2)*B(L)*B(L))                                           00157400
      B(N+1)=B(N+1)+V*W                                                 00157500
      B(N+2)=B(N+2)+W                                                   00157600
      B(N+3)=AMOD(F(I+3),UT)                                            00157700
      B(N+4)=B(N+4)+AMOD(F(I+4),1000.)*W*B(L)                           00157800
      B(N+5)=B(N+5)+F(I+5)*W                                            00157900
      B(N+6)=B(N+6)+V*V*W                                               00158000
      B(N+7)=F(I)                                                       00158100
44    B(N)=B(N)+1000.                                                   00158200
45    NT=MAX0(N,NT)                                                     00158300
      GOTO 43                                                           00158400
46    REWIND LF                                                         00158500
      IF(M.NE.KM)GOTO 51                                                00158600
      K=NN                                                              00158700
47    K=K+1                                                             00158800
      IF(K+10.GT.M)GOTO 49                                              00158900
      IF(B(K).LT.1.)GOTO 48                                             00159000
      M=M-8                                                             00159100
      B(K)=M+1                                                          00159200
48    IF(NT.GT.K)GOTO 47                                                00159300
      ASSIGN 55 TO NQ                                                   00159400
      K=K+1                                                             00159500
49    DO 50 I=K,KM                                                      00159600
50    B(I)=0.                                                           00159700
      M=K-1                                                             00159800
      GOTO 43                                                           00159900
C                                                                       00160000
C R-INDEX AND INCONSISTENCIES                                           00160100
C                                                                       00160200
51    GA=GA-FLOAT(K-NI)                                                 00160300
      K=K-1                                                             00160400
      DO 53 J=NI,K                                                      00160500
      M=B(J)                                                            00160600
      IF(M.EQ.0)GOTO 53                                                 00160700
      NE=NE+6                                                           00160800
      E(NE)=B(M+7)                                                      00160900
      W=1./B(M+2)                                                       00161000
      E(NE+1)=B(M+1)*W                                                  00161100
      E(NE+2)=W                                                         00161200
      E(NE+3)=B(M+3)                                                    00161300
      E(NE+4)=B(M)+AMIN1(900.,B(M+4)*W)                                 00161400
      E(NE+5)=B(M+5)*W                                                  00161500
      IF(NE.LT.LV)GOTO 52                                               00161600
      WRITE(LA)E                                                        00161700
      NE=-5                                                             00161800
52    NM=NM+1                                                           00161900
      IF(1500..GT.B(M))GOTO 53                                          00162000
      IF(1.E-8.GT.B(M+1))GOTO 53                                        00162100
      X=B(M+2)*B(M+6)                                                   00162200
      Y=B(M+1)*B(M+1)                                                   00162300
      S=S+W*X*(B(M)-1000.)                                              00162400
      R=R+W*B(M)*(X-Y)                                                  00162500
      IF(1.04*Y.GT.X)GOTO 53                                            00162600
      U=1./(SQRT(W)*B(M+1))                                             00162700
      W=SQRT(ABS(X/Y-1.))                                               00162800
      N=INT(0.001*B(M)+0.1)                                             00162900
      CALL HKL(B(M+7),X,Y,Z)                                            00163000
      I=X                                                               00163100
      L=Y                                                               00163200
      M=Z                                                               00163300
      IF(W.GT.U+U)WRITE(LI,54)I,L,M,W,U,N                               00163400
53    CONTINUE                                                          00163500
54    FORMAT(3I4,2F8.3,I5)                                              00163600
      GOTO NQ,(41,55)                                                   00163700
55    E(NE+6)=0.                                                        00163800
      WRITE(LA)E                                                        00163900
      T=0.                                                              00164000
      IF(S.NE.0.)T=SQRT(ABS(R/S))                                       00164100
      WRITE(LI,56)NM,T                                                  00164200
56    FORMAT(//I7,23H UNIQUE REFLEXIONS, R =,F8.4)                      00164300
      GOTO 60                                                           00164400
57    READ(LF)F                                                         00164500
      WRITE(LA)F                                                        00164600
      DO 58 I=1,LV,6                                                    00164700
      IF(0.5.GT.ABS(F(I)))GOTO 59                                       00164800
58    CONTINUE                                                          00164900
      GOTO 57                                                           00165000
59    REWIND LF                                                         00165100
60    ENDFILE LA                                                        00165200
      REWIND LA                                                         00165300
C                                                                       00165400
C NORMALISE E-VALUES                                                    00165500
C                                                                       00165600
      IF(MM.LT.0)WRITE(LI,61)                                           00165700
61    FORMAT(//1X,4(5X,25HH  K  L     F   SIG(F)  N)/)                  00165800
      L=0                                                               00165900
      DO 62 I=1,64                                                      00166000
      B(I)=0.                                                           00166100
62    E(I)=0.                                                           00166200
      DO 77 M=1,2                                                       00166300
63    READ(LA)F                                                         00166400
      I=-5                                                              00166500
64    I=I+6                                                             00166600
      IF(0.5.GT.ABS(F(I)))GOTO 72                                       00166700
      X=1.+SQRT(2.584724*AMOD(F(I+3),UT))                               00166800
      K=MIN0(14,INT(X))                                                 00166900
      T=AMIN1(X-FLOAT(K),1.)                                            00167000
      W=AMOD(F(I+4),1000.)                                              00167100
      P=1.-T                                                            00167200
      IF(M.GT.1)GOTO 65                                                 00167300
      B(K)=B(K)+P*W*W                                                   00167400
      B(K+1)=B(K+1)+T*W*W                                               00167500
      B(K+15)=B(K+15)+P                                                 00167600
      B(K+16)=B(K+16)+T                                                 00167700
      GOTO 69                                                           00167800
65    W=W*(P*B(K+30)+T*B(K+31))                                         00167900
      N=INT(0.001*F(I+4))                                               00168000
      F(I+4)=AMIN1(W,9.0)                                               00168100
      IF(MG.LT.2)F(I+4)=F(I+4)+FLOAT(1000*N)                            00168200
      F(I+3)=AMOD(F(I+3),UT)                                            00168300
      IF(SS.GT.1.E9)GOTO 66                                             00168400
      IF(F(I+2)*SS.GT.F(I+1)*F(I+1))N=-N                                00168500
66    F(I+1)=F(I+1)*Q                                                   00168600
      F(I+2)=F(I+2)*Q*Q                                                 00168700
      IF(TQ.LT.-1.E-6)F(I+2)=TQ*TQ                                      00168800
      V=ABS(1.-W*W)                                                     00168900
      B(K)=B(K)+P*V/AMAX1(B(K+15),0.01)                                 00169000
      B(K+1)=B(K+1)+T*V/AMAX1(B(K+16),0.01)                             00169100
      CALL HKL(F(I),X,Y,Z)                                              00169200
      IF(L.LT.4)GOTO 68                                                 00169300
      IF(MM.LT.0)WRITE(LI,67)(IT(K),IT(K+4),IT(K+8),B(K+45),            00169400
     *B(K+49),IT(K+12),K=1,4)                                           00169500
67    FORMAT(1X,4(I6,2I3,F8.2,F6.2,I4))                                 00169600
      L=0                                                               00169700
68    L=L+1                                                             00169800
      IT(L)=X                                                           00169900
      IT(L+4)=Y                                                         00170000
      IT(L+8)=Z                                                         00170100
      IT(L+12)=N                                                        00170200
      B(L+45)=F(I+1)                                                    00170300
      B(L+49)=SQRT(F(I+2))                                              00170400
69    IF(I.LT.LV)GOTO 64                                                00170500
      IF(M.EQ.2)WRITE(LF)F                                              00170600
      GOTO 63                                                           00170700
70    FORMAT(18H SIN(THETA)/LAMBDA,F5.2,14F7.2//10H R.M.S.(E),6X,15F7.3)00170800
71    FORMAT(/16H MEAN ABS(E*E-1),15F7.3//16H EFFECTIVE N    ,15F7.1/)  00170900
72    IF(M.EQ.2)GOTO 77                                                 00171000
      Q=1.                                                              00171100
      U=0.                                                              00171200
      DO 75 J=1,10                                                      00171300
      DO 73 I=1,8                                                       00171400
73    E(I)=0.                                                           00171500
      DO 74 I=1,15                                                      00171600
      X=E(8)*E(8)                                                       00171700
      P=EXP(X*U)*B(I)                                                   00171800
      V=P/AMAX1(1.E-5,B(I+15))                                          00171900
      W=P*Q                                                             00172000
      Z=B(I+15)-W                                                       00172100
      E(1)=E(1)+V*P                                                     00172200
      W=W*X                                                             00172300
      E(2)=E(2)+V*W                                                     00172400
      P=Q*X                                                             00172500
      E(3)=E(3)+V*W*P                                                   00172600
      E(4)=E(4)+Z*V                                                     00172700
      E(5)=E(5)+Z*V*P                                                   00172800
      E(6)=E(6)+B(I)                                                    00172900
      E(7)=E(7)+B(I+15)                                                 00173000
74    E(8)=E(8)+.622004                                                 00173100
      X=1./(0.1+E(1))                                                   00173200
      W=-X*E(2)                                                         00173300
      Z=1./(0.1+E(3)+W*E(2))                                            00173400
      Y=Z*W                                                             00173500
      X=X+W*Y                                                           00173600
      U=U+E(4)*Y+E(5)*Z                                                 00173700
      IF(ABS(U).LT.0.1)GOTO 75                                          00173800
      U=SIGN(0.09999,U)                                                 00173900
      X=0.                                                              00174000
      Y=1./(0.1+E(3))                                                   00174100
75    Q=Q+E(4)*X+E(5)*Y                                                 00174200
      Q=ABS(Q)  !!!!!!!!!!!!!!!!!!!! LIGNE RAJOUTEE !!!!!!!!!!!!!!!!!!!!!!
      Q=SQRT(Q)*SL                                                      00174300
      U=0.05-0.5*U                                                      00174400
      X=0.0001                                                          00174500
      DO 76 I=1,15                                                      00174600
      B(I+30)=SQRT((B(I+15)+0.01*E(7))/(B(I)+0.01*E(6)))                00174700
      E(I+15)=B(I+30)*SQRT(B(I)/AMAX1(B(I+15),0.0001))+0.00001          00174800
      B(I)=0.00001                                                      00174900
      E(I)=X                                                            00175000
76    X=X+0.07                                                          00175100
77    REWIND LA                                                         00175200
      IF(MM.LT.0)WRITE(LI,67)(IT(K),IT(K+4),IT(K+8),B(K+45),B(K+49),    00175300
     *IT(K+12),K=1,L)                                                   00175400
      WRITE(LF)F                                                        00175500
      ENDFILE LF                                                        00175600
      REWIND LF                                                         00175700
78    FORMAT(//14H OVERALL SCALE,F12.5,10X,13HESTIMATED U =,F6.3//)     00175800
      WRITE(LI,78)Q,U                                                   00175900
      WRITE(LI,70)(E(I),I=1,30)                                         00176000
      WRITE(LI,71)(B(I),I=1,30)                                         00176100
C                                                                       00176200
C EDIT AND RENORMALISE                                                  00176300
C                                                                       00176400
79    N=0                                                               00176500
      M=0                                                               00176600
      DO 80 I=1,16                                                      00176700
      B(I)=0.                                                           00176800
80    E(I)=0.                                                           00176900
      R=ABS(BN)+ABS(SM)+ABS(SP)                                         00177000
      IF(R.GT.1.E-6)GOTO 81                                             00177100
      IF(KZ.GT.0)GOTO 81                                                00177200
      IF(SS.GT.1.E9)GOTO 94                                             00177300
81    READ(LF)F                                                         00177400
      WRITE(LA)F                                                        00177500
      DO 82 I=1,LV,6                                                    00177600
      IF(0.5.GT.ABS(F(I)))GOTO 83                                       00177700
      IF(R.LT.1.E-6)GOTO 82                                             00177800
      Q=AMOD(F(I+4),1000.)                                              00177900
      Q=Q*Q                                                             00178000
      CALL HKL(F(I),X,Y,Z)                                              00178100
      P=COS(X*BN+Y*SM+Z*SP)*4.99+6.                                     00178200
      K=INT(P)                                                          00178300
      P=P-FLOAT(K)                                                      00178400
      Z=1.-P                                                            00178500
      B(K)=B(K)+Q*Z                                                     00178600
      E(K)=E(K)+Z                                                       00178700
      B(K+1)=B(K+1)+Q*P                                                 00178800
      E(K+1)=E(K+1)+P                                                   00178900
82    N=N+1                                                             00179000
      GOTO 81                                                           00179100
83    REWIND LF                                                         00179200
      ENDFILE LA                                                        00179300
      REWIND LA                                                         00179400
      IF(R.LT.1.E-6)GOTO 86                                             00179500
      S=-1.                                                             00179600
      DO 84 I=1,11                                                      00179700
      W=1./AMAX1(0.001,E(I))                                            00179800
      P=B(I)*S                                                          00179900
      E(12)=E(12)+W*B(I)*B(I)                                           00180000
      E(13)=E(13)+W*B(I)*P                                              00180100
      E(14)=E(14)+W*P*P                                                 00180200
      E(15)=E(15)+B(I)                                                  00180300
      E(16)=E(16)+P                                                     00180400
84    S=S+0.2                                                           00180500
      P=1./AMAX1(0.01,E(12)*E(14)-E(13)*E(13))                          00180600
      S=P*(E(15)*E(14)-E(13)*E(16))                                     00180700
      T=P*(E(12)*E(16)-E(13)*E(15))                                     00180800
      X=BN*.159155                                                      00180900
      Y=SM*.159155                                                      00181000
      Z=SP*.159155                                                      00181100
      WRITE(LI,85)S,T,X,Y,Z                                             00181200
85    FORMAT(//24H NEW E*E = (OLD E*E) * (,F7.4,2H +,F7.4,              00181300
     *12H*COS( 2*PI*(,F7.4,4H*H +,F7.4,4H*K +,F7.4,8H*L ) ) ))          00181400
86    READ(LA)F                                                         00181500
      DO 90 I=1,LV,6                                                    00181600
      IF(0.5.GT.ABS(F(I)))GOTO 91                                       00181700
      X=0.                                                              00181800
      J=0                                                               00181900
87    J=J+1                                                             00182000
      IF(J.GT.KZ)GOTO 88                                                00182100
      IF(0.5.GT.ABS(F(I)-H(J)))X=1.1                                    00182200
      GOTO 87                                                           00182300
88    IF(SS.GT.1.E9)GOTO 89                                             00182400
      IF(SS*F(I+2).GT.F(I+1)*F(I+1))X=1.1                               00182500
89    M=M+INT(X)                                                        00182600
      IF(R.LT.1.E-6)GOTO 90                                             00182700
      CALL HKL(F(I),P,Y,Z)                                              00182800
      F(I+4)=F(I+4)+AMOD(F(I+4),1000.)*(SQRT(ABS(S+T*                   00182900
     *COS(P*BN+Y*SM+Z*SP)))-1.)                                         00183000
90    F(I+3)=AMOD(F(I+3),UT)+UT*AINT(X)                                 00183100
      WRITE(LF)F                                                        00183200
      GOTO 86                                                           00183300
91    WRITE(LF)F                                                        00183400
      ENDFILE LF                                                        00183500
92    FORMAT(///I6,30H REFLECTIONS SUPPRESSED OUT OF,I6)                00183600
      WRITE(LI,92)M,N                                                   00183700
      REWIND LF                                                         00183800
      REWIND LA                                                         00183900
      GOTO 94                                                           00184000
93    LV=-17                                                            00184100
94    RETURN                                                            00184200
      END                                                               00184300
C                                                                       00184400
      SUBROUTINE ATFIX                                                  00184500
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS, 00184600
     *NP,KH,NA,NH,R,SF,DA,IT(40),JN(160),IN(660),C(1740),ID(800),IX(480)00184700
     *,E(410),A(410),H(800),D(1600),F(84),DX(480),G(141),ES(800),B(100) 00184800
      READ(LB)IT,JN,IN,C                                                00184900
      REWIND LB                                                         00185000
      IF(LV.LT.0)IN(20)=LV                                              00185100
      IF(IN(20))59,1,1                                                  00185200
1     X=0.                                                              00185300
      DO 2 I=1,126                                                      00185400
      G(I)=SIN(X)                                                       00185500
2     X=X+6.283185E-2                                                   00185600
      B(1)=C(4)/C(3)                                                    00185700
      B(2)=C(2)/C(4)                                                    00185800
      B(3)=C(3)/C(2)                                                    00185900
      DO 3 J=1,3                                                        00186000
      Y=.0174533*C(J+4)                                                 00186100
      Z=1./SIN(Y)                                                       00186200
      B(J+6)=C(J+16)/C(J+19)                                            00186300
      G(J+126)=COS(Y)*Z                                                 00186400
      G(J+129)=B(J)*Z                                                   00186500
3     G(J+132)=Z/B(J)                                                   00186600
      G(136)=B(9)*G(130)/G(134)                                         00186700
      G(139)=B(8)*G(133)/G(132)                                         00186800
      G(137)=B(7)*G(131)/G(135)                                         00186900
      G(140)=B(9)*G(134)/G(130)                                         00187000
      G(138)=B(8)*G(132)/G(133)                                         00187100
      G(141)=B(7)*G(135)/G(131)                                         00187200
      NS=IN(1)+12                                                       00187300
      NE=IN(4)+1                                                        00187400
      SF=AINT(1.99-0.01*C(NE))                                          00187500
      NP=IN(4)-IN(3)-7                                                  00187600
      NC=0                                                              00187700
      NV=IABS(IN(13))                                                   00187800
      IF(IN(13).LT.-998)NV=-1                                           00187900
      DO 4 J=1,410                                                      00188000
4     A(J)=0.                                                           00188100
C                                                                       00188200
C ATOM CO-ORDINATES                                                     00188300
C                                                                       00188400
      JI=0                                                              00188500
      N=-2                                                              00188600
      M=-2                                                              00188700
      K=IN(5)+1                                                         00188800
      I=17                                                              00188900
5     I=I+4                                                             00189000
      IF(I.GT.IN(6))GOTO 30                                             00189100
      IF(JI.NE.8)GOTO 6                                                 00189200
      IF(IN(I+1).LT.80)N=-2                                             00189300
6     JI=IN(I+1)/10                                                     00189400
      DO 8 J=1,3                                                        00189500
      L=MAX0(1,INT(ABS(C(K)*0.1)+0.5))+NE                               00189600
      IF(IN(5)-L)58,7,7                                                 00189700
7     R=SIGN(0.5,C(K)+5.)                                               00189800
      NJ=J+N+2                                                          00189900
      IF(JI.EQ.8)C(K)=H(NJ)+C(50)*(H(NJ)-B(J))/Q                        00190000
      H(NJ)=(AMOD(C(K)+5.,10.)-10.*R)*(R+AMOD(C(L)+5.,10.)-5.5)         00190100
8     K=K+1                                                             00190200
      K=K-3                                                             00190300
      IF(JI.EQ.8)GOTO 26                                                00190400
C                                                                       00190500
C BENZENE AND CYCLOPENTADIENIDE RINGS                                   00190600
C                                                                       00190700
      NI=12                                                             00190800
      IF(JI-5)27,10,9                                                   00190900
9     NI=16                                                             00191000
10    N=N+3                                                             00191100
      IX(N)=K                                                           00191200
      IF(NI-N)11,13,29                                                  00191300
11    DO 12 J=1,3                                                       00191400
12    B(J)=.2*(H(J)+H(J+3)+H(J+6)+H(J+9)+H(J+12))                       00191500
      Q=C(51)*.8506508                                                  00191600
      NX=3                                                              00191700
      NI=13                                                             00191800
      GOTO 18                                                           00191900
13    DO 14 J=1,3                                                       00192000
14    B(J)=.3333333*(H(J)+H(J+6)+H(J+12))                               00192100
      Q=C(52)                                                           00192200
      NX=6                                                              00192300
      IF(JI-6)18,15,18                                                  00192400
15    DO 16 J=1,3                                                       00192500
16    B(J)=0.5*B(J)+.1666667*(H(J+3)+H(J+9)+H(J+15))                    00192600
      DO 17 J=1,3                                                       00192700
      H(J)=0.5*(H(J)-H(J+9))+B(J)                                       00192800
      H(J+6)=0.5*(H(J+6)-H(J+15))+B(J)                                  00192900
17    H(J+12)=0.5*(H(J+12)-H(J+3))+B(J)                                 00193000
18    L=1                                                               00193100
      DO 21 J=1,100                                                     00193200
      DO 19 NT=1,3                                                      00193300
      NJ=MOD(L+5,NI+2)+1                                                00193400
      NL=MOD(L+5+NX,NI+2)+1                                             00193500
      B(NT+3)=B(NT)-0.5*(H(NJ)+H(NL))                                   00193600
19    L=L+1                                                             00193700
      R=Q/SQRT(C(8)*B(4)*B(4)+C(9)*B(5)*B(5)+C(10)*B(6)*B(6)            00193800
     *+C(11)*B(5)*B(6)+C(12)*B(4)*B(6)+C(13)*B(4)*B(5))                 00193900
      L=MOD(L-4,NI+2)+1                                                 00194000
      DO 20 NT=1,3                                                      00194100
      H(L)=B(NT)+R*B(NT+3)                                              00194200
20    L=L+1                                                             00194300
21    L=MOD(L+NX-4,NI+2)+1                                              00194400
      IF(NI-15)24,24,22                                                 00194500
22    DO 23 J=1,3                                                       00194600
      H(J+3)=B(J)+B(J)-H(J+12)                                          00194700
      H(J+9)=B(J)+B(J)-H(J)                                             00194800
23    H(J+15)=B(J)+B(J)-H(J+6)                                          00194900
24    I=I-(4*NI+8)/3                                                    00195000
      DO 25 J=1,NI,3                                                    00195100
      L=IX(J)                                                           00195200
      M=M+3                                                             00195300
      I=I+4                                                             00195400
      ID(I)=M                                                           00195500
      D(M)=H(J)                                                         00195600
      D(M+1)=H(J+1)                                                     00195700
      D(M+2)=H(J+2)                                                     00195800
      C(L)=H(J)                                                         00195900
      C(L+1)=H(J+1)                                                     00196000
25    C(L+2)=H(J+2)                                                     00196100
      N=-2                                                              00196200
      GOTO 29                                                           00196300
26    IF(NI.LT.13)GOTO 58                                               00196400
      N=N+3                                                             00196500
      IF(NI-N)58,29,29                                                  00196600
C                                                                       00196700
C FREE ATOMS                                                            00196800
C                                                                       00196900
27    IF(JI)58,28,29                                                    00197000
28    M=M+3                                                             00197100
      D(M)=H(N+3)                                                       00197200
      D(M+1)=H(N+4)                                                     00197300
      D(M+2)=H(N+5)                                                     00197400
29    ID(I)=M                                                           00197500
      K=K+IN(I)                                                         00197600
      GOTO 5                                                            00197700
C                                                                       00197800
C HYDROGEN ATOMS                                                        00197900
C                                                                       00198000
30    K=IN(5)+1                                                         00198100
      I=17                                                              00198200
      H(1)=-1.                                                          00198300
      NQ=0                                                              00198400
      KH=0                                                              00198500
31    I=I+4                                                             00198600
      IF(IN(6)-I)59,32,32                                               00198700
32    N=(IN(I+1)/10)                                                    00198800
      KH=MAX0(IN(I+3),KH)                                               00198900
      NK=ID(I)                                                          00199000
      IF((5-N)*N)52,52,33                                               00199100
33    IF(NQ-5)34,57,57                                                  00199200
34    L=-2                                                              00199300
      NI=1                                                              00199400
      IF(NK)58,58,35                                                    00199500
35    L=L+3                                                             00199600
      IF(M-L)41,36,36                                                   00199700
36    X=D(L)-D(NK)                                                      00199800
      Y=D(L+1)-D(NK+1)                                                  00199900
      Z=D(L+2)-D(NK+2)                                                  00200000
      R=X*X*C(8)+Y*Y*C(9)+Z*Z*C(10)+Y*Z*C(11)+X*Z*C(12)+X*Y*C(13)       00200100
      R=SQRT(R)                                                         00200200
      NJ=NI+4                                                           00200300
      NL=NJ                                                             00200400
37    NJ=NJ-4                                                           00200500
      IF(R-H(NJ))37,39,39                                               00200600
38    H(NL+7)=H(NL+3)                                                   00200700
      H(NL+6)=H(NL+2)                                                   00200800
      H(NL+5)=H(NL+1)                                                   00200900
      H(NL+4)=H(NL)                                                     00201000
39    NL=NL-4                                                           00201100
      IF(NJ-NL)38,40,40                                                 00201200
40    H(NJ+4)=R                                                         00201300
      H(NJ+5)=X                                                         00201400
      H(NJ+6)=Y                                                         00201500
      H(NJ+7)=Z                                                         00201600
      NI=MIN0(NI+4,21)                                                  00201700
      GOTO 35                                                           00201800
41    Q=C(50)                                                           00201900
      NL=17                                                             00202000
      GOTO(45,43,42,44),N                                               00202100
42    Q=Q*.3333333                                                      00202200
      NL=9                                                              00202300
      IF(NI-13)58,45,45                                                 00202400
43    Q=Q*.5773503                                                      00202500
C                                                                       00202600
C C-H                                                                   00202700
C                                                                       00202800
44    NL=13                                                             00202900
45    IF(NL-NI)46,46,58                                                 00203000
46    ND=K+2                                                            00203100
      DO 47 J=1,3                                                       00203200
      B(J)=0.                                                           00203300
      DO 47 NJ=9,NL,4                                                   00203400
      NT=J+NJ                                                           00203500
47    B(J)=B(J)-H(NT)/AMAX1(H(NJ),0.01)                                 00203600
      Q=Q/(1.E-8+SQRT(B(1)*B(1)*C(8)+B(2)*B(2)*C(9)+                    00203700
     *B(3)*B(3)*C(10)+B(2)*B(3)*C(11)+B(1)*B(3)*C(12)+B(1)*B(2)*C(13))) 00203800
      NT=1                                                              00203900
      DO 48 J=K,ND                                                      00204000
      C(J)=D(NK)+Q*B(NT)                                                00204100
      NK=NK+1                                                           00204200
48    NT=NT+1                                                           00204300
      GOTO(52,49,49,52),N                                               00204400
C                                                                       00204500
C CH2                                                                   00204600
C                                                                       00204700
49    X=H(11)*H(16)-H(15)*H(12)                                         00204800
      Y=H(12)*H(14)-H(10)*H(16)                                         00204900
      Z=H(10)*H(15)-H(11)*H(14)                                         00205000
      B(5)=C(14)*X+0.5*(C(19)*Y+C(18)*Z)                                00205100
      B(6)=C(15)*Y+0.5*(C(17)*Z+C(19)*X)                                00205200
      B(7)=C(16)*Z+0.5*(C(18)*X+C(17)*Y)                                00205300
      B(4)=C(50)*.8164966/(1.E-8+SQRT(B(5)*B(5)*C(8)+B(6)*B(6)*C(9)+    00205400
     *B(7)*B(7)*C(10)+B(6)*B(7)*C(11)+B(5)*B(7)*C(12)+B(5)*B(6)*C(13))) 00205500
      GOTO(58,50,53,55),N                                               00205600
50    L=K                                                               00205700
      DO 51 J=5,7                                                       00205800
      H(J)=C(L)+B(J)*B(4)                                               00205900
      C(L)=C(L)-B(J)*B(4)                                               00206000
51    L=L+1                                                             00206100
      NQ=5                                                              00206200
52    K=K+IN(I)                                                         00206300
      GOTO 31                                                           00206400
C                                                                       00206500
C CH3                                                                   00206600
C                                                                       00206700
53    N=4                                                               00206800
      DO 54 J=4,7                                                       00206900
54    H(J+9)=B(J)                                                       00207000
      GOTO 49                                                           00207100
55    NQ=8                                                              00207200
      L=K                                                               00207300
      DO 56 J=5,7                                                       00207400
      H(J)=C(L)-.5773503*B(4)*B(J)+H(13)*H(J+9)                         00207500
      H(J+3)=H(J)-2.*H(13)*H(J+9)                                       00207600
      C(L)=C(L)+1.154701*B(4)*B(J)                                      00207700
56    L=L+1                                                             00207800
      GOTO 52                                                           00207900
57    C(K)=H(NQ)                                                        00208000
      C(K+1)=H(NQ+1)                                                    00208100
      C(K+2)=H(NQ+2)                                                    00208200
      NQ=NQ-3                                                           00208300
      GOTO 52                                                           00208400
C                                                                       00208500
C ERROR CHECK                                                           00208600
C                                                                       00208700
58    J=(I/4)-4                                                         00208800
      IN(1)=JN(J)                                                       00208900
      IN(20)=-5                                                         00209000
59    WRITE(LB)IT,JN,IN,C                                               00209100
      ENDFILE LB                                                        00209200
      REWIND LB                                                         00209300
      DO 60 I=1,800                                                     00209400
60    ES(I)=0.                                                          00209500
      RETURN                                                            00209600
      END                                                               00209700
C                                                                       00209800
      SUBROUTINE XREF                                                   00209900
      DIMENSION IH(18)                                                  00210000
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS, 00210100
     *NP,KH,NA,NH,R,SF,DA,IT(40),JN(160),IN(660),C(1740),ID(800),IX(480)00210200
     *,E(410),A(410),H(800),D(1600),F(84),DX(480),G(141),ES(800),B(100) 00210300
      DATA IH(1)/4H X/A/,IH(2)/4H Y/B/,IH(3)/4H Z/C/,IH(4)/4H  K /      00210400
      DATA IH(5)/4H U11/,IH(6)/4H U22/,IH(7)/4H U33/,IH(8)/4H U23/      00210500
      DATA IH(9)/4H U13/,IH(10)/4H U12/,IH(11)/1H /,IH(12)/1H0/         00210600
      DATA IH(13)/4HILSF/,IH(14)/4HFVAR/,IH(15)/4H    /                 00210700
      DATA IH(16)/4HROTX/,IH(17)/4HROTY/,IH(18)/4HROTZ/                 00210800
      MPR=MIN0(400,INT(SQRT(FLOAT(LM+LM+(2139*LU)-17096-LV-LV))-1.5))   00210900
      KB=1                                                              00211000
      IF(IN(20))113,1,1                                                 00211100
1     NC=NC+1                                                           00211200
      KB=KB+KB                                                          00211300
      IF(KH.GT.0)IN(13)=-IABS(IN(13))                                   00211400
      IF(KB.GT.KH)KB=2                                                  00211500
      R=0.                                                              00211600
C                                                                       00211700
C PUNCH CARDS                                                           00211800
C                                                                       00211900
      JI=0                                                              00212000
      K=IN(5)                                                           00212100
      IF(NV)10,2,10                                                     00212200
2     WRITE(LI,3)IT                                                     00212300
3     FORMAT(///1X,40A1//)                                              00212400
      WRITE(LI,4)(IH(J),J=1,10)                                         00212500
4     FORMAT(5H ATOM,3(5X,A4),2(8X,A4),5(5X,A4)/)                       00212600
      IF(C(60).LT.9.E8)WRITE(LP,5)C(60),IN(19),IN(8)                    00212700
5     FORMAT(4HWGHT,F11.6,2I4)                                          00212800
      IF(IN(12))6,8,6                                                   00212900
6     J=IN(3)+6                                                         00213000
      C(J)=IN(12)                                                       00213100
      NT=IN(4)                                                          00213200
      WRITE(LP,7)(C(I),I=J,NT)                                          00213300
7     FORMAT(4HILSF,7F10.5)                                             00213400
      C(J)=1.                                                           00213500
8     J=IN(4)+2                                                         00213600
      C(J)=C(J-1)                                                       00213700
      WRITE(LP,9)(C(I),I=J,K)                                           00213800
9     FORMAT(4HFVAR,7F10.5)                                             00213900
      C(J)=1.                                                           00214000
10    NH=0                                                              00214100
      NZ=-1                                                             00214200
      NA=-2                                                             00214300
      MM=0                                                              00214400
      NN=IN(5)-IN(3)-7                                                  00214500
      NCS=0                                                             00214600
      NER=-5                                                            00214700
      I=17                                                              00214800
11    I=I+4                                                             00214900
      JI=JI+1                                                           00215000
      IF(IN(6)-I)46,12,12                                               00215100
C                                                                       00215200
C PARAMETER VALUES                                                      00215300
C                                                                       00215400
12    J=MOD(IN(I+1),10)                                                 00215500
      IF(IN(I+3).EQ.0)GOTO 13                                           00215600
      IF(MOD(IN(I+3)/KB,2).EQ.0)J=2                                     00215700
13    NQ=MIN0(5,3*((J-1)/2),3*(7-J))                                    00215800
      IN(I+3)=J                                                         00215900
      IF(NV.EQ.0)IN(I+3)=2                                              00216000
      NF=MIN0(MOD(J,2),IABS(J-5))                                       00216100
      IF(NF*4-NQ)15,14,14                                               00216200
14    NZ=NH                                                             00216300
      ND=K                                                              00216400
15    IF(J-6)16,18,17                                                   00216500
16    MM=0                                                              00216600
      GOTO 19                                                           00216700
17    MM=NN+1                                                           00216800
      NN=NN+3                                                           00216900
      GOTO 19                                                           00217000
18    NA=NA+3                                                           00217100
      IX(NA)=MM                                                         00217200
      IX(NA+1)=NH+1                                                     00217300
      IX(NA+2)=K+1                                                      00217400
      DX(NA)=C(K+1)-C(ND+1)                                             00217500
      DX(NA+1)=C(K+2)-C(ND+2)                                           00217600
      DX(NA+2)=C(K+3)-C(ND+3)                                           00217700
      IF(MM)44,44,19                                                    00217800
19    NL=IN(I)                                                          00217900
      IF(NZ)44,20,20                                                    00218000
20    NW=NZ                                                             00218100
      DO 29 J=1,NL                                                      00218200
      K=K+1                                                             00218300
      M=INT(ABS(C(K)*0.1)+0.5)                                          00218400
      E(J)=C(K)                                                         00218500
      NH=NH+1                                                           00218600
      ID(NH)=(NN*NF)+1                                                  00218700
      NN=NN+NF                                                          00218800
      IF(M-1)25,21,21                                                   00218900
21    ID(NH)=(M+NP)*NF+1                                                00219000
      NN=NN-NF                                                          00219100
      NR=M+IN(4)+1                                                      00219200
      IF(IN(5)-NR)44,22,22                                              00219300
22    Q=SIGN(0.5,C(K)+5.)                                               00219400
      H(NH)=AMOD(C(K)+5.,10.)-10.*Q                                     00219500
      C(K)=H(NH)*(Q+AMOD(C(NR)+5.,10.)-5.5)                             00219600
      IF(5.-C(NR))24,23,23                                              00219700
23    IF(1-M)26,24,24                                                   00219800
24    ID(NH)=1                                                          00219900
25    H(NH)=1.                                                          00220000
26    NW=NW+1                                                           00220100
      IF((NW-NH)*((M*ID(NW))-1))44,27,27                                00220200
27    ID(NH)=ID(NW)                                                     00220300
      H(NH)=H(NW)                                                       00220400
      M=ID(NH)                                                          00220500
      E(J+10)=C(K)                                                      00220600
      E(J+20)=ABS(A(M)*H(NH))                                           00220700
      IF(NQ-J)29,28,29                                                  00220800
28    NF=1-NF                                                           00220900
      NW=NH                                                             00221000
29    IF(KH.NE.0)E(J+20)=ES(NH)                                         00221100
C                                                                       00221200
C PRINT TABLES AND TEST FOR N.P.D.                                      00221300
C                                                                       00221400
      IF(NV)11,30,11                                                    00221500
30    WRITE(LI,31)IH(12),JN(JI),(E(J+10),J=1,NL)                        00221600
      WRITE(LI,31)IH(11),IH(15),(E(J+20),J=1,NL)                        00221700
31    FORMAT(A1,A4,2X,3F9.4,2F12.4,5F9.4)                               00221800
      IF(7-NL)33,32,32                                                  00221900
32    IF(E(15))36,38,38                                                 00222000
33    V=E(15)*E(16)*E(17)                                               00222100
      DO 35 J=15,17                                                     00222200
      IF(E(J))36,34,34                                                  00222300
34    U=(V/E(J))-E(J+3)*E(J+3)                                          00222400
      IF(U)36,35,35                                                     00222500
35    CONTINUE                                                          00222600
      U=U*E(17)+2.*E(18)*E(19)*E(20)                                    00222700
      IF(U-E(16)*E(19)*E(19)-E(15)*E(18)*E(18))36,38,38                 00222800
36    WRITE(LI,37)JN(JI)                                                00222900
37    FORMAT(/15X,4H**  ,A4,27H  NON POSITIVE DEFINITE  **/)            00223000
38    IF(IN(I+1)-NCS-1)39,41,39                                         00223100
39    NCS=IN(I+1)-1                                                     00223200
40    FORMAT(4HAFIX,I3)                                                 00223300
      WRITE(LP,40)NCS                                                   00223400
      NCS=NCS-MAX0(MOD(NCS,10)-5,0)                                     00223500
41    NR=(IN(I+2)-10)/2                                                 00223600
      WRITE(LP,42)JN(JI),NR,(E(J),J=1,NL)                               00223700
42    FORMAT(A4,I5,6F10.5,2H =/5X,4F10.5)                               00223800
      IF(IN(10).LT.0)WRITE(LP,43)E(21),E(22),E(23),(E(J+20),J=5,NL)     00223900
43    FORMAT(4X,9F8.5)                                                  00224000
      GOTO 11                                                           00224100
C                                                                       00224200
C ERROR EXIT                                                            00224300
C                                                                       00224400
44    J=JN(JI)                                                          00224500
45    IN(20)=NER                                                        00224600
      IN(1)=J                                                           00224700
      WRITE(LB)IT,JN,IN,C                                               00224800
      ENDFILE LB                                                        00224900
      REWIND LB                                                         00225000
      GOTO 113                                                          00225100
C                                                                       00225200
46    J=160                                                             00225300
      NER=-4                                                            00225400
      IF(800-NH)45,47,47                                                00225500
47    IF(NV)113,53,48                                                   00225600
48    NER=-11                                                           00225700
      J=MPR                                                             00225800
      IF(MPR-NN)45,49,49                                                00225900
49    I=((NN*(NN+3))/2)+10                                              00226000
      IF(MIN0(IN(13),NC-1).LT.1)GOTO 51                                 00226100
      DO 50 J=1,NN                                                      00226200
50    ES(J)=D(J)                                                        00226300
      GOTO 53                                                           00226400
51    DO 52 J=1,I                                                       00226500
52    B(J)=0.                                                           00226600
53    CALL SFLS                                                         00226700
      NV=NV-1                                                           00226800
      IF(NV)1,54,54                                                     00226900
C                                                                       00227000
C RETAINED FULL-MATRIX LEAST-SQUARES                                    00227100
C                                                                       00227200
54    IF(IN(13).LT.0)GOTO 57                                            00227300
      DO 55 J=1,NN                                                      00227400
      D(J)=AMAX1(B(J)+DA*C(47),0.1*DA)                                  00227500
55    B(J)=SQRT(ES(J)/D(J))                                             00227600
      IF(NC.EQ.1)GOTO 57                                                00227700
      L=NN+1                                                            00227800
      DO 56 I=1,NN                                                      00227900
      DO 56 J=I,NN                                                      00228000
      B(L)=B(L)*B(I)*B(J)                                               00228100
56    L=L+1                                                             00228200
      GOTO 68                                                           00228300
C                                                                       00228400
C INVERT MATRIX                                                         00228500
C                                                                       00228600
57    K=0                                                               00228700
      J=NN+1                                                            00228800
      DO 61 NI=1,NN                                                     00228900
      K=K+2                                                             00229000
      I=J-1                                                             00229100
      M=J+1                                                             00229200
      B(J)=1./AMAX1(B(J)+DA*C(47),0.1*DA)                               00229300
      IF(NI-NN)58,61,61                                                 00229400
58    B(K)=-B(J)*B(M)                                                   00229500
      M=M+1                                                             00229600
      K=K+1                                                             00229700
      IF(K-J)58,60,60                                                   00229800
59    B(M)=B(J)*B(L)+B(M)                                               00229900
      M=M+1                                                             00230000
      L=L+1                                                             00230100
      IF(I-L)60,59,59                                                   00230200
60    L=J+NI-NN                                                         00230300
      J=J+1                                                             00230400
      IF(I-L)61,59,59                                                   00230500
61    CONTINUE                                                          00230600
      NI=NN-1                                                           00230700
62    NI=NI-1                                                           00230800
      J=K                                                               00230900
      M=K+NI-NN                                                         00231000
      L=M-1                                                             00231100
      I=M+1                                                             00231200
      K=I+NI-NN                                                         00231300
63    B(I)=0.                                                           00231400
      I=I+1                                                             00231500
      IF(I-J)63,64,64                                                   00231600
64    M=M+1                                                             00231700
      B(M)=B(K)*B(J)+B(M)                                               00231800
      I=M                                                               00231900
      NK=K+1                                                            00232000
      IF(L-NK)66,65,65                                                  00232100
65    J=J+1                                                             00232200
      I=I+1                                                             00232300
      B(I)=B(K)*B(J)+B(I)                                               00232400
      B(M)=B(NK)*B(J)+B(M)                                              00232500
      NK=NK+1                                                           00232600
      IF(L-NK)66,65,65                                                  00232700
66    B(NK)=B(K)*B(M)+B(NK)                                             00232800
      J=J+1                                                             00232900
      K=K+1                                                             00233000
      IF(L-K)67,64,64                                                   00233100
67    IF(-NI)62,68,68                                                   00233200
68    DO 69 I=1,NN                                                      00233300
69    B(I)=0.                                                           00233400
      L=NN+1                                                            00233500
      DO 71 I=1,NN                                                      00233600
      B(I)=B(I)-B(L)*A(I)                                               00233700
      T=B(L)*R                                                          00233800
      DO 70 K=I,NN                                                      00233900
      B(I)=B(L)*A(K)+B(I)                                               00234000
      B(K)=B(L)*A(I)+B(K)                                               00234100
70    L=L+1                                                             00234200
71    A(I)=SQRT(ABS(T))                                                 00234300
C                                                                       00234400
C RIGID GROUP SHIFTS                                                    00234500
C                                                                       00234600
      U=B(1)                                                            00234700
      B(1)=0.                                                           00234800
      NH=1                                                              00234900
      K=IN(5)                                                           00235000
      I=17                                                              00235100
72    I=I+4                                                             00235200
      IF(IN(6)-I)79,73,73                                               00235300
73    X=1.                                                              00235400
      IF(1-IABS(MOD(IN(I+1),10)-5))74,76,77                             00235500
74    DO 75 L=1,5                                                       00235600
      N=ID(NH)                                                          00235700
      E(L)=B(N)*H(NH)                                                   00235800
75    NH=NH+1                                                           00235900
      NH=NH-5                                                           00236000
      GOTO 78                                                           00236100
76    X=0.                                                              00236200
77    C(K+1)=C(K+1)+E(1)                                                00236300
      C(K+2)=C(K+2)+E(2)                                                00236400
      C(K+3)=C(K+3)+E(3)                                                00236500
      C(K+4)=C(K+4)+E(4)*X                                              00236600
      C(K+5)=C(K+5)+E(5)*X                                              00236700
78    NH=NH+IN(I)                                                       00236800
      K=K+IN(I)                                                         00236900
      GOTO 72                                                           00237000
79    B(1)=U                                                            00237100
      IF(NA)87,87,80                                                    00237200
80    DO 82 L=1,NA,3                                                    00237300
      N=IX(L)                                                           00237400
      K=IX(L+2)                                                         00237500
      DO 81 J=1,3                                                       00237600
      E(J)=SIN(B(N))                                                    00237700
      E(J+3)=COS(B(N))-1.                                               00237800
81    N=N+1                                                             00237900
      U=DX(L+1)-DX(L)*G(136)                                            00238000
      V=DX(L+2)-DX(L)*G(139)                                            00238100
      Y=U*E(4)+E(1)*(G(127)*U+G(130)*V)+DX(L+1)                         00238200
      Z=V*E(4)-E(1)*(G(133)*U+G(127)*V)+DX(L+2)                         00238300
      U=DX(L)-Y*G(140)                                                  00238400
      V=Z-Y*G(137)                                                      00238500
      X=U*E(5)-E(2)*(G(128)*U+G(134)*V)+DX(L)                           00238600
      Z=V*E(5)+E(2)*(G(131)*U+G(128)*V)+Z                               00238700
      C(K+2)=C(K+2)-DX(L+2)+Z                                           00238800
      U=X-Z*G(138)                                                      00238900
      V=Y-Z*G(141)                                                      00239000
      C(K)=C(K)-DX(L)+U*E(6)+E(3)*(G(129)*U+G(132)*V)+X                 00239100
82    C(K+1)=C(K+1)-DX(L+1)+V*E(6)-E(3)*(G(135)*U+G(129)*V)+Y           00239200
C                                                                       00239300
C L.S. RESULTS                                                          00239400
C                                                                       00239500
83    FORMAT(//6H CYCLE,I3/39X,17HESD     SHIFT/ESD/)                   00239600
84    FORMAT(20H   1   OVERALL SCALE,F11.5,F13.5,F10.3)                 00239700
85    FORMAT(I4,6X,A4,I4,2F13.5,F10.3)                                  00239800
86    FORMAT(I4,6X,2A4,2F13.5,F10.3)                                    00239900
87    N=0                                                               00240000
      JI=0                                                              00240100
      WRITE(LI,83)NC                                                    00240200
      K=IN(4)+1                                                         00240300
      ASSIGN 90 TO MC                                                   00240400
88    B(N+1)=B(N+1)*C(K)                                                00240500
      A(N+1)=A(N+1)*C(K)                                                00240600
89    N=N+1                                                             00240700
      U=AMIN1(A(N),10.)                                                 00240800
      C(K)=C(K)+B(N)                                                    00240900
      V=B(N)/U                                                          00241000
      A(N)=AMOD(U,9.99999)                                              00241100
      GOTO MC,(90,94,101)                                               00241200
90    WRITE(LI,84)C(K),A(N),V                                           00241300
      K=IN(3)+6                                                         00241400
      NI=IH(13)                                                         00241500
      J=1                                                               00241600
      ASSIGN 94 TO MC                                                   00241700
91    K=K+1                                                             00241800
      IF(IN(5)-K)95,92,92                                               00241900
92    IF(K-IN(4)-1)88,93,89                                             00242000
93    NI=IH(14)                                                         00242100
      J=2                                                               00242200
      K=K+1                                                             00242300
      GOTO 91                                                           00242400
94    WRITE(LI,85)N,NI,J,C(K),A(N),V                                    00242500
      J=J+1                                                             00242600
      GOTO 91                                                           00242700
95    ASSIGN 101 TO MC                                                  00242800
      NI=0                                                              00242900
      I=17                                                              00243000
96    I=I+4                                                             00243100
      JI=JI+1                                                           00243200
      J=0                                                               00243300
      IF(IN(6)-I)104,97,97                                              00243400
97    L=16                                                              00243500
      IF(MOD(IN(I+1),10).NE.7)GOTO 99                                   00243600
      IF(IN(I+3).EQ.0)GOTO 98                                           00243700
      IF(MOD(IN(I+3)/KB,2).EQ.0)GOTO 99                                 00243800
98    N=N+1                                                             00243900
      X=B(N)                                                            00244000
      U=AMIN1(A(N),10.)                                                 00244100
      V=B(N)/U                                                          00244200
      A(N)=AMOD(U,9.99999)                                              00244300
      WRITE(LI,86)N,JN(JI),IH(L),X,A(N),V                               00244400
      L=L+1                                                             00244500
      IF(L-19)98,99,99                                                  00244600
99    J=J+1                                                             00244700
      IF(IN(I)-J)96,100,100                                             00244800
100   NI=NI+1                                                           00244900
      IF(ID(NI)-N-1)103,89,103                                          00245000
101   WRITE(LI,86)N,JN(JI),IH(J),C(K),A(N),V                            00245100
      C(K)=AMAX1(-4.,AMIN1(4.,C(K)))                                    00245200
      IF((4-J)*(J-7))103,102,102                                        00245300
102   C(K)=AMAX1(C(K),0.0001)                                           00245400
103   K=K+1                                                             00245500
      GOTO 99                                                           00245600
C                                                                       00245700
C BLOC ESDS                                                             00245800
C                                                                       00245900
104   A(1)=0.                                                           00246000
      IF(KH.EQ.0)GOTO 106                                               00246100
      DO 105 I=1,NI                                                     00246200
      J=ID(I)                                                           00246300
      X=0.                                                              00246400
      IF(J.GT.1)X=ABS(A(J)*H(I))                                        00246500
105   IF(X.GT.1.E-6)ES(I)=X                                             00246600
C                                                                       00246700
C CORRELATION COEFFICIENTS AND RECYCLE                                  00246800
C                                                                       00246900
106   WRITE(LB)IT,JN,IN,C                                               00247000
      ENDFILE LB                                                        00247100
      REWIND LB                                                         00247200
      IF(NV.GT.0)DA=1.                                                  00247300
      J=0                                                               00247400
      E(1)=0.                                                           00247500
      L=NN                                                              00247600
      DO 109 I=1,NN                                                     00247700
      M=L+1                                                             00247800
      Y=B(M)                                                            00247900
      DO 109 K=I,NN                                                     00248000
      L=L+1                                                             00248100
      IF(I-K)107,109,109                                                00248200
107   M=M+NN-K+2                                                        00248300
      V=B(L)/SQRT(ABS(B(M)*Y))                                          00248400
      IF(ABS(V)-0.5)109,108,108                                         00248500
108   E(J+1)=I                                                          00248600
      E(J+2)=K                                                          00248700
      J=MIN0(300,J+3)                                                   00248800
      E(J)=V                                                            00248900
109   B(L)=B(L)*DA                                                      00249000
      J=MAX0(J,1)                                                       00249100
      WRITE(LI,111)                                                     00249200
111   FORMAT(//45H CORRELATION MATRIX ELEMENTS GREATER THAN 0.5)        00249300
      WRITE(LI,112)(E(I),I=1,J)                                         00249400
112   FORMAT(20(/5(2F5.0,F8.4,4X))/5H ETC.)                             00249500
      GOTO 1                                                            00249600
113   RETURN                                                            00249700
      END                                                               00249800
C                                                                       00249900
      SUBROUTINE SFLS                                                   00250000
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS, 00250100
     *NP,KH,NA,NH,R,SF,DA,IT(40),JN(160),IN(660),C(1740),ID(800),IX(480)00250200
     *,E(410),A(410),H(800),D(1600),F(84),DX(480),G(141),ES(800),B(100) 00250300
      NE=IN(4)+1                                                        00250400
      NR=0                                                              00250500
      DA=0.                                                             00250600
      RM=0.                                                             00250700
      RC=0.                                                             00250800
      SA=0.                                                             00250900
      SB=0.                                                             00251000
      SC=0.                                                             00251100
      SD=0.                                                             00251200
      SE=0.                                                             00251300
      DO 1 J=1,410                                                      00251400
      A(J)=0.                                                           00251500
1     E(J)=0.                                                           00251600
      DO 2 J=26,32                                                      00251700
2     C(J)=0.                                                           00251800
      DO 3 J=1,1600                                                     00251900
3     D(J)=0.                                                           00252000
      IF(0.0001-C(46))6,6,34                                            00252100
4     IF(NV)6,5,6                                                       00252200
5     WRITE(LA)F                                                        00252300
6     READ(LF)F                                                         00252400
      I=1                                                               00252500
7     IF(ABS(F(I))-.8)55,8,8                                            00252600
8     IF(C(46)-F(I+3))33,9,9                                            00252700
9     NR=NR+1                                                           00252800
C                                                                       00252900
C SFAC                                                                  00253000
C                                                                       00253100
      V=1.266515*C(1)*C(1)*F(I+3)                                       00253200
      U=AMOD(V,2.)                                                      00253300
      M=INT(V-U)+2                                                      00253400
      U=0.5*U                                                           00253500
      NB=12                                                             00253600
      NK=IN(2)                                                          00253700
      DO 10 J=NS,NK,103                                                 00253800
      E(NB+1)=C(J+1)                                                    00253900
      K=M+J                                                             00254000
      E(NB)=C(K)+U*(C(K+2)-C(K)+C(K+1)-U*C(K+1))                        00254100
10    NB=NB+2                                                           00254200
C                                                                       00254300
C H K L                                                                 00254400
C                                                                       00254500
      CALL HKL(F(I),E(2),E(3),E(4))                                     00254600
      E(1)=0.                                                           00254700
      U=0.                                                              00254800
      V=0.                                                              00254900
      NK=NB                                                             00255000
      J=IN(5)                                                           00255100
      K=17                                                              00255200
11    K=K+4                                                             00255300
      J=J+IN(K)                                                         00255400
      IF(IN(K)-10)12,13,13                                              00255500
12    E(NK)=EXP(-C(J)*F(I+3))                                           00255600
      NK=NK+1                                                           00255700
13    IF(IN(6).GT.K)GOTO 11                                             00255800
      J=61                                                              00255900
14    X=E(2)*C(J)+E(3)*C(J+3)+E(4)*C(J+6)                               00256000
      Y=E(2)*C(J+1)+E(3)*C(J+4)+E(4)*C(J+7)                             00256100
      Z=E(2)*C(J+2)+E(3)*C(J+5)+E(4)*C(J+8)                             00256200
      T=E(2)*C(J+9)+E(3)*C(J+10)+E(4)*C(J+11)+100.005                   00256300
      E(7)=-Y*Y*C(15)                                                   00256400
      E(8)=-Z*Z*C(16)                                                   00256500
      E(9)=-Y*Z*C(20)                                                   00256600
      E(10)=-X*Z*C(21)                                                  00256700
      E(11)=-X*Y*C(22)                                                  00256800
C                                                                       00256900
C ATOMS                                                                 00257000
C                                                                       00257100
      NK=NB                                                             00257200
      NI=17                                                             00257300
      K=IN(5)                                                           00257400
      N=1                                                               00257500
      GOTO 16                                                           00257600
15    N=N+IN(NI)                                                        00257700
16    NI=NI+4                                                           00257800
      IF(NI.GT.IN(6))GOTO 20                                            00257900
      IF(6.GT.IN(NI))GOTO 17                                            00258000
      E(6)=-X*X*C(14)                                                   00258100
      P=EXP(E(6)*C(K+5)+E(7)*C(K+6)+E(8)*C(K+7)+E(9)*C(K+8)+            00258200
     *E(10)*C(K+9)+E(11)*C(K+10))                                       00258300
      GOTO 18                                                           00258400
17    P=E(NK)                                                           00258500
      NK=NK+1                                                           00258600
      E(6)=-F(I+3)                                                      00258700
18    S=AMOD(C(K+1)*X+C(K+2)*Y+C(K+3)*Z+T,1.)                           00258800
      M=INT(100.*S)                                                     00258900
      S=(AMOD(S,0.01)-0.005)*6.282579                                   00259000
      R=1.-.5000612*S*S                                                 00259100
      O=R*G(M+1)+S*G(M+26)                                              00259200
      Q=R*G(M+26)-S*G(M+1)                                              00259300
      P=P*C(K+4)*C(25)                                                  00259400
      NL=IN(NI+2)                                                       00259500
      S=P*E(NL+1)                                                       00259600
      R=P*E(NL)                                                         00259700
      P=R*Q                                                             00259800
      R=R*O                                                             00259900
      Q=S*Q                                                             00260000
      S=S*O                                                             00260100
      U=U+P-S*C(23)                                                     00260200
      V=V+R*C(23)+Q                                                     00260300
      W=C(K+4)                                                          00260400
      K=K+IN(NI)                                                        00260500
      IF(IN(NI+3).EQ.2)GOTO 15                                          00260600
C                                                                       00260700
C DERIVATIVES                                                           00260800
C                                                                       00260900
      P=P-S                                                             00261000
      Q=R+Q                                                             00261100
      R=P*6.283153                                                      00261200
      S=Q*6.283153                                                      00261300
      E(5)=1./AMAX1(W,0.0001)                                           00261400
      D(N)=D(N)-S*X                                                     00261500
      D(N+800)=D(N+800)+R*X                                             00261600
      D(N+1)=D(N+1)-S*Y                                                 00261700
      D(N+801)=D(N+801)+R*Y                                             00261800
      D(N+2)=D(N+2)-S*Z                                                 00261900
      D(N+802)=D(N+802)+R*Z                                             00262000
      N=N+3                                                             00262100
      L=IN(NI)+1                                                        00262200
      DO 19 M=5,L                                                       00262300
      D(N)=D(N)+E(M)*P                                                  00262400
      D(N+800)=D(N+800)+E(M)*Q                                          00262500
19    N=N+1                                                             00262600
      GOTO 16                                                           00262700
20    J=J+12                                                            00262800
      IF(IN(1)-J)21,14,14                                               00262900
C                                                                       00263000
C F CALC AND F OBS                                                      00263100
C                                                                       00263200
21    L=MIN0(5,1+IABS(IN(12)))                                          00263300
      E(5)=INT(0.001*F(I+4))                                            00263400
      M=INT(ABS(E(L))+1.1)                                              00263500
      L=MIN0(IN(4),M+IN(3)+5)                                           00263600
      X=U*U+V*V                                                         00263700
      O=1./AMAX1(AMOD(C(NE),100.)*AMOD(C(L),100.),1.E-6)                00263800
      F(I+1)=F(I+1)*O                                                   00263900
      W=F(I+2)*O*O                                                      00264000
      O=F(I+1)*F(I+1)                                                   00264100
      F(I+2)=ABS(C(59)/(W+O*ABS(C(60))))                                00264200
      IF(C(60).GT.9.E8)F(I+2)=1.                                        00264300
      J=IN(4)+IN(19)+1                                                  00264400
      T=1.                                                              00264500
      IF(IN(19).GT.1)T=EXP(F(I+5)*(C(J)-1.))                            00264600
      CR=F(I+5)                                                         00264700
      P=0.                                                              00264800
      J=IN(8)+IN(4)+1                                                   00264900
      IF(IN(8).GT.1)P=X/(C(1)*SQRT(F(I+3))*1125.395)                    00265000
      Q=(1.-C(J)*P)*T                                                   00265100
      F(I+4)=U*Q                                                        00265200
      F(I+5)=V*Q                                                        00265300
      S=SQRT(X)                                                         00265400
      X=S*Q                                                             00265500
      Y=F(I+1)-X                                                        00265600
      SA=SA+W*W                                                         00265700
      SB=SB+W*O                                                         00265800
      SC=SC+O*O                                                         00265900
      SD=SD+Y*Y*W                                                       00266000
      SE=SE+Y*Y*O                                                       00266100
      DA=DA+F(I+2)                                                      00266200
      W=SQRT(F(I+2))                                                    00266300
      C(26)=AMAX1(C(26),F(I+1))                                         00266400
      C(27)=C(27)+ABS(Y)                                                00266500
      C(28)=C(28)+F(I+1)                                                00266600
      C(29)=C(29)+W*ABS(Y)                                              00266700
      C(30)=C(30)+W*F(I+1)                                              00266800
      C(31)=C(31)+F(I+2)*Y*Y                                            00266900
      C(32)=C(32)+F(I+2)*O                                              00267000
      RM=RM+F(I+2)*F(I+1)*X                                             00267100
      RC=RC+F(I+2)*X*X                                                  00267200
      IF(NV)33,33,22                                                    00267300
C                                                                       00267400
C ADD DERIVATIVES                                                       00267500
C                                                                       00267600
22    NB=NN+10                                                          00267700
      Q=T*(1.-3.*C(J)*P)*W/AMAX1(S,1.E-6)                               00267800
      DO 23 J=1,NB                                                      00267900
23    E(J)=0.                                                           00268000
      X=X*W                                                             00268100
      U=U*Q                                                             00268200
      V=V*Q                                                             00268300
      J=IN(8)+NP+1                                                      00268400
      IF(IN(8).GT.1)E(J)=-P*S*T*W                                       00268500
      J=IN(19)+NP+1                                                     00268600
      IF(IN(19).GT.1)E(J)=CR*X                                          00268700
      O=1.99-0.01*C(L)                                                  00268800
      E(M)=X*AINT(O)                                                    00268900
      N=N-1                                                             00269000
      IF(NA)26,26,24                                                    00269100
24    DO 25 NB=1,NA,3                                                   00269200
      NM=IX(NB)                                                         00269300
      J=IX(NB+1)                                                        00269400
      O=U*D(J)+V*D(J+800)                                               00269500
      P=U*D(J+1)+V*D(J+801)                                             00269600
      Q=U*D(J+2)+V*D(J+802)                                             00269700
      T=(DX(NB+1)-DX(NB)*G(136))*(P*G(127)-Q*G(133))                    00269800
      E(NM)=T+E(NM)+(DX(NB+2)-DX(NB)*G(139))*(P*G(130)-Q*G(127))        00269900
      T=(DX(NB)-DX(NB+1)*G(140))*(Q*G(131)-O*G(128))                    00270000
      E(NM+1)=E(NM+1)+T+(DX(NB+2)-DX(NB+1)*G(137))*(Q*G(128)-O*G(134))  00270100
      T=(DX(NB)-DX(NB+2)*G(138))*(O*G(129)-P*G(135))                    00270200
25    E(NM+2)=E(NM+2)+T+(DX(NB+1)-DX(NB+2)*G(141))*(O*G(132)-P*G(129))  00270300
26    DO 27 J=1,N                                                       00270400
      K=ID(J)                                                           00270500
      E(K)=E(K)+H(J)*(U*D(J)+V*D(J+800))                                00270600
      D(J)=0.                                                           00270700
27    D(J+800)=0.                                                       00270800
      ASSIGN 33 TO NU                                                   00270900
      E(1)=SF*X                                                         00271000
      W=W*Y                                                             00271100
28    M=NN+1                                                            00271200
      ASSIGN 30 TO KQ                                                   00271300
      IF(MIN0(IN(13),NC-1).GT.0)ASSIGN 32 TO KQ                         00271400
      DO 32 N=1,NN                                                      00271500
      Y=E(N)                                                            00271600
      L=M                                                               00271700
      M=M+NN-N+1                                                        00271800
      IF(Y)29,32,29                                                     00271900
29    A(N)=W*Y+A(N)                                                     00272000
      B(N)=B(N)+Y*Y                                                     00272100
      GOTO KQ,(30,32)                                                   00272200
30    K=N                                                               00272300
31    B(L)=Y*E(K)+B(L)                                                  00272400
      B(L+1)=Y*E(K+1)+B(L+1)                                            00272500
      B(L+2)=Y*E(K+2)+B(L+2)                                            00272600
      B(L+3)=Y*E(K+3)+B(L+3)                                            00272700
      B(L+4)=Y*E(K+4)+B(L+4)                                            00272800
      B(L+5)=Y*E(K+5)+B(L+5)                                            00272900
      B(L+6)=Y*E(K+6)+B(L+6)                                            00273000
      B(L+7)=Y*E(K+7)+B(L+7)                                            00273100
      B(L+8)=Y*E(K+8)+B(L+8)                                            00273200
      B(L+9)=Y*E(K+9)+B(L+9)                                            00273300
      L=L+10                                                            00273400
      K=K+10                                                            00273500
      IF(NN.GT.K)GOTO 31                                                00273600
      B(L)=Y*E(K)+B(L)                                                  00273700
32    CONTINUE                                                          00273800
      GOTO NU,(33,40,49)                                                00273900
33    I=I+6                                                             00274000
      IF(LV-I)4,7,7                                                     00274100
C                                                                       00274200
C BOND LENGTH CONSTRAINTS                                               00274300
C                                                                       00274400
34    S=0.                                                              00274500
      R=1.E-7                                                           00274600
      DA=1.                                                             00274700
35    WRITE(LI,36)NC                                                    00274800
      WRITE(LI,37)                                                      00274900
36    FORMAT(///38H CONSTRAINED BOND LENGTHS BEFORE CYCLE,I3/)          00275000
37    FORMAT(15X,3HOBS,5X,16HOBS-FIX    SIGMA)                          00275100
38    FORMAT(/1X,A4,1H-,A4,3F10.4)                                      00275200
      NH=1                                                              00275300
      L=IN(6)                                                           00275400
      DO 39 I=21,L,4                                                    00275500
      IN(I+1)=NH+IN(5)                                                  00275600
      IN(I+2)=NH                                                        00275700
39    NH=NH+IN(I)                                                       00275800
      I=IN(7)                                                           00275900
      ASSIGN 40 TO NU                                                   00276000
40    IF(C(I)-0.001)47,41,41                                            00276100
41    W=SQRT(R)/C(I+1)                                                  00276200
      X=1.                                                              00276300
      DO 42 J=1,NN                                                      00276400
42    E(J)=0.                                                           00276500
      L=MAX0(INT(0.1*C(I)),1)                                           00276600
      Q=C(I)                                                            00276700
      IF(L-1)45,45,43                                                   00276800
43    M=L+IN(4)+1                                                       00276900
      Q=AMOD(C(M),10.)*AMOD(C(I),10.)                                   00277000
      IF(C(M)-10.)44,45,45                                              00277100
44    K=L+NP+1                                                          00277200
      E(K)=W                                                            00277300
45    K=C(I+2)                                                          00277400
      M=C(I+3)                                                          00277500
      NI=IN(K+2)                                                        00277600
      NK=IN(K+1)                                                        00277700
      NT=IN(M+2)                                                        00277800
      NZ=IN(M+1)                                                        00277900
      X=C(NK)-C(NZ)                                                     00278000
      Y=C(NK+1)-C(NZ+1)                                                 00278100
      Z=C(NK+2)-C(NZ+2)                                                 00278200
      P=X*X*C(8)+Y*Y*C(9)+Z*Z*C(10)+Y*Z*C(11)+X*Z*C(12)+X*Y*C(13)       00278300
      P=SQRT(ABS(P))                                                    00278400
      C(14)=C(8)*X+0.5*(C(12)*Z+C(13)*Y)                                00278500
      C(15)=C(9)*Y+0.5*(C(11)*Z+C(13)*X)                                00278600
      C(16)=C(10)*Z+0.5*(C(11)*Y+C(12)*X)                               00278700
      DO 46 J=14,16                                                     00278800
      N=ID(NI)                                                          00278900
      E(N)=E(N)-H(NI)*C(J)*W/P                                          00279000
      N=ID(NT)                                                          00279100
      E(N)=E(N)+H(NT)*C(J)*W/P                                          00279200
      NI=NI+1                                                           00279300
46    NT=NT+1                                                           00279400
      E(1)=0.                                                           00279500
      O=P-Q                                                             00279600
      W=W*O                                                             00279700
      J=(K-17)/4                                                        00279800
      N=(M-17)/4                                                        00279900
      WRITE(LI,38)JN(J),JN(N),P,O,C(I+1)                                00280000
      I=I+4                                                             00280100
      IF(NV)40,40,28                                                    00280200
47    U=0.                                                              00280300
      V=100000.                                                         00280400
      IF(0.0001-C(46))57,57,65                                          00280500
C                                                                       00280600
C ILSF/U(JJ) CONSTRAINTS                                                00280700
C                                                                       00280800
48    ASSIGN 49 TO NU                                                   00280900
      NI=17                                                             00281000
      T=1.E3*SQRT(R)                                                    00281100
      NH=5                                                              00281200
      IF(IN(12)+4)56,56,50                                              00281300
49    NH=NH+IN(NI)                                                      00281400
50    NI=NI+4                                                           00281500
      IF(IN(6)-NI)56,51,51                                              00281600
51    IF(IN(NI)-6)49,52,52                                              00281700
52    DO 53 K=1,NN                                                      00281800
53    E(K)=0.                                                           00281900
      K=NH+2                                                            00282000
      DO 54 L=NH,K                                                      00282100
      N=ID(L)                                                           00282200
54    E(N)=H(L)*T                                                       00282300
      NK=NH-IN(12)-1                                                    00282400
      N=ID(NK)                                                          00282500
      E(N)=E(N)-3.*H(NK)*T                                              00282600
      NK=NK+IN(5)                                                       00282700
      I=NH+IN(5)                                                        00282800
      W=T*(3.*C(NK)-C(I)-C(I+1)-C(I+2))                                 00282900
      E(1)=0.                                                           00283000
      GOTO 28                                                           00283100
C                                                                       00283200
C RESIDUALS                                                             00283300
C                                                                       00283400
55    S=1.                                                              00283500
      R=C(31)/FLOAT(NR-NN)                                              00283600
      IF(1.GT.NV)GOTO 56                                                00283700
      IF(IN(12))48,56,56                                                00283800
56    IF(IN(7))57,57,35                                                 00283900
57    IF(NV)59,58,59                                                    00284000
58    WRITE(LA)F                                                        00284100
      ENDFILE LA                                                        00284200
      REWIND LA                                                         00284300
59    REWIND LF                                                         00284400
60    FORMAT(///23H RESIDUALS BEFORE CYCLE,I4,5H FOR ,40A1/)            00284500
61    FORMAT(4H R =,F8.4,5X,4HRW =,F8.4,5X,4HRG =,F8.4,5X,4HRM =,F8.4/) 00284600
62    FORMAT(4H N =,I5,5X,4HNP =,I4,5X,9HMAX(NP) =,I4/)                 00284700
63    FORMAT(9H WEIGHT =,F10.4,18H / ( SIGMA**2(F) +,F9.6,6H F*F ))     00284800
      R=R*S                                                             00284900
      U=C(27)/C(28)                                                     00285000
      V=C(29)/C(30)                                                     00285100
      W=SQRT(C(31)/C(32))                                               00285200
      RM=SQRT(1.-(RM*RM/(C(32)*RC)))                                    00285300
      WRITE(LI,60)NC,IT                                                 00285400
      WRITE(LI,61)U,V,W,RM                                              00285500
      WRITE(LI,62)NR,NN,MPR                                             00285600
      W=ABS(C(60))                                                      00285700
      IF(W.LT.9.E8)WRITE(LI,63)C(59),W                                  00285800
      IF(W.GT.9.E8)WRITE(LI,64)                                         00285900
64    FORMAT(13H UNIT WEIGHTS)                                          00286000
      W=SD*SC-SB*SE
      SACBB=SA*SC-SB*SB
      IF(SACBB.EQ.0.)GO TO 640                                          00286100
      U=W/(SA*SC-SB*SB)
640   W=(SB*SD-SA*SE)/W                                                 00286300
      V=C(26)                                                           00286400
      IF(U.GT.0.)GOTO 65                                                00286500
      U=1.                                                              00286600
      W=(SB-SE)/SC                                                      00286700
65    READ(LB)IT,JN,IN,C                                                00286800
      REWIND LB                                                         00286900
      IF(KH.GT.0)IN(13)=-IABS(IN(13))                                   00287000
      C(59)=U                                                           00287100
      IF(C(60).GT.-1.E-10)GOTO 66                                       00287200
      C(60)=AMIN1(-9.E-9,W)                                             00287300
66    C(26)=V                                                           00287400
      C(27)=FLOAT(NR)/DA                                                00287500
      C(28)=R/DA                                                        00287600
      C(29)=R                                                           00287700
      RETURN                                                            00287800
      END                                                               00287900
C                                                                       00288000
      SUBROUTINE ABOND                                                  00288100
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NR,MPR,NV,NC,NN,NS, 00288200
     *NP,KH,NA,NH,R,SF,DA,IT(40),JN(160),IN(660),C(1740),ID(800),IX(480)00288300
     *,E(410),A(410),H(800),D(1600),F(84),DX(480),G(141),ES(800),B(100) 00288400
1     FORMAT(/1X,A4,7H  X/A =,F7.4,7H  Y/B =,F7.4,7H  Z/C =,F7.4)       00288500
2     FORMAT(1H ,A4,3H---,A4,F8.3,2H (,F6.3,2H ),I3,3(1H,,F8.4))        00288600
3     FORMAT(1H ,A4,1H-,A4,1H-,A4,F7.1,2H (,F4.1,2H ))                  00288700
4     FORMAT(1H ,A4,3H...,A4,F8.3,10X,I3,3(1H,,F8.4))                   00288800
      WRITE(LB)IT,JN,IN,C                                               00288900
      ENDFILE LB                                                        00289000
      REWIND LB                                                         00289100
      IF(MIN0(IN(20),INT(C(48)+99.),IN(6)-20))69,5,5                    00289200
5     ND=IN(5)                                                          00289300
      KB=IN(10)                                                         00289400
      NY=IN(6)                                                          00289500
      NP=IN(1)                                                          00289600
      NF=(INT(1.1-C(23))*3)+13                                          00289700
      C(49)=AMAX1(C(48),C(49))                                          00289800
      WRITE(LI,6)IT                                                     00289900
6     FORMAT(///40A1)                                                   00290000
      J=NN+NN                                                           00290100
      K=NN+1                                                            00290200
      DO 7 I=K,J                                                        00290300
7     B(I)=0.                                                           00290400
      IF(KH.EQ.0)GOTO 9                                                 00290500
      DO 8 I=1,800                                                      00290600
8     ID(I)=I                                                           00290700
C                                                                       00290800
C LATTICE                                                               00290900
C                                                                       00291000
9     DO 10 J=1,12                                                      00291100
10    G(J)=10.0001                                                      00291200
      DO 11 J=4,11                                                      00291300
11    G(J)=10.5001                                                      00291400
      NS=1                                                              00291500
      N=IN(18)                                                          00291600
      IF(N-1)12,18,12                                                   00291700
12    NS=4                                                              00291800
      G(N-1)=10.0001                                                    00291900
      IF(N-3)18,13,13                                                   00292000
13    IF(N-4)14,17,18                                                   00292100
14    NS=7                                                              00292200
      DO 15 J=4,9                                                       00292300
15    G(J)=10.66677                                                     00292400
      DO 16 J=5,7                                                       00292500
16    G(J)=10.33343                                                     00292600
      GOTO 18                                                           00292700
17    NS=10                                                             00292800
      G(4)=10.0001                                                      00292900
      G(8)=10.0001                                                      00293000
18    NZ=IN(2)                                                          00293100
      I=19                                                              00293200
      NB=IN(1)+12                                                       00293300
      DO 19 NI=NB,NZ,103                                                00293400
      DX(I)=C(NI)+0.5*C(48)                                             00293500
      DX(I+1)=C(NI)+0.5*C(49)                                           00293600
19    I=I+2                                                             00293700
      I=0                                                               00293800
      JA=0                                                              00293900
      DO 68 NI=21,NY,4                                                  00294000
      JI=IN(NI+2)                                                       00294100
      JA=JA+1                                                           00294200
      NZ=-2                                                             00294300
      MM=6                                                              00294400
      NC=0                                                              00294500
C                                                                       00294600
C EQUIVALENT POSITIONS                                                  00294700
C                                                                       00294800
      DO 67 M=1,NS,3                                                    00294900
      DO 67 N=61,NP,12                                                  00295000
      LY=(N-49)/12                                                      00295100
      NB=I+ND                                                           00295200
      J=M                                                               00295300
      K=N                                                               00295400
      NE=N+9                                                            00295500
      DO 20 NR=4,6                                                      00295600
      DX(NR)=C(NB+1)*C(K)+C(NB+2)*C(K+1)+C(NB+3)*C(K+2)+C(NE)           00295700
      DX(NR+9)=DX(NR)+G(J)                                              00295800
      DX(NR+12)=20.0002-DX(NR+9)                                        00295900
      NE=NE+1                                                           00296000
      J=J+1                                                             00296100
20    K=K+3                                                             00296200
      CS=1.                                                             00296300
      DO 67 NCS=13,NF,3                                                 00296400
      G(NC+13)=AMOD(DX(NCS),1.)-.000099                                 00296500
      G(NC+14)=AMOD(DX(NCS+1),1.)-.000099                               00296600
      G(NC+15)=AMOD(DX(NCS+2),1.)-.000099                               00296700
      K=0                                                               00296800
21    IF(K-NC)22,24,24                                                  00296900
22    S=ABS(G(K+13)-G(NC+13))+ABS(G(K+14)-G(NC+14))                     00297000
      IF(0.01-ABS(G(K+15)-G(NC+15))-S)23,66,66                          00297100
23    K=K+3                                                             00297200
      GOTO 21                                                           00297300
24    WRITE(LI,1)JN(JA),G(NC+13),G(NC+14),G(NC+15)                      00297400
      NC=NC+3                                                           00297500
      J=0                                                               00297600
      NV=1                                                              00297700
      JB=0                                                              00297800
      DO 65 NJ=21,NY,4                                                  00297900
      JB=JB+1                                                           00298000
      LJ=NCS                                                            00298100
      NE=J+ND                                                           00298200
      DO 25 NR=1,3                                                      00298300
      NE=NE+1                                                           00298400
      X=DX(LJ)-C(NE)-0.0001                                             00298500
      DX(NR)=X-AINT(X+SIGN(0.5,.000001+X))                              00298600
      DX(NR+6)=0.00001+DX(NR)-DX(NR+3)*CS+C(NE)                         00298700
25    LJ=LJ+1                                                           00298800
      X=DX(1)                                                           00298900
      Y=DX(2)                                                           00299000
      Z=DX(3)                                                           00299100
      NE=6                                                              00299200
      LJ=IN(NJ+2)                                                       00299300
      ASSIGN 27 TO NA                                                   00299400
C                                                                       00299500
C BOND LENGTHS                                                          00299600
C                                                                       00299700
26    Q=C(8)*X*X+C(9)*Y*Y+C(10)*Z*Z+C(11)*Y*Z+C(12)*X*Z+C(13)*X*Y       00299800
      GOTO NA,(27,32,62)                                                00299900
27    P=SQRT(Q)                                                         00300000
      IF(DX(JI+8)+DX(LJ+8)-P)65,28,28                                   00300100
28    IF(Q-0.1)65,29,29                                                 00300200
29    IF(3-NC)56,30,30                                                  00300300
30    IF(DX(JI+7)+DX(LJ+7)-P)56,31,31                                   00300400
31    NG=J                                                              00300500
32    NT=NZ+3                                                           00300600
      A(NT+4)=0.5*(C(12)*Z+C(13)*Y)+C(8)*X                              00300700
      A(NT+5)=0.5*(C(11)*Z+C(13)*X)+C(9)*Y                              00300800
      A(NT+6)=0.5*(C(11)*Y+C(12)*X)+C(10)*Z                             00300900
      IF(I-J)33,60,33                                                   00301000
33    IF(6-NE)52,34,34                                                  00301100
34    E(NT+3)=P                                                         00301200
      IT(NV)=J                                                          00301300
      IN(NV)=JB                                                         00301400
      DO 35 NR=1,3                                                      00301500
      NT=NT+1                                                           00301600
      NU=I+NR                                                           00301700
      NG=NG+1                                                           00301800
      E(NT+3)=DX(NR)                                                    00301900
      A(NT+6)=A(NT+3)*H(NU)/P                                           00302000
      A(NT+3)=-A(NT+3)*H(NG)/P                                          00302100
      IX(NT+6)=ID(NU)                                                   00302200
35    IX(NT+3)=ID(NG)                                                   00302300
      NZ=NT                                                             00302400
      NV=NV+1                                                           00302500
      DD=1.                                                             00302600
      ASSIGN 43 TO NA                                                   00302700
      IF(NV-13)38,38,36                                                 00302800
36    WRITE(LI,37)JN(JA)                                                00302900
37    FORMAT(//22H ** TOO MANY BONDS TO ,A4)                            00303000
      GOTO 68                                                           00303100
C                                                                       00303200
C COVARIANCE MATRIX                                                     00303300
C                                                                       00303400
38    S=0.                                                              00303500
      IF(IN(13).EQ.0)GOTO 42                                            00303600
      IF(IN(13).LT.-998)GOTO 42                                         00303700
      DO 41 NM=1,NE                                                     00303800
      NG=NM+NZ                                                          00303900
      NB=NM+NT                                                          00304000
      IF(KH.EQ.0)GOTO 39                                                00304100
      NU=IX(NG)                                                         00304200
      O=A(NB)*ES(NU)                                                    00304300
      S=S+O*O                                                           00304400
      GOTO 41                                                           00304500
39    O=C(28)                                                           00304600
      DO 40 NO=NM,NE                                                    00304700
      NQ=NO+NZ                                                          00304800
      NR=NO+NT                                                          00304900
      NU=MIN0(IX(NQ),IX(NG))                                            00305000
      NU=(NN+NN-NU-1)*NU/2                                              00305100
      NU=NU+IX(NQ)+IX(NG)                                               00305200
      S=S+A(NR)*A(NB)*B(NU)*O                                           00305300
40    O=C(28)+C(28)                                                     00305400
41    CONTINUE                                                          00305500
      S=SQRT(ABS(S))                                                    00305600
42    GOTO NA,(43,54)                                                   00305700
43    K=-2                                                              00305800
      NH=0                                                              00305900
      IF(DX(JI+7)+DX(LJ+7)-P)44,46,46                                   00306000
44    WRITE(LI,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)                   00306100
      IF(KB)45,49,49                                                    00306200
45    WRITE(LP,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)                   00306300
      GOTO 49                                                           00306400
46    S=AMIN1(S,9.999)                                                  00306500
      WRITE(LI,2)JN(JB),JN(JA),P,S,LY,DX(7),DX(8),DX(9)                 00306600
      IF(KB)47,49,49                                                    00306700
47    IF(I-J)48,48,49                                                   00306800
48    WRITE(LP,2)JN(JB),JN(JA),P,S,LY,DX(7),DX(8),DX(9)                 00306900
49    K=K+6                                                             00307000
      NH=NH+1                                                           00307100
      IF(K-NZ)50,65,65                                                  00307200
50    X=E(K+1)-DX(1)*DD                                                 00307300
      Y=E(K+2)-DX(2)*DD                                                 00307400
      Z=E(K+3)-DX(3)*DD                                                 00307500
      ASSIGN 62 TO NA                                                   00307600
      IF(I-J)51,26,51                                                   00307700
51    ASSIGN 32 TO NA                                                   00307800
      NE=9                                                              00307900
      NG=IT(NH)                                                         00308000
      GOTO 26                                                           00308100
C                                                                       00308200
C ANGLE ABC                                                             00308300
C                                                                       00308400
52    O=P*P                                                             00308500
      T=E(K)*E(K)                                                       00308600
      S=0.5/(P*E(K))                                                    00308700
      Z=S*(O+T-Q)                                                       00308800
      X=S*(T-O-Q)/P                                                     00308900
      Y=S*(O-T-Q)/E(K)                                                  00309000
      T=S+S                                                             00309100
      DO 53 NM=1,3                                                      00309200
      NG=NM+NZ                                                          00309300
      NB=NM+NT                                                          00309400
      NQ=NM+K                                                           00309500
      NU=J+NM                                                           00309600
      NO=IT(NH)+NM                                                      00309700
      A(NB+6)=A(NG)*X+T*A(NB+3)*H(NU)                                   00309800
      A(NB+9)=A(NQ+3)*Y+A(NG+3)*X                                       00309900
      A(NB+12)=A(NQ)*Y-T*A(NB+3)*H(NO)                                  00310000
53    IX(NG+6)=IX(NQ)                                                   00310100
      T=SQRT(ABS(1.-Z*Z))                                               00310200
      Z=ATAN2(T,Z)                                                      00310300
      NT=NT+6                                                           00310400
      NX=IN(NH)                                                         00310500
      NW=JA                                                             00310600
      ASSIGN 54 TO NA                                                   00310700
      GOTO 38                                                           00310800
54    S=S*57.29578/AMAX1(T,0.01)                                        00310900
      Z=Z*57.29578                                                      00311000
      Z=AMOD(Z+720.,360.)                                               00311100
      S=AMIN1(S,99.9)                                                   00311200
      WRITE(LI,3)JN(JB),JN(NW),JN(NX),Z,S                               00311300
      IF(IN(10))55,49,49                                                00311400
55    WRITE(LP,3)JN(JB),JN(NW),JN(NX),Z,S                               00311500
      GOTO 49                                                           00311600
56    IF(I-J)57,32,59                                                   00311700
57    IF(IN(10))58,59,59                                                00311800
58    WRITE(LP,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)                   00311900
59    WRITE(LI,4)JN(JB),JN(JA),P,LY,DX(7),DX(8),DX(9)                   00312000
      GOTO 65                                                           00312100
C                                                                       00312200
C BOND A-A*                                                             00312300
C                                                                       00312400
60    DO 61 K=1,3                                                       00312500
      NB=NT+K                                                           00312600
      NM=N+K-1                                                          00312700
      NQ=I+K                                                            00312800
      A(NB)=A(NT+4)*C(NM)+A(NT+5)*C(NM+3)+A(NT+6)*C(NM+6)               00312900
      A(NB)=H(NQ)*(A(NB)*CS-A(NB+3))/P                                  00313000
      NG=NZ+K                                                           00313100
61    IX(NG)=ID(NQ)                                                     00313200
      NE=3                                                              00313300
      DD=-1.                                                            00313400
      ASSIGN 43 TO NA                                                   00313500
      GOTO 38                                                           00313600
C                                                                       00313700
C ANGLE ABA*                                                            00313800
C                                                                       00313900
62    X=0.5/Q                                                           00314000
      Q=SQRT(Q)                                                         00314100
      T=ABS(Q-E(K))                                                     00314200
      IF(T-0.01)63,49,49                                                00314300
63    Q=0.5*(Q+E(K))                                                    00314400
      DO 64 NM=1,3                                                      00314500
      NB=NM+NT                                                          00314600
      NQ=K+NM                                                           00314700
      A(NB+3)=X*(A(NB)*Q-A(NQ+3)*P)                                     00314800
      A(NB+6)=-X*A(NQ)*P                                                00314900
      NG=NZ+NM                                                          00315000
64    IX(NG+3)=IX(NQ)                                                   00315100
      NE=6                                                              00315200
      NT=NT+3                                                           00315300
      NX=JA                                                             00315400
      NW=IN(NH)                                                         00315500
      Z=0.5*P/Q                                                         00315600
      T=SQRT(ABS(1.-Z*Z))                                               00315700
      Z=ATAN2(Z,T)*2.                                                   00315800
      T=T*0.5                                                           00315900
      ASSIGN 54 TO NA                                                   00316000
      GOTO 38                                                           00316100
65    J=J+IN(NJ)                                                        00316200
66    NZ=NZ+MM                                                          00316300
      MM=0                                                              00316400
      LY=-LY                                                            00316500
67    CS=-1.                                                            00316600
68    I=I+IN(NI)                                                        00316700
69    RETURN                                                            00316800
      END                                                               00316900
C                                                                       00317000
      SUBROUTINE XCEN                                                   00317100
      DIMENSION IS(4)                                                   00317200
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,F(84),IT(40),       00317300
     *JN(800),IN(660),D(4000),E(4000),IP(1)                             00317400
      DATA IH/4HPHIX/,IO/4HORIG/,IM/4HMULT/,IW/4HBREA/                  00317500
      DATA IS(1)/2H +/,IS(2)/2H -/,IS(3)/2H+-/,IS(4)/2HK /              00317600
      DATA QQ/0./,ZE/0./,ZR/0./,NP/-1/,LD/1/,NM/0/,NB/0/,JP/1/,NW/0/    00317700
      KD=4000                                                           00317800
      KE=4000                                                           00317900
      MP=(LU+1)*(LM-LV-KD-KE-1507+(LU*749))                             00318000
      READ(LB)IT,(JN(I),I=1,160),IN,(E(I),I=1,1740)                     00318100
      REWIND LB                                                         00318200
      IF(0.1+AMIN1(FLOAT(IN(20)),-E(23),E(39),-0.5-E(44)))156,1,1       00318300
C                                                                       00318400
C E-LISTS                                                               00318500
C                                                                       00318600
1     NS=IN(1)                                                          00318700
      WRITE(LI,2)IT                                                     00318800
2     FORMAT(28H1SIGN EXPANSION PATHWAY FOR ,40A1/)                     00318900
      ME=IN(3)+6                                                        00319000
      DO 3 I=ME,KE                                                      00319100
3     E(I)=0.                                                           00319200
      E(ME)=-9.E10                                                      00319300
4     ND=-4                                                             00319400
      NE=ME                                                             00319500
5     READ(LF)F                                                         00319600
      I=1                                                               00319700
6     F(I)=ABS(F(I))                                                    00319800
      IF(F(I)-0.8)21,7,7                                                00319900
7     IF(E(46)-F(I+3))18,8,8                                            00320000
8     P=AMOD(F(I+4),1000.)                                              00320100
      IF(P-E(39))18,9,9                                                 00320200
9     ND=ND+5                                                           00320300
      IF(KD-ND)19,10,10                                                 00320400
10    D(ND)=F(I)                                                        00320500
      D(ND+1)=0.01*P                                                    00320600
      D(ND+2)=0.0001                                                    00320700
      D(ND+3)=P                                                         00320800
      D(ND+4)=0.                                                        00320900
      CALL HKL(F(I),X,Y,Z)                                              00321000
      IF(AMAX1(ABS(X),ABS(Y)).GT.33.5)GOTO 17                           00321100
      DO 16 M=61,NS,12                                                  00321200
      W=ABS(E(M)*X+E(M+3)*Y+E(M+6)*Z+100.*(E(M+1)*X+E(M+4)*Y+           00321300
     *E(M+7)*Z+100.*(E(M+2)*X+E(M+5)*Y+E(M+8)*Z)))+0.1                  00321400
      L=NE+2                                                            00321500
      K=L                                                               00321600
11    K=K-2                                                             00321700
      IF(W-E(K))11,12,12                                                00321800
12    IF(0.2-W+E(K))14,16,16                                            00321900
13    E(L+3)=E(L+1)                                                     00322000
      E(L+2)=E(L)                                                       00322100
14    L=L-2                                                             00322200
      IF(K-L)13,15,15                                                   00322300
15    E(K+2)=W-0.1                                                      00322400
      E(K+3)=FLOAT(ND+1)+AMOD(ABS(E(M+9)*X+E(M+10)*Y+E(M+11)*Z)*2.+     00322500
     *0.1,2.)                                                           00322600
      D(ND+4)=D(ND+4)+P*E(45)                                           00322700
      NE=NE+2                                                           00322800
      IF(KE-NE-3)19,16,16                                               00322900
16    CONTINUE                                                          00323000
      GOTO 18                                                           00323100
17    ND=ND-5                                                           00323200
18    I=I+6                                                             00323300
      IF(LV-I)5,6,6                                                     00323400
19    REWIND LF                                                         00323500
      E(39)=E(39)+0.1                                                   00323600
      WRITE(LI,20)E(39)                                                 00323700
20    FORMAT(32H ** E-MIN TOO LOW - INCREASED TO,F7.3/)                 00323800
      GOTO 4                                                            00323900
C                                                                       00324000
C SIGN EXTENSION PATHWAY                                                00324100
C                                                                       00324200
21    REWIND LF                                                         00324300
      IF(ND)155,22,22                                                   00324400
22    WRITE(LI,23)                                                      00324500
23    FORMAT(8X,28HH  K  L   E   SIGN RELATIONS/)                       00324600
      JJ=IN(2)+97                                                       00324700
      JK=IN(3)                                                          00324800
      DO 26 N=1,ND,5                                                    00324900
      I=JJ                                                              00325000
24    I=I+6                                                             00325100
      IF(I.GT.JK)GOTO 26                                                00325200
      IF(0.4-ABS(D(N)-E(I)))24,25,25                                    00325300
25    D(N+1)=D(N+1)+10000.                                              00325400
26    CONTINUE                                                          00325500
      IN(1)=1                                                           00325600
      DO 27 I=2,660                                                     00325700
27    IN(I)=0                                                           00325800
      DO 28 K=61,NS,12                                                  00325900
      IF(ABS(E(K+7)).GT.0.01)IN(7)=1                                    00326000
      IF(ABS(E(K+2)).GT.0.01)IN(6)=1                                    00326100
      IF(ABS(E(K+3)).GT.0.01)IN(4)=1                                    00326200
      IF(ABS(E(K)*E(K+3))+ABS(E(K+1)*E(K+4)).LT.0.01)GOTO 28            00326300
      IN(2)=1                                                           00326400
      IN(3)=1                                                           00326500
28    CONTINUE                                                          00326600
      NN=MIN0(INT(ABS(E(40))+0.1),20)                                   00326700
      ND=ND+4                                                           00326800
      M=2                                                               00326900
29    N=M                                                               00327000
      Q=-0.001                                                          00327100
30    IF(D(N)-Q)32,32,31                                                00327200
31    Q=D(N)                                                            00327300
      L=N                                                               00327400
32    N=N+5                                                             00327500
      IF(ND-N)33,30,30                                                  00327600
33    IF(Q-QQ)84,34,34                                                  00327700
C                                                                       00327800
C PHIX AND MULTISOLUTION                                                00327900
C                                                                       00328000
34    L=L-M+1                                                           00328100
      S=FLOAT(L+1)                                                      00328200
      O=D(L)                                                            00328300
      CALL HKL(O,X,Y,Z)                                                 00328400
      O=O+0.2                                                           00328500
      IF(M-3)35,46,46                                                   00328600
35    NM=NM+1                                                           00328700
      MW=INT(AMOD(X+98.1,2.)+2.*AMOD(Y+98.1,2.)+4.*AMOD(Z+98.1,2.))     00328800
      IF(NM-40)36,36,83                                                 00328900
36    IF(9000.-D(L+1))37,41,41                                          00329000
37    D(L+1)=AMOD(D(L+1),10000.)                                        00329100
      I=JJ                                                              00329200
38    I=I+6                                                             00329300
      IF(0.4-ABS(D(L)-E(I)))38,39,39                                    00329400
39    IN(NM+29)=INT(E(I+1)*0.01)                                        00329500
      NT=1+IN(NM+29)                                                    00329600
      K=IH                                                              00329700
      IF(E(I+2)-0.1)43,40,40                                            00329800
40    NB=NB+1                                                           00329900
      IN(NB+9)=NM+29                                                    00330000
      NT=3                                                              00330100
      JP=JP+JP                                                          00330200
      IF(NB-NN)45,45,82                                                 00330300
C                                                                       00330400
C ORIGIN                                                                00330500
C                                                                       00330600
41    K=IM                                                              00330700
      IF(IN(MW+1))42,42,40                                              00330800
42    K=IO                                                              00330900
      NT=1                                                              00331000
      IN(NM+29)=0                                                       00331100
43    DO 44 J=1,8                                                       00331200
      I=J-1                                                             00331300
      I=1+MOD(I+MW,2)+2*MOD((I/2)+(MW/2),2)+4*MOD((I/4)+(MW/4),2)       00331400
44    IN(I)=MAX0(IN(I),IN(J))                                           00331500
45    IN(NM+69)=L+1                                                     00331600
C                                                                       00331700
C TRIPLE SIGN RELATIONS                                                 00331800
C                                                                       00331900
46    ASSIGN 47 TO NQ                                                   00332000
      IN(130)=32001                                                     00332100
      NV=130                                                            00332200
      U=0.                                                              00332300
      V=0.                                                              00332400
      W=0.                                                              00332500
      J=NE+2                                                            00332600
      I=ME                                                              00332700
47    I=I+2                                                             00332800
48    J=J-2                                                             00332900
49    IF(I-J)50,53,53                                                   00333000
50    R=O-E(I)-E(J)                                                     00333100
      IF(R)48,51,51                                                     00333200
51    IF(0.4-R)52,59,59                                                 00333300
52    I=I+2                                                             00333400
      GOTO 49                                                           00333500
53    I=ME                                                              00333600
      ASSIGN 54 TO NQ                                                   00333700
54    J=J+2                                                             00333800
      IF(NE-J)70,55,55                                                  00333900
55    I=I+2                                                             00334000
56    R=O-E(J)+E(I)                                                     00334100
      IF(R)55,57,57                                                     00334200
57    IF(0.4-R)58,59,59                                                 00334300
58    J=J+2                                                             00334400
      IF(NE-J)70,56,56                                                  00334500
C                                                                       00334600
C SAVE 10 BEST UNIQUE RELATIONS                                         00334700
C                                                                       00334800
59    IF(AMIN1(ABS(S-E(I+1)),ABS(S-E(J+1)),ABS(E(I+1)-E(J+1)))-2.)      00334900
     *68,60,60                                                          00335000
60    NI=INT(0.2*E(I+1))*5                                              00335100
      NJ=INT(0.2*E(J+1))*5                                              00335200
      IF(3-M)92,62,61                                                   00335300
61    IF(AMAX1(D(NI+3),D(NJ+3)))68,69,69                                00335400
62    IF(AMAX1(D(NI+3),D(NJ+3)))63,69,69                                00335500
63    MW=MIN0(INT(1000.*D(NI+4)*D(NJ+4)),32000)                         00335600
      NJ=NV+3                                                           00335700
      NI=NJ                                                             00335800
64    NJ=NJ-3                                                           00335900
      IF(IN(NJ)-MW)64,68,66                                             00336000
65    IN(NI+5)=IN(NI+2)                                                 00336100
      IN(NI+4)=IN(NI+1)                                                 00336200
      IN(NI+3)=IN(NI)                                                   00336300
66    NI=NI-3                                                           00336400
      IF(NJ-NI)65,67,67                                                 00336500
67    IN(NJ+5)=E(I+1)                                                   00336600
      IN(NJ+4)=E(J+1)                                                   00336700
      IN(NJ+3)=MW                                                       00336800
      NV=MIN0(160,NV+3)                                                 00336900
68    GOTO NQ,(47,54)                                                   00337000
C                                                                       00337100
C ADD RELATIONS TO ARRAYS                                               00337200
C                                                                       00337300
69    T=D(NI+4)*D(NJ+4)*D(L+4)                                          00337400
      P=SIGN(T,D(NI+3)+1.E-6)                                           00337500
      Q=SIGN(T,D(NJ+3)+1.E-6)                                           00337600
      D(NI+2)=D(NI+2)+Q                                                 00337700
      D(NI+3)=D(NI+3)+T-Q                                               00337800
      D(NJ+2)=D(NJ+2)+P                                                 00337900
      D(NJ+3)=D(NJ+3)+T-P                                               00338000
      GOTO NQ,(47,54)                                                   00338100
70    I=130                                                             00338200
      IF(3-M)89,71,74                                                   00338300
71    I=I+3                                                             00338400
      IF(NV-I)74,72,72                                                  00338500
72    NP=NP+2                                                           00338600
      IF(MP-NP)84,84,73                                                 00338700
73    IP(NP)=IN(I+1)                                                    00338800
      IP(NP+1)=IN(I+2)                                                  00338900
      R=0.001*D(L+3)*E(45)*FLOAT(IN(I))                                 00339000
      Q=TANH(0.5*R)*R                                                   00339100
      W=W+V*Q                                                           00339200
      V=V+Q                                                             00339300
      U=U+R*R                                                           00339400
      GOTO 71                                                           00339500
C                                                                       00339600
C PRINT PATHWAY                                                         00339700
C                                                                       00339800
74    IF(M-3)77,75,75                                                   00339900
75    NP=NP+2                                                           00340000
      IP(NP)=-1                                                         00340100
      IP(NP+1)=L+1                                                      00340200
      LD=NP                                                             00340300
      ZE=ZE+SQRT(W+W+U)                                                 00340400
      ZR=ZR+SQRT(U)                                                     00340500
      NT=4                                                              00340600
      IF(NV.EQ.130)K=IW                                                 00340700
      NX=130                                                            00340800
      NJ=130                                                            00340900
76    NJ=NJ+3                                                           00341000
      IF(NJ.GT.NV)GOTO 77                                               00341100
      NX=NX+2                                                           00341200
      NK=(IN(NJ+1)+4)/5                                                 00341300
      IN(NX-1)=JN(NK)                                                   00341400
      NK=(IN(NJ+2)+4)/5                                                 00341500
      IN(NX)=JN(NK)                                                     00341600
      IF(MOD(IN(NJ+1)+IN(NJ+2),5).EQ.0)IN(NX-1)=-IN(NX-1)               00341700
      GOTO 76                                                           00341800
77    D(L+2)=-999999.                                                   00341900
      D(L+1)=-999999.                                                   00342000
      D(L+4)=(ZR+(ZE-ZR)*AMIN1(E(42),FLOAT(NW)*0.01-.5))/E(45)          00342100
      NW=NW+1                                                           00342200
      NI=(L+4)/5                                                        00342300
      JN(NI)=NW                                                         00342400
      IF(NV.LT.140)GOTO 78                                              00342500
      IF(NW.GT.50)GOTO 81                                               00342600
78    NI=X                                                              00342700
      NJ=Y                                                              00342800
      NK=Z                                                              00342900
      IF(NV.EQ.130)WRITE(LI,79)NW,NI,NJ,NK,D(L+3),K,IS(NT)              00343000
79    FORMAT(I4,I5,2I3,F6.3,2X,A4,A2)                                   00343100
      IF(NV.NE.130)WRITE(LI,80)NW,NI,NJ,NK,D(L+3),(IN(NT),NT=131,NX)    00343200
80    FORMAT(I4,I5,2I3,F6.3,10(I6,1H*,I3))                              00343300
81    IF(6*NW-ND)29,84,84                                               00343400
82    NB=NB-1                                                           00343500
      JP=JP/2                                                           00343600
83    NM=NM-1                                                           00343700
      QQ=1.5                                                            00343800
84    M=M+1                                                             00343900
      IF(3-M)85,29,29                                                   00344000
C                                                                       00344100
C QUARTETS                                                              00344200
C                                                                       00344300
85    S=-999.                                                           00344400
      MQ=130                                                            00344500
      K=ME+2                                                            00344600
      DO 86 L=628,660                                                   00344700
86    IN(L)=K                                                           00344800
      DO 87 L=K,NE,2                                                    00344900
      N=MIN0(INT((E(L)+.2)*.0001),32)                                   00345000
87    IN(N+628)=L+2                                                     00345100
88    READ(LF)F                                                         00345200
      MW=-5                                                             00345300
89    MW=MW+6                                                           00345400
      IF(LV-MW)88,90,90                                                 00345500
90    O=ABS(F(MW))+0.2                                                  00345600
      IF(O-1.)105,91,91                                                 00345700
91    Z=AMOD(F(MW+4),10.)                                               00345800
      IF(Z-.2)46,89,89                                                  00345900
92    Y=ABS(E(J)+0.4-O-O)+0.2                                           00346000
      X=D(NI+4)*D(NI+4)                                                 00346100
      N=J                                                               00346200
93    NN=E(N+1)                                                         00346300
      IF(D(NN)+9999.)94,103,103                                         00346400
94    L=MIN0(INT(Y*.0001),32)                                           00346500
      L=IN(L+628)                                                       00346600
95    L=L-2                                                             00346700
      IF(Y-E(L))95,96,96                                                00346800
96    IF(Y-E(L)-0.4)97,103,103                                          00346900
97    JJ=E(L+1)                                                         00347000
      IF(D(JJ)+9999.)98,103,103                                         00347100
98    NT=INT(100.*(X+Z*(Z-2.*X*Z)))                                     00347200
      NK=MQ+3                                                           00347300
      K=NK                                                              00347400
99    NK=NK-3                                                           00347500
      IF(IN(NK)-NT)99,103,101                                           00347600
100   IN(K+5)=IN(K+2)                                                   00347700
      IN(K+4)=IN(K+1)                                                   00347800
      IN(K+3)=IN(K)                                                     00347900
101   K=K-3                                                             00348000
      IF(NK-K)100,102,102                                               00348100
102   IN(NK+3)=NT                                                       00348200
      IN(NK+4)=NN                                                       00348300
      IN(NK+5)=JJ                                                       00348400
      MQ=MIN0(622,MQ+3)                                                 00348500
103   IF(N-J)68,104,68                                                  00348600
104   N=I                                                               00348700
      Y=O+E(J)                                                          00348800
      X=D(NJ+4)*D(NJ+4)                                                 00348900
      GOTO 93                                                           00349000
C                                                                       00349100
C SET UP TESTS                                                          00349200
C                                                                       00349300
105   NP=((LD+1)/2)-NW+NM                                               00349400
      NN=(MQ-130)/3                                                     00349500
106   FORMAT(1H1,40A1///12H EXPANDED TO,I5,12H SIGNS USING,I6,          00349600
     *10H RELATIONS//I8,13H PERMUTATIONS,I10,9H QUARTETS/)              00349700
      WRITE(LI,106)IT,NW,NP,JP,NN                                       00349800
      NS=MIN0(INT(E(41)),(KE-400)/MAX0(NN,1))                           00349900
      REWIND LF                                                         00350000
      MW=7                                                              00350100
      ZE=(ZE-ZR)/E(45)                                                  00350200
      ZR=ZR/E(45)                                                       00350300
      E(7)=999.                                                         00350400
      S=0.                                                              00350500
      T=0.                                                              00350600
      N=130                                                             00350700
107   N=N+3                                                             00350800
      IF(MQ-N)109,108,108                                               00350900
108   J=(IN(N+1)/5)*5+4                                                 00351000
      K=(IN(N+2)/5)*5+4                                                 00351100
      P=D(J)*D(K)                                                       00351200
      T=T+P*FLOAT(IN(N))                                                00351300
      S=S+P*P                                                           00351400
      GOTO 107                                                          00351500
109   P=T*E(43)                                                         00351600
      R=S*0.2                                                           00351700
C                                                                       00351800
C EVALUATE PERMUTATIONS                                                 00351900
C                                                                       00352000
      ASSIGN 120 TO NU                                                  00352100
      ASSIGN 110 TO NQ                                                  00352200
      JJ=0                                                              00352300
110   JJ=JJ+1                                                           00352400
      IF(JP-JJ)129,111,111                                              00352500
111   K=JJ-1                                                            00352600
      DO 112 I=1,NB                                                     00352700
      J=IN(I+9)                                                         00352800
      IN(J)=MOD(K,2)                                                    00352900
112   K=K/2                                                             00353000
      DO 113 I=1,NM                                                     00353100
      J=IN(I+69)                                                        00353200
      X=SIGN(D(J+2),0.5-FLOAT(IN(I+29)))                                00353300
      D(J)=X                                                            00353400
113   D(J+1)=-X                                                         00353500
      M=-1                                                              00353600
      N=NM                                                              00353700
      Z=0.                                                              00353800
114   X=0.                                                              00353900
      N=N+1                                                             00354000
      IF(NW-N)119,116,116                                               00354100
115   X=X+D(I)*D(J)                                                     00354200
116   M=M+2                                                             00354300
      J=IP(M+1)                                                         00354400
      I=IP(M)                                                           00354500
      IF(I)117,117,115                                                  00354600
117   D(J)=SIGN(D(J+2),X+0.0001)                                        00354700
      D(J+1)=-D(J)                                                      00354800
      Z=Z+ABS(X*D(J+2))                                                 00354900
      IF(Z-D(J+3))118,114,114                                           00355000
118   N=MIN0(110+MAX0(0,N-41)/10,129)                                   00355100
      IN(N)=IN(N)+1                                                     00355200
      GOTO NQ,(110,140)                                                 00355300
C                                                                       00355400
C QUARTET AND SIMILARITY TESTS                                          00355500
C                                                                       00355600
119   GOTO NU,(120,141)                                                 00355700
120   X=0.                                                              00355800
      N=130                                                             00355900
121   N=N+3                                                             00356000
      IF(MQ-N)123,122,122                                               00356100
122   J=IN(N+1)                                                         00356200
      K=IN(N+2)                                                         00356300
      X=X+D(J)*D(K)*FLOAT(IN(N))                                        00356400
      GOTO 121                                                          00356500
123   IF(P-X)110,124,124                                                00356600
124   Y=(Z-ZR)/ZE                                                       00356700
      X=1.-X/T                                                          00356800
      X=X*X+AMIN1(Y*Y,1.)                                               00356900
      J=MW+2                                                            00357000
      I=J                                                               00357100
125   J=J-2                                                             00357200
      IF(E(J)-X)125,127,127                                             00357300
126   E(I+3)=E(I+1)                                                     00357400
      E(I+2)=E(I)                                                       00357500
127   I=I-2                                                             00357600
      IF(J-I)126,128,128                                                00357700
128   E(J+3)=JJ                                                         00357800
      E(J+2)=X                                                          00357900
      MW=MIN0(397,MW+2)                                                 00358000
      GOTO 110                                                          00358100
129   K=MIN0(19,(NW-41)/10)+110                                         00358200
      DO 130 I=110,129                                                  00358300
      JP=JP-IN(I)                                                       00358400
130   IN(I)=JP                                                          00358500
131   FORMAT(//12H M(ABS) TEST//14H SURVIVORS    ,20I5)                 00358600
      WRITE(LI,131)(IN(I),I=110,K)                                      00358700
132   FORMAT(/14H SIGNS FOUND  ,20I5)                                   00358800
      J=50                                                              00358900
      DO 133 I=110,129                                                  00359000
      IN(I)=J                                                           00359100
133   J=J+10                                                            00359200
      IN(K)=NW                                                          00359300
      WRITE(LI,132)(IN(I),I=110,K)                                      00359400
      IF(MW.GT.8)GOTO 136                                               00359500
      WRITE(LI,134)                                                     00359600
134   FORMAT(//15H ** NO SOLUTION//                                     00359700
     *42H RERUN WITH LOWER M(MIN) AND QT(MAX) = 1.0)                    00359800
      GOTO 155                                                          00359900
135   FORMAT(/14H 1000*M(MIN)  ,20I5)                                   00360000
136   DO 137 I=110,129                                                  00360100
137   IN(I)=MIN0(10*IN(I)-500,850)                                      00360200
      WRITE(LI,135)(IN(I),I=110,K)                                      00360300
138   FORMAT(///42H EMAP  PARACHOR M(ABS)   NQT   PERMUTATION/)         00360400
      WRITE(LI,138)                                                     00360500
      DO 139 I=2,ND,5                                                   00360600
139   D(I)=0.                                                           00360700
C                                                                       00360800
C FINAL EXPANSION                                                       00360900
C                                                                       00361000
      ASSIGN 140 TO NQ                                                  00361100
      ASSIGN 141 TO NU                                                  00361200
      NT=1                                                              00361300
      NK=401                                                            00361400
      JP=7                                                              00361500
140   JP=JP+2                                                           00361600
      JJ=E(JP+1)                                                        00361700
      IF(MW-JP)155,111,111                                              00361800
141   NI=401                                                            00361900
      N=130                                                             00362000
      Q=0.                                                              00362100
142   N=N+3                                                             00362200
      IF(MQ-N)144,143,143                                               00362300
143   J=IN(N+1)                                                         00362400
      K=IN(N+2)                                                         00362500
      E(NK)=D(J)*D(K)                                                   00362600
      Q=Q+E(NK)*FLOAT(IN(N))                                            00362700
      NK=NK+1                                                           00362800
      GOTO 142                                                          00362900
144   NK=NK-NN                                                          00363000
145   IF(NK-NI)148,148,146                                              00363100
146   X=0.                                                              00363200
      DO 147 N=133,MQ,3                                                 00363300
      Y=E(NI)*E(NK)                                                     00363400
      X=X+ABS(Y-ABS(Y))                                                 00363500
      NI=NI+1                                                           00363600
147   NK=NK+1                                                           00363700
      NK=NK-NN                                                          00363800
      IF(X-R)140,145,145                                                00363900
C                                                                       00364000
C OUTPUT RESULTS                                                        00364100
C                                                                       00364200
148   M=-4                                                              00364300
      Q=Q/T                                                             00364400
      X=(Z-ZR)/ZE                                                       00364500
      DO 149 I=1,NM                                                     00364600
      J=IN(I+29)                                                        00364700
149   IT(I)=IS(J+1)                                                     00364800
150   FORMAT(I5,3F8.3,2X,45A2)                                          00364900
      WRITE(LI,150)NT,E(JP),X,Q,(IT(I),I=1,NM)                          00365000
151   DO 153 I=1,LV,6                                                   00365100
      M=M+5                                                             00365200
      IF(ND-M)154,152,152                                               00365300
152   F(I)=D(M)                                                         00365400
      F(I+1)=D(M+3)                                                     00365500
      F(I+2)=ABS(D(M+1)/D(M+3))                                         00365600
      F(I+3)=0.                                                         00365700
      F(I+4)=D(M+1)                                                     00365800
153   F(I+5)=0.                                                         00365900
      WRITE(LA)F                                                        00366000
      GOTO 151                                                          00366100
154   F(I)=-0.1                                                         00366200
      WRITE(LA)F                                                        00366300
      NK=NK+NN                                                          00366400
      NT=NT+1                                                           00366500
      IF(NS-NT)155,140,140                                              00366600
155   F(1)=-1.E10                                                       00366700
      WRITE(LA)F                                                        00366800
      ENDFILE LA                                                        00366900
      REWIND LA                                                         00367000
156   RETURN                                                            00367100
      END                                                               00367200
C                                                                       00367300
      SUBROUTINE XTPR                                                   00367400
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NB,ND,NP,NS,MM,     00367500
     *MP,JM,NM,CS,FT,F(84),IT(40),IN(660),C(6600),JN(160),E(1)          00367600
      READ(LB)IT,JN,IN,(C(I),I=1,1740)                                  00367700
      REWIND LB                                                         00367800
      FT=AMIN1(FLOAT(IN(20)),C(39),98.-C(40),C(44))                     00367900
      IF(FT.LT.-.1)GOTO 45                                              00368000
      IF(C(42).GT.1.E-5)FT=9.E9                                         00368100
      NS=IN(1)                                                          00368200
      NC=IN(3)+6                                                        00368300
      NB=NC+10                                                          00368400
C                                                                       00368500
C EXPANDED ATOM LIST                                                    00368600
C                                                                       00368700
      SS=0.                                                             00368800
      WX=0.                                                             00368900
      I=17                                                              00369000
      K=IN(5)+1                                                         00369100
      JE=-2                                                             00369200
1     I=I+4                                                             00369300
      IF(I.GT.IN(6))GOTO 3                                              00369400
      M=NS+14+103*((IN(I+2)-12)/2)                                      00369500
      DO 2 J=61,NS,12                                                   00369600
      JE=JE+4                                                           00369700
      E(JE)=C(25)*C(M)*C(K+3)                                           00369800
      E(JE+1)=6.283185*(C(J)*C(K)+C(J+1)*C(K+1)+C(J+2)*C(K+2)+C(J+9))   00369900
      E(JE+2)=6.283185*(C(J+3)*C(K)+C(J+4)*C(K+1)+C(J+5)*C(K+2)+C(J+10))00370000
      E(JE+3)=6.283185*(C(J+6)*C(K)+C(J+7)*C(K+1)+C(J+8)*C(K+2)+C(J+11))00370100
      WX=WX+E(JE)*C(M)*C(M)                                             00370200
2     SS=SS+E(JE)*C(M)                                                  00370300
      K=K+IN(I)                                                         00370400
      GOTO 1                                                            00370500
3     XP=SS/C(58)                                                       00370600
      WX=2.*WX/(C(58)*SQRT(C(58)))                                      00370700
      SS=2.*C(58)/AMAX1(0.001,C(58)-SS)                                 00370800
      E(1)=0.                                                           00370900
      ME=LM-LV-7478+(429*LU)                                            00371000
      DO 4 M=61,NS,12                                                   00371100
      I=M+6                                                             00371200
      DO 4 J=M,I,3                                                      00371300
4     C(J)=C(J)+100.*(C(J+1)+100.*C(J+2))                               00371400
5     ND=NC                                                             00371500
      NE=1                                                              00371600
      DO 6 I=NC,6600,1                                                  00371700
6     C(I)=0.                                                           00371800
C                                                                       00371900
C SORT E VALUES, AVERAGE FRIEDEL PAIRS                                  00372000
C                                                                       00372100
7     READ(LF)F                                                         00372200
      DO 12 I=1,LV,6                                                    00372300
      IF(0.8.GT.ABS(F(I)))GOTO 16                                       00372400
      IF(F(I+3).GT.C(46))GOTO 12                                        00372500
      P=AMOD(F(I+4),1000.)                                              00372600
      IF(C(39).GT.P)GOTO 12                                             00372700
      CALL HKL(F(I),X,Y,Z)                                              00372800
      IF(AMAX1(ABS(X),ABS(Y)).GT.33.5)GOTO 12                           00372900
      S=-1.                                                             00373000
      DO 8 J=61,NS,12                                                   00373100
8     S=AMAX1(S,0.2+ABS(X*C(J)+Y*C(J+3)+Z*C(J+6)))                      00373200
      J=ND+10                                                           00373300
      K=J                                                               00373400
9     J=J-10                                                            00373500
      IF(C(J).GT.S)GOTO 9                                               00373600
      IF(S.GT.(C(J)+0.4))GOTO 11                                        00373700
      W=C(J+4)+F(I+2)                                                   00373800
      C(J+1)=(C(J+1)*F(I+2)+P*C(J+4))/W                                 00373900
      C(J+4)=W                                                          00374000
      GOTO 12                                                           00374100
10    C(K+14)=C(K+4)                                                    00374200
      C(K+11)=C(K+1)                                                    00374300
      C(K+10)=C(K)                                                      00374400
11    K=K-10                                                            00374500
      IF(K.GT.J)GOTO 10                                                 00374600
      C(J+10)=S-0.2                                                     00374700
      C(J+11)=P                                                         00374800
      C(J+14)=F(I+2)                                                    00374900
      ND=ND+10                                                          00375000
      IF(ND.GT.6564)GOTO 15                                             00375100
12    CONTINUE                                                          00375200
      GOTO 7                                                            00375300
C                                                                       00375400
C E(MIN) TOO SMALL                                                      00375500
C                                                                       00375600
13    IF(FT.LT.8.E9)GOTO 15                                             00375700
      FT=-1.                                                            00375800
      WRITE(LI,14)                                                      00375900
14    FORMAT(//40H ** TOO MANY REFLEXIONS - INCREASE E-MIN)             00376000
      C(41)=0.                                                          00376100
      F(1)=-9.E10                                                       00376200
      GOTO 36                                                           00376300
15    REWIND LF                                                         00376400
      C(39)=C(39)+0.1                                                   00376500
      FT=9.E9                                                           00376600
      GOTO 5                                                            00376700
C                                                                       00376800
C POINT ATOM PHASES                                                     00376900
C                                                                       00377000
16    IF(1.E-5.GT.C(42))GOTO 23                                         00377100
      IF(JE.LT.0)GOTO 23                                                00377200
      R=0.                                                              00377300
      S=0.                                                              00377400
      DO 18 I=NB,ND,10                                                  00377500
      CALL HKL(C(I),X,Y,Z)                                              00377600
      P=0.                                                              00377700
      Q=0.                                                              00377800
      DO 17 J=2,JE,4                                                    00377900
      T=E(J+1)*X+E(J+2)*Y+E(J+3)*Z                                      00378000
      P=P+E(J)*COS(T)                                                   00378100
17    Q=Q+E(J)*SIN(T)                                                   00378200
      Q=Q*C(23)                                                         00378300
      C(I+6)=SQRT((P*P+Q*Q)/C(58))                                      00378400
      W=C(I+6)*C(I+1)*SS                                                00378500
      C(I+4)=AMIN1(W*.5658+W*(W*.0106-.1304),W/(W+.56))                 00378600
      R=R+ABS(C(I+4)*C(I+1)-C(I+6))                                     00378700
      S=S+C(I+1)                                                        00378800
      C(I+5)=.125+AMOD(59.91667+4.774648*ATAN2(Q,P),30.)                00378900
18    CONTINUE                                                          00379000
      Q=0.5                                                             00379100
19    P=-1.                                                             00379200
      DO 20 I=NB,ND,10                                                  00379300
      IF(P.GT.C(I+4))GOTO 20                                            00379400
      P=C(I+4)                                                          00379500
      J=I                                                               00379600
20    CONTINUE                                                          00379700
      IF(P.LT.0.01)GOTO 21                                              00379800
      C(J)=-C(J)                                                        00379900
      C(J+2)=10000.                                                     00380000
      C(J+4)=0.                                                         00380100
      C(J+3)=C(J+5)                                                     00380200
      Q=Q+1.                                                            00380300
      IF(C(42).GT.Q)GOTO 19                                             00380400
21    R=R/S                                                             00380500
      WRITE(LI,22)R,XP                                                  00380600
22    FORMAT(///4H R =,F7.4,4H FOR,F7.4,20H OF SCATTERING POWER)        00380700
C                                                                       00380800
C EXPANDED LIST AND PHASE RESTRICTIONS                                  00380900
C                                                                       00381000
23    P=0.01                                                            00381100
      REWIND LF                                                         00381200
      DO 28 I=NB,ND,10                                                  00381300
      P=P+1.                                                            00381400
      Q=ABS(C(I))                                                       00381500
      CALL HKL(Q,X,Y,Z)                                                 00381600
      DO 28 M=61,NS,12                                                  00381700
      W=X*C(M)+Y*C(M+3)+Z*C(M+6)                                        00381800
      Q=1.-C(23)*(1.-SIGN(1.,W))                                        00381900
      S=Q*(P+AMOD(100.004-Q*(X*C(M+9)+Y*C(M+10)+Z*C(M+11)),1.))         00382000
      W=ABS(W)+0.2                                                      00382100
      L=NE+2                                                            00382200
      K=L                                                               00382300
24    K=K-2                                                             00382400
      IF(E(K).GT.W)GOTO 24                                              00382500
      IF(0.4+E(K)-W)26,27,27                                            00382600
25    E(L+3)=E(L+1)                                                     00382700
      E(L+2)=E(L)                                                       00382800
26    L=L-2                                                             00382900
      IF(L.GT.K)GOTO 25                                                 00383000
      E(K+2)=W-0.2                                                      00383100
      E(K+3)=S                                                          00383200
      NE=NE+2                                                           00383300
      IF(ME-NE)13,28,28                                                 00383400
27    IF((E(K+1)*S).GT.0.)GOTO 28                                       00383500
      IF(C(I).GT.0.)C(I+3)=AMOD(100.01-S-E(K+1),1.)+2.                  00383600
28    CONTINUE                                                          00383700
C                                                                       00383800
C DERIVE TPR                                                            00383900
C                                                                       00384000
      NR=0                                                              00384100
      FT=9.E9                                                           00384200
      WW=ABS(C(40))                                                     00384300
      E(NE+2)=220440.                                                   00384400
      DO 29 I=1,NE,2                                                    00384500
      N=MIN0(660,INT(0.003*E(I)+21.1))                                  00384600
      M=MIN0(660,INT(0.003*E(I+2)+21.1))                                00384700
      NL=MAX0(3,I)                                                      00384800
      DO 29 L=N,M                                                       00384900
29    IN(L)=NL                                                          00385000
      P=0.1                                                             00385100
      M=1                                                               00385200
      NL=0                                                              00385300
      N=INT(1.1-2.2*C(23))                                              00385400
      ASSIGN 30 TO NQ                                                   00385500
      L=NB-10                                                           00385600
30    P=P+1.                                                            00385700
      NL=NL+1                                                           00385800
      IF(NR.GT.20000)GOTO 13                                            00385900
      L=L+10                                                            00386000
      IF(L.GT.ND)GOTO 35                                                00386100
31    W=C(45)*C(L+1)                                                    00386200
      SK=0.                                                             00386300
      SG=0.                                                             00386400
      I=1                                                               00386500
      K=MIN0(660,INT(0.003*ABS(C(L))+21.1))                             00386600
      J=IN(K)                                                           00386700
32    I=I+2                                                             00386800
33    IF(I.EQ.J)GOTO NQ,(30,38)                                         00386900
      X=ABS(C(L))-E(I)-E(J)                                             00387000
      IF(X.GT.0.5)GOTO 32                                               00387100
      IF(X.GT.-0.5)GOTO 34                                              00387200
      J=J-2                                                             00387300
      GOTO 33                                                           00387400
34    NI=E(I+1)                                                         00387500
      NJ=E(J+1)                                                         00387600
      NM=IABS(NI)*10+NC                                                 00387700
      NN=IABS(NJ)*10+NC                                                 00387800
      T=W*C(NN+1)*C(NM+1)                                               00387900
      IF(JE.GT.0)T=T*(1.+(2.*C(NN+6)*C(NM+6)*C(L+6)*                    00388000
     *COS(.2094395*(C(NN+5)+C(NM+5)+C(L+5)-0.125))-WX)/C(45))           00388100
      IF(WW.GT.T)GOTO 32                                                00388200
      IF(NL.EQ.NI)GOTO 32                                               00388300
      IF(NL.EQ.NJ)GOTO 32                                               00388400
      IF(NI.EQ.NJ*N)GOTO 32                                             00388500
      NR=NR+1                                                           00388600
      S=T*T                                                             00388700
      T=AMIN1(S*(.5658+T*(T*.0106-.1304)),S/(T+.56))                    00388800
      F(M)=AMIN1(32000.,1000.*T+0.5)                                    00388900
      SK=SK+S+SG*T                                                      00389000
      SG=SG+T+T                                                         00389100
      F(M+1)=P+1000.*AINT(24.*AMOD(ABS(E(I+1))+ABS(E(J+1)),1.))         00389200
      F(M+2)=-E(I+1)                                                    00389300
      F(M+3)=-E(J+1)                                                    00389400
      M=M+4                                                             00389500
      IF(LV.GT.M-1)GOTO 32                                              00389600
      IF(L.GT.ND)GOTO 37                                                00389700
      WRITE(LA)F                                                        00389800
      M=1                                                               00389900
      GOTO 32                                                           00390000
35    F(M)=-9999.                                                       00390100
36    WRITE(LA)F                                                        00390200
      ENDFILE LA                                                        00390300
      REWIND LA                                                         00390400
C                                                                       00390500
C TPR FOR RA                                                            00390600
C                                                                       00390700
      IF(ABS(C(41)).LT.0.5)GOTO 42                                      00390800
      JE=-1                                                             00390900
      WW=0.                                                             00391000
      M=1                                                               00391100
      ASSIGN 38 TO NQ                                                   00391200
      P=0.1                                                             00391300
      GOTO 40                                                           00391400
37    M=M-4                                                             00391500
38    F(M)=-1.                                                          00391600
      IF(M.GT.6)F(M)=-1000.*SQRT(SK)/(C(45)*C(L+1))                     00391700
      WRITE(LC)F                                                        00391800
      M=1                                                               00391900
39    L=L+2                                                             00392000
      IF(L.LT.JO)GOTO 31                                                00392100
40    L=ND+8                                                            00392200
      JO=L+2                                                            00392300
      READ(LF)F                                                         00392400
      DO 41 I=1,LV,6                                                    00392500
      IF(0.5.GT.ABS(F(I)))GOTO 42                                       00392600
      C(JO+1)=AMOD(F(I+4),1000.)                                        00392700
      IF((C(JO+1)-1.5)*(0.2-C(JO+1)).GT.0.)GOTO 41                      00392800
      IF(C(JO+1).LT.0.01)GOTO 41                                        00392900
      C(JO)=F(I)                                                        00393000
      JO=JO+2                                                           00393100
41    CONTINUE                                                          00393200
      GOTO 39                                                           00393300
42    F(1)=-9.E9                                                        00393400
      WRITE(LC)F                                                        00393500
      ENDFILE LC                                                        00393600
      REWIND LC                                                         00393700
      REWIND LF                                                         00393800
C                                                                       00393900
C FLAG PHIX                                                             00394000
C                                                                       00394100
      DO 44 L=NB,ND,10                                                  00394200
      X=ABS(C(L))                                                       00394300
      C(L+1)=C(L+1)+AINT(12.*C(L+3))*10.                                00394400
      N=IN(2)+97                                                        00394500
43    N=N+6                                                             00394600
      IF(N.GT.IN(3))GOTO 44                                             00394700
      IF(ABS(C(N)-X).GT.0.5)GOTO 43                                     00394800
      C(L+2)=20000.                                                     00394900
44    C(L+4)=0.                                                         00395000
45    RETURN                                                            00395100
      END                                                               00395200
C                                                                       00395300
      SUBROUTINE CONV                                                   00395400
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NB,ND,NP,NS,MM,     00395500
     *MP,JM,NM,CS,FT,F(84),IT(40),IN(660),C(6600),IP(1)                 00395600
      DATA IA/1H+/,IM/1H-/                                              00395700
      IF(FT.LT.-.1)GOTO 52                                              00395800
      MP=(((LU+1)*(LM+(349*LU)-LV-7323))/4)*4+1                         00395900
      NT=0                                                              00396000
      JM=IN(2)+97                                                       00396100
      NM=IN(3)                                                          00396200
      I=1                                                               00396300
      DO 1 J=NB,ND,10                                                   00396400
      C(J+3)=I                                                          00396500
      IN(I)=J                                                           00396600
1     I=I+1                                                             00396700
C                                                                       00396800
C FIND UNIQUE TPRS                                                      00396900
C                                                                       00397000
      MQ=32000                                                          00397100
      IP(1)=32000                                                       00397200
      NP=1                                                              00397300
2     READ(LA)F                                                         00397400
      DO 6 I=1,LV,4                                                     00397500
      IF(F(I).LT.0.)GOTO 7                                              00397600
      L=F(I)                                                            00397700
      IF(L.GT.MQ)GOTO 6                                                 00397800
      NI=F(I+1)                                                         00397900
      NJ=F(I+2)                                                         00398000
      NK=F(I+3)                                                         00398100
      NN=MOD(NI,1000)                                                   00398200
      J=IABS(NJ)                                                        00398300
      K=IABS(NK)                                                        00398400
      IF(MAX0(IN(NN),IN(J),IN(K)).GT.ND)GOTO 6                          00398500
      NN=NN+J+K                                                         00398600
      J=NP+4                                                            00398700
      K=J                                                               00398800
3     J=J-4                                                             00398900
      IF(L.GT.IP(J))GOTO 3                                              00399000
      IF(IP(J).GT.L)GOTO 5                                              00399100
      IF((MOD(IP(J+1),1000)+IABS(IP(J+2))+IABS(IP(J+3))).EQ.NN)GOTO 6   00399200
      IF(IP(J-4)-L)5,3,5                                                00399300
4     IP(K+7)=IP(K+3)                                                   00399400
      IP(K+6)=IP(K+2)                                                   00399500
      IP(K+5)=IP(K+1)                                                   00399600
      IP(K+4)=IP(K)                                                     00399700
5     K=K-4                                                             00399800
      IF(K.GT.J)GOTO 4                                                  00399900
      IP(J+4)=L                                                         00400000
      IP(J+5)=NI                                                        00400100
      IP(J+6)=NJ                                                        00400200
      IP(J+7)=NK                                                        00400300
      NP=MIN0(NP+4,MP)                                                  00400400
6     CONTINUE                                                          00400500
      GOTO 2                                                            00400600
7     REWIND LA                                                         00400700
      MQ=MIN0(MQ,IP(NP)-1)                                              00400800
C                                                                       00400900
C ALPHA LIST                                                            00401000
C                                                                       00401100
      DO 8 I=NB,ND,10                                                   00401200
8     C(I+4)=C(I+2)                                                     00401300
      DO 9 I=5,NP,4                                                     00401400
      P=0.001*FLOAT(IP(I))                                              00401500
      NI=MOD(IP(I+1),1000)                                              00401600
      NJ=IABS(IP(I+2))                                                  00401700
      NK=IABS(IP(I+3))                                                  00401800
      NI=IN(NI)+4                                                       00401900
      NJ=IN(NJ)+4                                                       00402000
      NK=IN(NK)+4                                                       00402100
      IF((NI-NJ)*(NI-NK).NE.0)C(NI)=C(NI)+P                             00402200
      IF((NI-NJ)*(NJ-NK).NE.0)C(NJ)=C(NJ)+P                             00402300
9     IF((NI-NK)*(NJ-NK).NE.0)C(NK)=C(NK)+P                             00402400
      DO 10 I=NB,ND,10                                                  00402500
10    C(I+5)=C(I+4)                                                     00402600
      NT=NT+1                                                           00402700
      NJ=ND                                                             00402800
      NK=NP                                                             00402900
      IF(NT.EQ.5)GOTO 20                                                00403000
C                                                                       00403100
C ELIMINATE SMALLEST BETA                                               00403200
C                                                                       00403300
      ASSIGN 11 TO NQ                                                   00403400
      NL=((NB-ND)/200)*10+ND                                            00403500
      ND=ND+10                                                          00403600
11    ND=ND-10                                                          00403700
      IF(ND.EQ.NL)GOTO 2                                                00403800
      NJ=ND                                                             00403900
12    U=9.E8                                                            00404000
      DO 14 I=NB,NJ,10                                                  00404100
      V=C(I+5)                                                          00404200
      IF(C(I).LT.0.)GOTO 13                                             00404300
      IF(C(I+1).GT.10.)V=V+V                                            00404400
13    IF(V.GT.U)GOTO 14                                                 00404500
      K=I                                                               00404600
      U=V                                                               00404700
14    CONTINUE                                                          00404800
      M=K+5                                                             00404900
      J=NJ                                                              00405000
      DO 15 L=K,M                                                       00405100
      P=C(L)                                                            00405200
      C(L)=C(J)                                                         00405300
      C(J)=P                                                            00405400
15    J=J+1                                                             00405500
      J=C(K+3)                                                          00405600
      I=C(NJ+3)                                                         00405700
      IN(I)=NJ                                                          00405800
      IN(J)=K                                                           00405900
C                                                                       00406000
C SORT TPRS                                                             00406100
C                                                                       00406200
      K=1                                                               00406300
16    K=K+4                                                             00406400
17    IF(K.GT.NP)GOTO NQ,(11,21)                                        00406500
      L=MOD(IP(K+1),1000)                                               00406600
      M=IABS(IP(K+2))                                                   00406700
      N=IABS(IP(K+3))                                                   00406800
      IF(L.EQ.I)GOTO 18                                                 00406900
      MZ=L                                                              00407000
      L=M                                                               00407100
      M=MZ                                                              00407200
      IF(L.EQ.I)GOTO 18                                                 00407300
      MZ=L                                                              00407400
      L=N                                                               00407500
      N=MZ                                                              00407600
      IF(L.NE.I)GOTO 16                                                 00407700
18    P=0.001*FLOAT(IP(K))                                              00407800
      MZ=IN(M)                                                          00407900
      IF((M-L)*(M-N).NE.0)C(MZ+5)=C(MZ+5)-P                             00408000
      MZ=IN(N)                                                          00408100
      IF((N-L)*(M-N).NE.0)C(MZ+5)=C(MZ+5)-P                             00408200
      M=NP+3                                                            00408300
      J=K                                                               00408400
      DO 19 L=NP,M                                                      00408500
      MZ=IP(L)                                                          00408600
      IP(L)=IP(J)                                                       00408700
      IP(J)=MZ                                                          00408800
19    J=J+1                                                             00408900
      NP=NP-4                                                           00409000
      GOTO 17                                                           00409100
20    ASSIGN 21 TO NQ                                                   00409200
      GOTO 12                                                           00409300
21    NJ=NJ-10                                                          00409400
      IF(NJ.NE.NB)GOTO 12                                               00409500
      NP=NK                                                             00409600
C                                                                       00409700
C PHIX                                                                  00409800
C                                                                       00409900
      MM=NB-10                                                          00410000
      NS=MM                                                             00410100
      I=JM                                                              00410200
22    I=I+6                                                             00410300
      IF(I.GT.NM)GOTO 27                                                00410400
      IF(0.5.GT.ABS(C(I)))GOTO 22                                       00410500
      DO 23 J=NB,ND,10                                                  00410600
      IF(ABS(ABS(C(J))-C(I)).LT.0.5)GOTO 25                             00410700
23    CONTINUE                                                          00410800
      CALL HKL(C(I),X,Y,Z)                                              00410900
      WRITE(LI,24)X,Y,Z                                                 00411000
24    FORMAT(/8H ** PHIX,3F6.0,14H NOT IN E LIST)                       00411100
      J=MM                                                              00411200
25    C(I)=J                                                            00411300
      NS=MAX0(J,NS)                                                     00411400
      GOTO 22                                                           00411500
26    FORMAT(//I5,23H REFLEXIONS    E(MIN) =,F7.3/)                     00411600
27    N=(ND-MM)/10                                                      00411700
      WRITE(LI,26)N,C(39)                                               00411800
C                                                                       00411900
C PRINT ALPHA LIST                                                      00412000
C                                                                       00412100
      N=ND                                                              00412200
      IF(C(40).GT.0.)N=MIN0(N,NB+490)                                   00412300
      DO 31 I=NB,ND,10                                                  00412400
      IF(C(I+5).GT.2.)GOTO 31                                           00412500
      L=(I-MM)/10                                                       00412600
      N=MAX0(N,MIN0(ND,I+90))                                           00412700
      IF(C(I+5).LT.0.01)GOTO 29                                         00412800
      WRITE(LI,28)L                                                     00412900
28    FORMAT(/22H ** WEAK LINK AT PHASE,I4)                             00413000
      GOTO 31                                                           00413100
29    WRITE(LI,30)L                                                     00413200
30    FORMAT(/24H ** PATH BROKEN AT PHASE,I4)                           00413300
31    IF(C(I).LT.0.)NS=MAX0(I,NS)                                       00413400
      WRITE(LI,32)                                                      00413500
32    FORMAT(53H1 CODE  H   K   L     E    ALPHA  OMEGA  RESTRICTIONS/) 00413600
      L=1                                                               00413700
      DO 36 I=NB,N,10                                                   00413800
      P=ABS(C(I))                                                       00413900
      CALL HKL(P,X,Y,Z)                                                 00414000
      NI=X                                                              00414100
      NJ=Y                                                              00414200
      NK=Z                                                              00414300
      X=AMOD(C(I+1),10.)                                                00414400
      Y=AMOD(C(I+4),10000.)                                             00414500
      J=INT(C(I+1)*0.1-23.9)*15                                         00414600
      K=J+180                                                           00414700
      IF(C(I).LT.0.)J=-1                                                00414800
      IF(C(I+4).GT.19900.)C(I)=P                                        00414900
      P=ABS(AMOD(C(I+5)+99.,10000.)-99.)                                00415000
      IF(0.00005*C(I+5).GT.P)P=0.                                       00415100
      M=MIN0(INT(85.714/(.5714+SQRT(P)+.0897*P)),104)                   00415200
      IF(-1.GT.J)WRITE(LI,34)L,NI,NJ,NK,X,Y,M                           00415300
      IF(J.GT.-1)WRITE(LI,34)L,NI,NJ,NK,X,Y,M,J,K                       00415400
      K=INT(C(I+1)*0.1)                                                 00415500
      IF(J.EQ.-1)WRITE(LI,33)L,NI,NJ,NK,X,Y,M,K                         00415600
33    FORMAT(I5,3I4,F8.3,F7.1,I6,I8)                                    00415700
34    FORMAT(I5,3I4,F8.3,F7.1,2I6,3H OR,I4)                             00415800
35    FORMAT(2X,50(1H-))                                                00415900
      IF(I.EQ.NS)WRITE(LI,35)                                           00416000
36    L=L+1                                                             00416100
      JL=(N-MM)/10                                                      00416200
C                                                                       00416300
C UPDATE TPR FOR RA                                                     00416400
C                                                                       00416500
37    READ(LC)F                                                         00416600
      IF(F(1).LT.-8.E9)GOTO 40                                          00416700
      IF(AMIN1(F(1),F(5)).LT.0.)GOTO 37                                 00416800
      M=-3                                                              00416900
38    M=M+4                                                             00417000
      IF(F(M).LT.0.)GOTO 39                                             00417100
      F(M+1)=AINT(0.001*F(M+1)+1.)                                      00417200
      J=INT(ABS(F(M+2)))                                                00417300
      K=INT(ABS(F(M+3)))                                                00417400
      F(M+2)=FLOAT(IN(J))-SIGN(1.,F(M+2))+3.25                          00417500
      F(M+3)=FLOAT(IN(K))-SIGN(1.,F(M+3))+3.25                          00417600
      GOTO 38                                                           00417700
39    WRITE(LA)F                                                        00417800
      GOTO 37                                                           00417900
40    WRITE(LA)F                                                        00418000
      ENDFILE LA                                                        00418100
      REWIND LA                                                         00418200
      REWIND LC                                                         00418300
C                                                                       00418400
C SHUFFLE TPR                                                           00418500
C                                                                       00418600
      DO 44 N=5,NP,4                                                    00418700
      I=MOD(IP(N+1),1000)                                               00418800
      J=IABS(IP(N+2))                                                   00418900
      K=IABS(IP(N+3))                                                   00419000
      L=IP(N+1)/1000                                                    00419100
      J=ISIGN((IN(J)-MM)/10,IP(N+2))                                    00419200
      K=ISIGN((IN(K)-MM)/10,IP(N+3))                                    00419300
      I=(IN(I)-MM)/10                                                   00419400
      IF(IABS(J).GT.IABS(K))GOTO 41                                     00419500
      NI=J                                                              00419600
      J=K                                                               00419700
      K=NI                                                              00419800
41    IF(I.GT.IABS(J))GOTO 42                                           00419900
      L=MOD(24+ISIGN(L,J),24)                                           00420000
      NI=I                                                              00420100
      K=K*ISIGN(1,J)                                                    00420200
      I=IABS(J)                                                         00420300
      J=ISIGN(NI,J)                                                     00420400
42    IF(IABS(J).GT.IABS(K))GOTO 43                                     00420500
      NI=J                                                              00420600
      J=K                                                               00420700
      K=NI                                                              00420800
43    IP(N+1)=1000*L+I                                                  00420900
      IP(N+2)=J                                                         00421000
44    IP(N+3)=K                                                         00421100
C                                                                       00421200
C PRINT TPR                                                             00421300
C                                                                       00421400
      I=NP/4                                                            00421500
      WRITE(LI,45)I,IT                                                  00421600
45    FORMAT(1H1,I6,28H UNIQUE PHASE RELATIONS FOR ,40A1/)              00421700
      WRITE(LI,46)                                                      00421800
46    FORMAT(49H REFLEXION CODES, WITH PHASES AND ESDS IN DEGREES/)     00421900
47    FORMAT(5(I5,A1,I3,A1,I3,2H =,I3,1H(,I3,2H) ))                     00422000
      M=1                                                               00422100
      N=20                                                              00422200
48    M=M+4                                                             00422300
      IF(M.GT.NP)GOTO 50                                                00422400
      I=MOD(IP(M+1),1000)                                               00422500
      IF(I.GT.JL)GOTO 50                                                00422600
      J=IABS(IP(M+2))                                                   00422700
      K=IABS(IP(M+3))                                                   00422800
      IF(N.LT.55)GOTO 49                                                00422900
      WRITE(LI,47)(IN(NI),NI=21,55)                                     00423000
      N=20                                                              00423100
49    IN(N+1)=I                                                         00423200
      IN(N+2)=IA                                                        00423300
      IF(IP(M+2).LT.0)IN(N+2)=IM                                        00423400
      IN(N+3)=J                                                         00423500
      IN(N+4)=IA                                                        00423600
      IF(IP(M+3).LT.0)IN(N+4)=IM                                        00423700
      IN(N+5)=K                                                         00423800
      IN(N+6)=(IP(M+1)/1000)*15                                         00423900
      X=FLOAT(IP(M))                                                    00424000
      IN(N+7)=MIN0(104,INT(2710.5/(18.07+SQRT(X)+.00284*X)))            00424100
      N=N+7                                                             00424200
      GOTO 48                                                           00424300
50    WRITE(LI,47)(IN(I),I=21,N)                                        00424400
      DO 51 N=5,NP,4                                                    00424500
      IP(N)=(IP(N+1)/1000)+1                                            00424600
      IP(N+1)=MOD(IP(N+1),1000)*10+MM+2                                 00424700
      IP(N+2)=IABS(IP(N+2))*10+MM+3-ISIGN(1,IP(N+2))                    00424800
51    IP(N+3)=IABS(IP(N+3))*10+MM+3-ISIGN(1,IP(N+3))                    00424900
52    RETURN                                                            00425000
      END                                                               00425100
C                                                                       00425200
      SUBROUTINE PHEX                                                   00425300
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NB,ND,NP,NS,MM,     00425400
     *MP,JM,NM,CS,FT,F(84),IT(40),IN(660),C(6600),IP(1)                 00425500
      FT=AMIN1(FT,ABS(C(41))-.5)                                        00425600
      IF(FT.LT.-.1)GOTO 30                                              00425700
      CS=C(23)                                                          00425800
      DO 1 I=1,31                                                       00425900
1     C(I)=SIN(.2617994*FLOAT(I-1))                                     00426000
      C(1)=0.                                                           00426100
      C(13)=0.                                                          00426200
      C(25)=0.                                                          00426300
2     FORMAT(40H1PHASES BEFORE AND AFTER REFINEMENT FOR ,40A1/)         00426400
      IF(C(41).LT.0.)WRITE(LI,2)IT                                      00426500
C                                                                       00426600
C PHASE PERMUTATIONS                                                    00426700
C                                                                       00426800
      KK=0                                                              00426900
      JP=0                                                              00427000
      J=JM                                                              00427100
      NR=0                                                              00427200
3     J=J+6                                                             00427300
      IF(J.GT.NM)GOTO 4                                                 00427400
      JP=JP+1                                                           00427500
      IN(JP)=J+1                                                        00427600
      IF(C(J).LT.0.5)JP=JP-1                                            00427700
      GOTO 3                                                            00427800
4     NR=NR+1                                                           00427900
      DO 5 I=1,28                                                       00428000
5     IN(I+630)=I                                                       00428100
      AM=10.                                                            00428200
      NG=NS+10                                                          00428300
      NT=201                                                            00428400
      JT=0                                                              00428500
      DO 7 I=NB,ND,10                                                   00428600
      J=I+2                                                             00428700
      IF(C(I).GT.0.)GOTO 6                                              00428800
      J=I+6                                                             00428900
      Q=.0174533*AINT(C(I+1)*0.1)                                       00429000
      X=AMOD(C(I+1),10.)                                                00429100
      C(I+2)=X*COS(Q)                                                   00429200
      C(I+3)=X*SIN(Q)                                                   00429300
      C(I+4)=C(I+2)                                                     00429400
      C(I+5)=-C(I+3)                                                    00429500
6     K=I+9                                                             00429600
      DO 7 L=J,K                                                        00429700
7     C(L)=0.                                                           00429800
8     K=KK                                                              00429900
      KK=1                                                              00430000
      N=0                                                               00430100
      M=JM                                                              00430200
9     M=M+6                                                             00430300
      IF(M.GT.NM)GOTO 13                                                00430400
      N=N+1                                                             00430500
      IN(N)=IN(N)+K                                                     00430600
      J=IN(N)                                                           00430700
      IF(INT(C(J)).EQ.0)GOTO 12                                         00430800
10    K=0                                                               00430900
11    IN(N+600)=C(J)                                                    00431000
      Q=0.                                                              00431100
      IF(INT(C(J)).NE.0)Q=.0174533*C(J)                                 00431200
      J=C(M)                                                            00431300
      C(J+2)=COS(Q)*AMOD(C(J+1),10.)                                    00431400
      C(J+3)=SIN(Q)*AMOD(C(J+1),10.)*CS                                 00431500
      C(J+4)=C(J+2)                                                     00431600
      C(J+5)=-C(J+3)                                                    00431700
      GOTO 9                                                            00431800
12    J=MIN0(M+4,J)                                                     00431900
      IF(INT(C(J+1)).NE.0)GOTO 10                                       00432000
      IN(N)=M+1                                                         00432100
      J=M+1                                                             00432200
      GOTO 11                                                           00432300
13    IF(K.EQ.1)GOTO 29                                                 00432400
      IF(C(41).LT.0.)WRITE(LI,14)NR,(IN(I),I=631,658)                   00432500
14    FORMAT(//4H SET,I5//10H NC MEAN W,I3,27I4/)                       00432600
C                                                                       00432700
C TANGENT EXPANSION                                                     00432800
C                                                                       00432900
15    NT=MIN0(NP,1+4*(NT/3))                                            00433000
      DO 16 N=5,NT,4                                                    00433100
      L=IP(N)                                                           00433200
      I=IP(N+1)                                                         00433300
      J=IP(N+2)                                                         00433400
      K=IP(N+3)                                                         00433500
      X=C(K)*C(L+6)+C(K+1)*C(L)                                         00433600
      Y=C(K+1)*C(L+6)-C(K)*C(L)                                         00433700
      C(I+4)=C(I+4)+X*C(J)-Y*C(J+1)                                     00433800
      C(I+5)=C(I+5)+X*C(J+1)+Y*C(J)                                     00433900
      C(J+4)=C(J+4)+X*C(I)-Y*C(I+1)                                     00434000
      C(J+5)=C(J+5)+X*C(I+1)+Y*C(I)                                     00434100
      X=C(I)*C(L+6)+C(I+1)*C(L)                                         00434200
      Y=C(I+1)*C(L+6)-C(I)*C(L)                                         00434300
      C(K+4)=C(K+4)+X*C(J)-Y*C(J+1)                                     00434400
16    C(K+5)=C(K+5)+X*C(J+1)+Y*C(J)                                     00434500
C                                                                       00434600
C EVALUATE WEIGHTS AND PHASES                                           00434700
C                                                                       00434800
      V=1./SQRT(AM)                                                     00434900
      Q=0.                                                              00435000
      DO 19 N=NB,I,10                                                   00435100
      P=1.                                                              00435200
      O=AMOD(C(N+1),10.)                                                00435300
      W=O*C(45)                                                         00435400
      X=W*(C(N+6)+C(N+8))                                               00435500
      Y=W*(C(N+9)-C(N+7))*CS                                            00435600
      IF(10..GT.C(N+1))GOTO 17                                          00435700
      IF(C(N).LT.0.)GOTO 18                                             00435800
      K=INT(0.1*C(N+1))-23                                              00435900
      W=C(K+6)*X+C(K)*Y                                                 00436000
      X=W*C(K+6)                                                        00436100
      Y=W*C(K)                                                          00436200
17    U=X*X+Y*Y                                                         00436300
      P=0.                                                              00436400
      IF(AM.GT.U)GOTO 18                                                00436500
      S=SQRT(U)                                                         00436600
      P=AMIN1(0.2*S,1.)                                                 00436700
      IF(NG.GT.N)GOTO 18                                                00436800
      W=O*P/S                                                           00436900
      C(N+2)=W*X                                                        00437000
      C(N+3)=W*Y                                                        00437100
      C(N+4)=C(N+2)                                                     00437200
      C(N+5)=-C(N+3)                                                    00437300
18    Q=Q+P                                                             00437400
      C(N+6)=0.                                                         00437500
      C(N+7)=0.                                                         00437600
      C(N+8)=0.                                                         00437700
19    C(N+9)=0.                                                         00437800
      Q=Q*10./FLOAT(ND-MM)                                              00437900
      IF(C(41).GT.-0.5)GOTO 22                                          00438000
      JT=JT+1                                                           00438100
      N=NB                                                              00438200
      J=600                                                             00438300
20    J=J+1                                                             00438400
      IN(J)=-1                                                          00438500
      IF(ABS(C(N+3))+ABS(C(N+2)).GT.0.01)                               00438600
     *IN(J)=MOD(INT(720.5+57.29578*ATAN2(C(N+3),C(N+2))),360)           00438700
      N=N+10                                                            00438800
      IF(J.LT.628)GOTO 20                                               00438900
      WRITE(LI,21)JT,Q,(IN(N),N=601,628)                                00439000
21    FORMAT(I3,F6.3,28I4)                                              00439100
22    IF(Q.GT.C(43))NG=0                                                00439200
      IF(Q.GT.C(44))GOTO 23                                             00439300
      AM=AM*0.75                                                        00439400
      IF(AM.GT.0.04)GOTO 15                                             00439500
C                                                                       00439600
C STORE PHASE SETS                                                      00439700
C                                                                       00439800
23    N=MM                                                              00439900
      GOTO 25                                                           00440000
24    WRITE(LC)F                                                        00440100
25    I=0                                                               00440200
26    I=I+1                                                             00440300
      N=N+10                                                            00440400
      IF(N.GT.ND)GOTO 28                                                00440500
      F(I)=720.                                                         00440600
      IF(ABS(C(N+2))+ABS(C(N+3)).LT.0.01)GOTO 27                        00440700
      F(I)=ATAN2(C(N+3),C(N+2))                                         00440800
27    IF(LV+5-I)24,24,26                                                00440900
28    F(I)=-999.                                                        00441000
      WRITE(LC)F                                                        00441100
      GOTO 4                                                            00441200
29    F(1)=-9.E10                                                       00441300
      WRITE(LC)F                                                        00441400
      ENDFILE LC                                                        00441500
      REWIND LC                                                         00441600
30    RETURN                                                            00441700
      END                                                               00441800
C                                                                       00441900
      SUBROUTINE QUAT                                                   00442000
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,NB,ND,NP,NS,MM,     00442100
     *MP,JM,NM,CS,FT,F(84),IT(40),IN(660),C(6600),IP(100)               00442200
      IF(FT.LT.-.1)GOTO 45                                              00442300
      DO 1 I=NB,ND,10                                                   00442400
1     C(I+1)=AMOD(C(I+1),10.)                                           00442500
C                                                                       00442600
C SET UP RA TEST                                                        00442700
C                                                                       00442800
      NP=-2                                                             00442900
      O=0.                                                              00443000
      SA=0.                                                             00443100
      NS=0                                                              00443200
2     READ(LA)F                                                         00443300
      IF(F(1).LT.-8.E9)GOTO 6                                           00443400
      M=-3                                                              00443500
3     M=M+4                                                             00443600
      IF(F(M).LT.0.)GOTO 4                                              00443700
      L=F(M+2)                                                          00443800
      N=F(M+3)                                                          00443900
      IF(MAX0(L,N).GT.ND+10)GOTO 3                                      00444000
      NP=NP+3                                                           00444100
      IF(NP+5000.GT.MP)GOTO 5                                           00444200
      IP(NP)=F(M+1)                                                     00444300
      IP(NP+1)=L                                                        00444400
      IP(NP+2)=N                                                        00444500
      GOTO 3                                                            00444600
4     NP=NP+3                                                           00444700
      NS=NS+1                                                           00444800
      IP(NP)=INT(F(M))                                                  00444900
      O=O+F(M)*F(M)                                                     00445000
      SA=SA+62500.                                                      00445100
      IP(NP+1)=0                                                        00445200
      IP(NP+2)=0                                                        00445300
      K=NP                                                              00445400
      GOTO 2                                                            00445500
5     NP=K                                                              00445600
6     IP(NP+1)=-1                                                       00445700
      REWIND LA                                                         00445800
      NR=(NP+2)/3-NS                                                    00445900
      WRITE(LI,7)IT,NR,NS                                               00446000
7     FORMAT(28H1BEST UNIQUE PHASE SETS FOR ,40A1///I7,                 00446100
     *14H RELATIONS FOR,I5,22H REFLEXIONS IN RA TEST//)                 00446200
C                                                                       00446300
C FIND LOWEST R(ALPHA)                                                  00446400
C                                                                       00446500
      NR=0                                                              00446600
      NS=1                                                              00446700
      IN(1)=-1                                                          00446800
      NM=INT(ABS(C(41))+0.1)                                            00446900
8     N=MM                                                              00447000
      NR=NR+1                                                           00447100
9     READ(LC)F                                                         00447200
      IF(F(1).LT.-9998.)GOTO 19                                         00447300
      I=0                                                               00447400
10    I=I+1                                                             00447500
      IF(F(I).LT.-998.)GOTO 11                                          00447600
      N=N+10                                                            00447700
      C(N+2)=COS(F(I))*C(N+1)                                           00447800
      C(N+3)=SIN(F(I))*CS*C(N+1)                                        00447900
      C(N+4)=C(N+2)                                                     00448000
      C(N+5)=-C(N+3)                                                    00448100
      IF(LV+5-I)9,9,10                                                  00448200
11    S=0.                                                              00448300
      T=0.                                                              00448400
      N=-2                                                              00448500
      GOTO 14                                                           00448600
12    U=C(J)*C(K)-C(J+1)*C(K+1)                                         00448700
      V=C(J)*C(K+1)+C(K)*C(J+1)                                         00448800
      X=X+U*C(I+6)+V*C(I)                                               00448900
      Y=Y+V*C(I+6)-U*C(I)                                               00449000
13    N=N+3                                                             00449100
      I=IP(N)                                                           00449200
      J=IP(N+1)                                                         00449300
      K=IP(N+2)                                                         00449400
      IF(I.GT.0)GOTO 12                                                 00449500
      X=1000.*SQRT(X*X+Y*Y)                                             00449600
      T=T-X*FLOAT(I)                                                    00449700
      S=S+X*X                                                           00449800
      IF(J.LT.0)GOTO 15                                                 00449900
14    X=0.                                                              00450000
      Y=0.                                                              00450100
      GOTO 13                                                           00450200
15    L=INT(1000.-1000.*T*T/(O*S))                                      00450300
      M=NS+2                                                            00450400
      K=M                                                               00450500
16    K=K-2                                                             00450600
      IF(L-IN(K))16,18,18                                               00450700
17    IN(M+3)=IN(M+1)                                                   00450800
      IN(M+2)=IN(M)                                                     00450900
18    M=M-2                                                             00451000
      IF(M.GT.K)GOTO 17                                                 00451100
      IN(K+2)=L                                                         00451200
      IN(K+3)=NR                                                        00451300
      NS=MIN0(NS+2,659)                                                 00451400
      GOTO 8                                                            00451500
C                                                                       00451600
C SORT UNIQUE PHASE SETS                                                00451700
C                                                                       00451800
19    REWIND LC                                                         00451900
      IF(NS.EQ.1)GOTO 44                                                00452000
      NT=0                                                              00452100
      NK=NP+2                                                           00452200
      I=1                                                               00452300
20    I=I+2                                                             00452400
      NN=NK                                                             00452500
      NR=0                                                              00452600
      N=MM                                                              00452700
21    NR=NR+1                                                           00452800
22    READ(LC)F                                                         00452900
      J=0                                                               00453000
23    J=J+1                                                             00453100
      IF(F(J).LT.-998.)GOTO 25                                          00453200
      IF(NR.NE.IN(I+1))GOTO 24                                          00453300
      N=N+10                                                            00453400
      C(N+2)=COS(F(J))*C(N+1)                                           00453500
      C(N+3)=SIN(F(J))*C(N+1)*CS                                        00453600
      C(N+4)=C(N+2)                                                     00453700
      C(N+5)=-C(N+3)                                                    00453800
      C(N+6)=1.                                                         00453900
      IF(F(J).GT.700.)C(N+6)=0.                                         00454000
24    IF(LV+5-J)22,22,23                                                00454100
25    IF(NR.NE.IN(I+1))GOTO 21                                          00454200
      N=-2                                                              00454300
      GOTO 28                                                           00454400
26    U=C(J)*C(K)-C(J+1)*C(K+1)                                         00454500
      V=C(J)*C(K+1)+C(K)*C(J+1)                                         00454600
      X=X+U*C(L+6)+V*C(L)                                               00454700
      Y=Y+V*C(L+6)-U*C(L)                                               00454800
27    N=N+3                                                             00454900
      L=IP(N)                                                           00455000
      J=IP(N+1)                                                         00455100
      K=IP(N+2)                                                         00455200
      IF(L.GT.0)GOTO 26                                                 00455300
      NN=NN+1                                                           00455400
      IF(NN.GT.MP)GOTO 37                                               00455500
      IP(NN)=0                                                          00455600
      IF(X*X+Y*Y.GT.0.01)IP(NN)=INT(572.958*ATAN2(Y,X))                 00455700
      IF(J.LT.0)GOTO 29                                                 00455800
28    X=0.                                                              00455900
      Y=0.                                                              00456000
      GOTO 27                                                           00456100
29    N=MM                                                              00456200
      J=NK+1                                                            00456300
      M=NP+3                                                            00456400
30    IF(M.GT.NK)GOTO 33                                                00456500
      U=0.                                                              00456600
      DO 31 L=J,NN                                                      00456700
      X=FLOAT(MOD(19800+IP(L)-IP(M),3600)-1800)                         00456800
      U=U+X*X                                                           00456900
31    M=M+1                                                             00457000
      IF(U.GT.SA)GOTO 30                                                00457100
      IN(I)=(NP-M)/(NN-NK)                                              00457200
      GOTO 36                                                           00457300
32    WRITE(LA)F                                                        00457400
33    L=-5                                                              00457500
34    L=L+6                                                             00457600
      N=N+10                                                            00457700
      IF(N.GT.ND)GOTO 35                                                00457800
      F(L)=ABS(C(N))                                                    00457900
      F(L+1)=C(N+1)                                                     00458000
      F(L+2)=1.                                                         00458100
      F(L+3)=0.                                                         00458200
      F(L+4)=C(N+2)*C(N+6)                                              00458300
      F(L+5)=C(N+3)*C(N+6)                                              00458400
      IF(LV-L)32,32,34                                                  00458500
35    F(L)=0.                                                           00458600
      WRITE(LA)F                                                        00458700
      NK=NN                                                             00458800
      NT=NT+1                                                           00458900
36    REWIND LC                                                         00459000
      IF(NT.EQ.NM)GOTO 37                                               00459100
      IF(I.LT.NS)GOTO 20                                                00459200
37    WRITE(LI,38)                                                      00459300
      REWIND LC                                                         00459400
38    FORMAT(33H E-MAP  RA   SET  EQUIVALENT SETS/)                     00459500
39    FORMAT(I4,F7.3,2I5,25I4/(17X,26I4))                               00459600
      NT=0                                                              00459700
      J=1                                                               00459800
40    J=J+2                                                             00459900
41    IF(J.GT.I)GOTO 44                                                 00460000
      IF(IN(J).LT.0)GOTO 40                                             00460100
      NT=NT+1                                                           00460200
      X=0.001*FLOAT(IN(J))                                              00460300
      IP(1)=IN(J+1)                                                     00460400
      N=1                                                               00460500
      K=J                                                               00460600
42    K=K+2                                                             00460700
      IF(K.GT.I)GOTO 43                                                 00460800
      IF(IN(K)+NT.NE.0)GOTO 42                                          00460900
      N=N+1                                                             00461000
      IP(N)=IN(K+1)                                                     00461100
      GOTO 42                                                           00461200
43    WRITE(LI,39)NT,X,(IP(K),K=1,N)                                    00461300
      GOTO 40                                                           00461400
44    F(1)=-9.E10                                                       00461500
      WRITE(LA)F                                                        00461600
      ENDFILE LA                                                        00461700
      REWIND LA                                                         00461800
45    RETURN                                                            00461900
      END                                                               00462000
C                                                                       00462100
      SUBROUTINE XMAP                                                   00462200
      DIMENSION ID(29)                                                  00462300
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,JN(160),            00462400
     *IT(40),C(1740),IN(3334),G(126),F(84),IL(30),IM(28),E(4452),A(1)   00462500
      DATA IX/1HX/,IY/1HY/,IZ/1HZ/                                      00462600
      DATA ID(1)/4H  PA/,ID(2)/4H DIF/,ID(3)/4H    /,ID(4)/4H    /      00462700
      DATA ID(5)/4H  WT/,ID(6)/4H  E*/,ID(7)/4HTTER/,ID(8)/4HFERE/      00462800
      DATA ID(9)/4HFOUR/,ID(10)/4H    /,ID(11)/4H. DI/,ID(12)/4HF PA/   00462900
      DATA ID(13)/4HSON /,ID(14)/4HNCE /,ID(15)/4HIER /,ID(16)/4H  E-/  00463000
      DATA ID(17)/4HFF. /,ID(18)/4HTT. /                                00463100
      DATA ID(19)/1H /,ID(20)/1H0/,ID(21)/1H1/,ID(22)/1H2/,ID(23)/1H3/  00463200
      DATA ID(24)/1H4/,ID(25)/1H5/,ID(26)/1H6/,ID(27)/1H7/,ID(28)/1H8/  00463300
      DATA ID(29)/1H9/                                                  00463400
      READ(LB)IT,JN,(IN(I),I=1,660),C                                   00463500
      REWIND LB                                                         00463600
      IF(IN(20))97,1,1                                                  00463700
1     MDM=LM-LV-9915+(1795*LU)                                          00463800
      Y=0.                                                              00463900
      DO 2 I=1,126                                                      00464000
      G(I)=SIN(Y)                                                       00464100
2     Y=Y+6.283185E-2                                                   00464200
      I=IN(4)+1                                                         00464300
      OS=1.                                                             00464400
      IF(I.GT.1)OS=AMOD(C(I),100.)                                      00464500
      WW=0.                                                             00464600
      IF(0.001.LT.ABS(C(24)))WW=SIGN(.0087788/(C(24)*C(24)),C(24))      00464700
      MP=MIN0(1681,(4*IABS(IN(17)))+637)                                00464800
      KF=IN(9)+9998                                                     00464900
      NP=0                                                              00465000
      NX=IN(16)                                                         00465100
      JJ=IN(14)                                                         00465200
      JP=MIN0(KF,IN(17))                                                00465300
      NV=1                                                              00465400
      NS=IN(1)                                                          00465500
      JF=IABS(IN(14))/7                                                 00465600
      NZ=MIN0(IABS(IN(14))-3*JF,6)                                      00465700
      MA=MAX0(MIN0(IABS(IN(15)),3),1)                                   00465800
      MB=IN(15)                                                         00465900
      NI=LF                                                             00466000
      NA=1                                                              00466100
      MM=1                                                              00466200
      DO 3 I=1,MA                                                       00466300
      J=IX                                                              00466400
      IX=IY                                                             00466500
      IY=IZ                                                             00466600
3     IZ=J                                                              00466700
      IF(MB)5,4,4                                                       00466800
4     J=IX                                                              00466900
      IX=IY                                                             00467000
      IY=J                                                              00467100
5     DO 6 I=1,3334                                                     00467200
6     IN(I)=0                                                           00467300
C                                                                       00467400
C READ REFLEXIONS                                                       00467500
C                                                                       00467600
      ASSIGN 9 TO NF                                                    00467700
      ASSIGN 21 TO NG                                                   00467800
      ASSIGN 36 TO NU                                                   00467900
      IF((NZ-1)*(6-NZ))92,8,7                                           00468000
7     NI=LA                                                             00468100
8     READ(NI)F                                                         00468200
      I=-5                                                              00468300
      IF(F(1)+9.E9)96,9,9                                               00468400
9     I=I+6                                                             00468500
      IF(LV-I)8,10,10                                                   00468600
10    IF(ABS(F(I))-0.8)35,11,11                                         00468700
11    IF(C(46)-F(I+3))9,12,12                                           00468800
12    CALL HKL(F(I),X,Y,Z)                                              00468900
      S=F(I+4)*F(I+4)+F(I+5)*F(I+5)                                     00469000
      IF(F(I+2))9,9,13                                                  00469100
13    IF(1.E-10-S)14,9,9                                                00469200
14    U=SQRT(S)                                                         00469300
      V=F(I+1)-U                                                        00469400
      SE=0.                                                             00469500
      KJ=NA-4                                                           00469600
C                                                                       00469700
C LOCATING SCHEME                                                       00469800
C                                                                       00469900
      DO 23 K=61,NS,12                                                  00470000
      P=X*C(K)+Y*C(K+3)+Z*C(K+6)                                        00470100
      Q=X*C(K+1)+Y*C(K+4)+Z*C(K+7)                                      00470200
      R=X*C(K+2)+Y*C(K+5)+Z*C(K+8)                                      00470300
      W=P+100.*(Q+100.*R)                                               00470400
      E(KJ+7)=ABS(W)                                                    00470500
      J=NA-4                                                            00470600
15    J=J+4                                                             00470700
      IF(J-KJ)16,16,17                                                  00470800
16    IF(0.5-ABS(E(J+3)-E(KJ+7)))15,15,23                               00470900
17    DO 18 J=1,MA                                                      00471000
      E(KJ+4)=P                                                         00471100
      P=Q                                                               00471200
      Q=R                                                               00471300
18    R=E(KJ+4)                                                         00471400
      IF(MB)20,19,19                                                    00471500
19    T=P                                                               00471600
      P=Q                                                               00471700
      Q=T                                                               00471800
20    IF(AMAX1(ABS(P),ABS(Q)).GT.33.5)GOTO 23                           00471900
      T=100.*P+Q                                                        00472000
      M=INT(ABS(T)+1.1)                                                 00472100
      KJ=KJ+4                                                           00472200
      E(KJ+1)=T                                                         00472300
      GOTO NG,(21,22)                                                   00472400
21    IN(M)=1                                                           00472500
      GOTO 23                                                           00472600
C                                                                       00472700
C FOURIER TYPE                                                          00472800
C                                                                       00472900
22    SE=SE+SIGN(0.5,0.5-ABS(F(I)-W))+0.5                               00473000
      E(KJ+2)=100.*(X*C(K+9)+Y*C(K+10)+Z*C(K+11))                       00473100
23    CONTINUE                                                          00473200
      GOTO NF,(9,24)                                                    00473300
24    P=F(I+1)*OS                                                       00473400
      W=EXP(-WW*F(I+3))                                                 00473500
      GOTO(26,28,27,29,27,25),NZ                                        00473600
25    P=SQRT(SE)*AMOD(F(I+4),10.)                                       00473700
26    Q=0.                                                              00473800
      P=F(I+1)*P                                                        00473900
      R=10000.5                                                         00474000
      GOTO 30                                                           00474100
27    Y=F(I+3)*C(1)*C(1)*.6332574                                       00474200
      K=Y                                                               00474300
      Y=AMOD(Y,1.)                                                      00474400
      Y=P*U*(Y*(C(K+1691)-C(K+1690))+C(K+1690))                         00474500
      V=P*AMIN1(Y*(.5658+Y*(Y*.0106-.1304)),Y/(Y+.56))                  00474600
      IF(NZ.EQ.5)V=V-U                                                  00474700
28    V=V/U                                                             00474800
      P=F(I+4)*V                                                        00474900
      Q=F(I+5)*V*C(23)                                                  00475000
      GOTO 30                                                           00475100
29    F(I+2)=F(I+2)*SQRT(SE)                                            00475200
      P=F(I+4)*F(I+2)                                                   00475300
      Q=F(I+5)*F(I+2)                                                   00475400
30    P=P*W                                                             00475500
      Q=Q*W                                                             00475600
      DO 34 K=NA,KJ,4                                                   00475700
      Y=SIGN(1.,E(K+1)+0.1)                                             00475800
      X=Y*E(K)                                                          00475900
      Z=ABS(E(K+1))+1.1                                                 00476000
      M=Z                                                               00476100
      N=IN(M)                                                           00476200
      A(N)=Z-1.099                                                      00476300
C                                                                       00476400
C HX SUMS                                                               00476500
C                                                                       00476600
      IF((NZ-1)*(6-NZ))32,32,31                                         00476700
31    R=10000.5-Y*E(K+2)                                                00476800
32    S=AMOD(R-ZZ*X,100.)                                               00476900
      M=S                                                               00477000
      S=.0628258*(AMOD(S,1.)-0.5)                                       00477100
      T=1.-.5000612*S*S                                                 00477200
      O=T*G(M+1)+S*G(M+26)                                              00477300
      S=T*G(M+26)-S*G(M+1)                                              00477400
      Z=Q*Y                                                             00477500
      T=P*S-Z*O                                                         00477600
      S=-Z*S-P*O                                                        00477700
      L=INT(AMOD(10000.5+X*C(36),100.))                                 00477800
      M=N+1                                                             00477900
      DO 33 N=3,NH,2                                                    00478000
      A(M)=A(M)+T                                                       00478100
      A(M+1)=A(M+1)+S                                                   00478200
      O=T*G(L+26)-S*G(L+1)                                              00478300
      S=T*G(L+1)+S*G(L+26)                                              00478400
      T=O                                                               00478500
33    M=M+2                                                             00478600
34    SS=SS+SQRT(P*P+Q*Q)                                               00478700
      GOTO 9                                                            00478800
C                                                                       00478900
C SET UP FOURIER                                                        00479000
C                                                                       00479100
35    GOTO NU,(36,48)                                                   00479200
36    M=0                                                               00479300
      DO 37 I=1,3334                                                    00479400
37    M=M+IN(I)                                                         00479500
      N=MIN0(NX,((MDM/(M+2))-1)/2)                                      00479600
      IF(N)95,95,38                                                     00479700
38    NH=N+N+1                                                          00479800
      NL=(NH*M)+1                                                       00479900
      M=1-NH                                                            00480000
      DO 39 I=1,3334                                                    00480100
      M=M+(NH*IN(I))                                                    00480200
39    IN(I)=M                                                           00480300
      L=INT(C(34)+1000.1)                                               00480400
      K=INT(C(37)*1.001)                                                00480500
      DO 40 I=1,28                                                      00480600
      IM(I)=MOD(L,100)                                                  00480700
40    L=L+K                                                             00480800
      REWIND NI                                                         00480900
      IF(JF)45,45,41                                                    00481000
41    READ(LA)F                                                         00481100
      IF(F(1)+9.E9)96,42,42                                             00481200
42    WRITE(LC)F                                                        00481300
      DO 43 I=1,LV,6                                                    00481400
      IF(0.8.GT.ABS(F(I)))GOTO 44                                       00481500
43    CONTINUE                                                          00481600
      GOTO 41                                                           00481700
44    NI=LC                                                             00481800
      ENDFILE NI                                                        00481900
      REWIND NI                                                         00482000
45    NC=-1                                                             00482100
      NB=-1                                                             00482200
      NA=1                                                              00482300
      NT=0                                                              00482400
      EZ=9999.                                                          00482500
      ZZ=C(33)                                                          00482600
      YM=AMOD(C(34)+1000.1,100.)-0.1                                    00482700
      ZM=AMOD(C(35)+1000.1,100.)-0.1                                    00482800
      NP=637                                                            00482900
      C(MP)=0.                                                          00483000
      C(637)=999999.                                                    00483100
46    SS=0.                                                             00483200
      DO 47 I=1,MDM                                                     00483300
47    A(I)=0.                                                           00483400
      A(NL)=1000000.                                                    00483500
      ASSIGN 22 TO NG                                                   00483600
      ASSIGN 24 TO NF                                                   00483700
      ASSIGN 48 TO NU                                                   00483800
      GOTO 8                                                            00483900
C                                                                       00484000
C FOURIER SUMMATIONS                                                    00484100
C                                                                       00484200
48    SS=999.1/SS                                                       00484300
      SC=2.221441*SS*C(2)*C(3)*SIN(.0174533*C(7))/SQRT(C(16))           00484400
      NV=NV+1                                                           00484500
      MS=2                                                              00484600
49    Z=0.                                                              00484700
      W=50.                                                             00484800
      NK=NA+1483                                                        00484900
      DO 50 J=NA,NK                                                     00485000
50    E(J)=0.                                                           00485100
      DO 51 J=1,56                                                      00485200
51    F(J)=0.                                                           00485300
      NK=MS                                                             00485400
      DO 58 I=1,NL,NH                                                   00485500
      IF(A(I)-W)56,52,52                                                00485600
52    Q=AMOD(Z*C(38),100.)                                              00485700
      K=Q                                                               00485800
      Q=AMOD(Z*ZM,100.)                                                 00485900
      L=Q                                                               00486000
      N=NA                                                              00486100
      DO 54 J=1,53                                                      00486200
      L=MOD(L,100)                                                      00486300
      W=G(L+1)                                                          00486400
      Z=G(L+26)                                                         00486500
      DO 53 M=1,25,4                                                    00486600
      E(N)=E(N)+F(M)*Z+F(M+28)*W                                        00486700
      E(N+1)=E(N+1)+F(M+1)*Z+F(M+29)*W                                  00486800
      E(N+2)=E(N+2)+F(M+2)*Z+F(M+30)*W                                  00486900
      E(N+3)=E(N+3)+F(M+3)*Z+F(M+31)*W                                  00487000
53    N=N+4                                                             00487100
54    L=L+K                                                             00487200
      Z=AINT(0.01*A(I)+0.5)+0.0001                                      00487300
      W=100.*Z+50.                                                      00487400
      DO 55 J=1,28                                                      00487500
      F(J)=0.                                                           00487600
55    F(J+28)=0.                                                        00487700
56    Q=AMOD(A(I)*C(37),100.)                                           00487800
      K=Q                                                               00487900
      Q=AMOD(A(I)*YM,100.)                                              00488000
      L=Q                                                               00488100
      U=A(NK)*SS                                                        00488200
      V=A(NK+1)*SS                                                      00488300
      DO 57 J=1,28                                                      00488400
      L=MOD(L,100)                                                      00488500
      F(J)=F(J)+U*G(L+26)-V*G(L+1)                                      00488600
      F(J+28)=F(J+28)-V*G(L+26)-U*G(L+1)                                00488700
57    L=L+K                                                             00488800
58    NK=NK+NH                                                          00488900
C                                                                       00489000
C LOCATE MAXIMA AND MINIMA                                              00489100
C                                                                       00489200
      IF(NC)76,59,59                                                    00489300
59    Z=C(35)                                                           00489400
      DO 69 I=28,1428,28                                                00489500
      Z=Z+C(38)                                                         00489600
      Y=C(34)                                                           00489700
      DO 69 K=1,26                                                      00489800
      Y=Y+C(37)                                                         00489900
      NK=I+K                                                            00490000
      M=NK+NB                                                           00490100
      EZ=AMIN1(EZ,E(M))                                                 00490200
      IF(ABS(E(M))-0.8*ABS(C(MP)))69,69,60                              00490300
60    L=NK+NC                                                           00490400
      N=NK+NA                                                           00490500
      W=AMAXA(E(L),E(M),E(N),E(M-1),E(M+1),E(M-28),E(M+28))             00490600
      Q=AMAXA(W,E(N+1),E(N-1),E(L+1),E(L-1),E(M-27),E(M-29))            00490700
      W=AMAXA(Q,E(M+27),E(M+29),E(L+28),E(L-28),E(N+28),E(N-28))        00490800
      IF(ABS(E(M))-ABS(W)+0.01)69,61,61                                 00490900
61    Q=E(M)+E(M)                                                       00491000
      U=E(L)-E(N)                                                       00491100
      V=E(M-1)-E(M+1)                                                   00491200
      W=E(M-28)-E(M+28)                                                 00491300
      R=U/(E(N)+E(L)-Q)                                                 00491400
      S=V/(E(M-1)+E(M+1)-Q)                                             00491500
      T=W/(E(M-28)+E(M+28)-Q)                                           00491600
      Q=E(M)-(U*R+V*S+W*T)*.0416667                                     00491700
      J=NP+4                                                            00491800
      NK=J                                                              00491900
62    J=J-4                                                             00492000
      IF(ABS(C(J))-ABS(Q))62,63,63  !!!!!!                              00492100
63    NK=NK-4                                                           00492200
      IF(J-NK)64,65,65                                                  00492300
64    C(NK+4)=C(NK)                                                     00492400
      C(NK+5)=C(NK+1)                                                   00492500
      C(NK+6)=C(NK+2)                                                   00492600
      C(NK+7)=C(NK+3)                                                   00492700
      GOTO 63                                                           00492800
65    C(J+4)=Q                                                          00492900
      C(J+7)=0.01*ZZ+C(36)*(0.005*R-0.01)                               00493000
      C(J+6)=0.005*(Y+Y+C(37)*S)                                        00493100
      C(J+5)=0.005*(Z+Z+C(38)*T)                                        00493200
      E(M)=E(M)+0.02                                                    00493300
      NP=MIN0(NP+4,MP)                                                  00493400
      IF(MB)67,66,66                                                    00493500
66    T=C(J+5)                                                          00493600
      C(J+5)=C(J+6)                                                     00493700
      C(J+6)=T                                                          00493800
67    DO 68 NK=1,MA                                                     00493900
      T=C(J+7)                                                          00494000
      C(J+7)=C(J+6)                                                     00494100
      C(J+6)=C(J+5)                                                     00494200
68    C(J+5)=T                                                          00494300
69    CONTINUE                                                          00494400
C                                                                       00494500
C OUTPUT FOURIER                                                        00494600
C                                                                       00494700
70    FORMAT(1H1,3A4,3HMAP,I3,6H  FOR ,40A1//)                          00494800
71    FORMAT(1X,A1,2H =,F5.2,5X,A1,7H ACROSS,5X,A1,5H DOWN/)            00494900
72    FORMAT(14H MULTIPLIED BY,F11.4,10X,5H(SCAN,I3,1H)//)              00495000
73    FORMAT(4H0   ,28I4)                                               00495100
74    FORMAT(3H0  ,28(4H*  *),3H* *)                                    00495200
75    FORMAT(1H0,I2,1H*,28I4,2H *,I2)                                   00495300
76    Z=0.01*ZZ                                                         00495400
      IF(JJ)77,80,80                                                    00495500
77    WRITE(LI,70)ID(NZ),ID(NZ+6),ID(NZ+12),MM,IT                       00495600
      WRITE(LI,71)IZ,Z,IY,IX                                            00495700
      WRITE(LI,72)SC,NV                                                 00495800
      WRITE(LI,73)IM                                                    00495900
      WRITE(LI,74)                                                      00496000
      M=NA                                                              00496100
      L=INT(C(35)+1000.1)                                               00496200
      K=INT(C(38)*1.001)                                                00496300
      DO 79 J=1,53                                                      00496400
      IL(1)=MOD(L,100)                                                  00496500
      IL(30)=IL(1)                                                      00496600
      L=L+K                                                             00496700
      DO 78 I=2,29                                                      00496800
      IL(I)=E(M)                                                        00496900
78    M=M+1                                                             00497000
79    WRITE(LI,75)IL                                                    00497100
      WRITE(LI,74)                                                      00497200
      WRITE(LI,73)IM                                                    00497300
80    NC=NB                                                             00497400
      NB=NA                                                             00497500
      NA=MOD(NA+1484,4452)                                              00497600
      MS=MS+2                                                           00497700
      NT=NT+1                                                           00497800
      ZZ=ZZ+C(36)                                                       00497900
      IF(NX-NT)83,83,81                                                 00498000
81    IF(NH-MS)82,49,49                                                 00498100
82    REWIND NI                                                         00498200
      GOTO 46                                                           00498300
83    IF(NP-640)94,84,84                                                00498400
84    WRITE(LI,70)ID(NZ),ID(NZ+6),ID(NZ+12),MM,IT                       00498500
      WRITE(LI,85)C(641),EZ                                             00498600
85    FORMAT(10H MAXIMUM =,F8.2,12H,  MINIMUM =,F8.2/)                  00498700
      WRITE(LI,72)SC,NV                                                 00498800
      IF(JP.GT.0)GOTO 92                                                00498900
      WRITE(LI,86)                                                      00499000
86    FORMAT(34H      HEIGHT   X/A     Y/B     Z/C/)                    00499100
      K=1                                                               00499200
      DO 91 J=641,NP,4                                                  00499300
      L=K/100                                                           00499400
      M=MOD(K/10,10)                                                    00499500
      N=MOD(K,10)                                                       00499600
87    IF(L)88,88,89                                                     00499700
88    L=M                                                               00499800
      M=N                                                               00499900
      N=-1                                                              00500000
      GOTO 87                                                           00500100
89    WRITE(LI,90)ID(L+20),ID(M+20),ID(N+20),C(J),C(J+1),C(J+2),C(J+3)  00500200
90    FORMAT(1X,1HQ,3A1,F7.0,3F8.3)                                     00500300
91    K=K+1                                                             00500400
92    IF(KF)94,93,93                                                    00500500
93    IL(2)=NP                                                          00500600
      IL(3)=MM                                                          00500700
      CALL XPLAN                                                        00500800
94    MM=MM+1                                                           00500900
      REWIND NI                                                         00501000
      IF(JF)97,97,41                                                    00501100
95    IN(20)=-8                                                         00501200
      WRITE(LB)IT,(IN(I),I=1,660),C                                     00501300
      ENDFILE LB                                                        00501400
      REWIND LB                                                         00501500
96    REWIND NI                                                         00501600
97    RETURN                                                            00501700
      END                                                               00501800
      FUNCTION AMAXA(A,B,C,D,E,F,G)                                             
      AMAXA=AMAX1(A,B,C,D,E,F,G)                                                
      AMINA=AMIN1(A,B,C,D,E,F,G)                                                
      IF(ABS(AMINA).GT.ABS(AMAXA)) AMAXA=AMINA                                  
      RETURN                                                                    
      END                                                                       
C                                                                       00501900
      SUBROUTINE XPLAN                                                  00502000
      DIMENSION IH(15)                                                  00502100
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,JN(160),IT(40),     00502200
     *D(1740),IQ(3334),G(126),F(84),IL(30),IM(28),IN(660),C(1740),      00502300
     *H(2304),A(1980),IB(600),IC(600),B(600)                            00502400
      DATA IH(1)/1H0/,IH(2)/1H1/,IH(3)/1H2/,IH(4)/1H3/,IH(5)/1H4/       00502500
      DATA IH(6)/1H5/,IH(7)/1H6/,IH(8)/1H7/,IH(9)/1H8/,IH(10)/1H9/      00502600
      DATA IH(11)/1H /,IH(12)/1H*/,IH(13)/1HX/,IH(14)/1HY/,IH(15)/1HZ/  00502700
      READ(LB)IT,JN,(IN(I),I=1,660),C                                   00502800
      REWIND LB                                                         00502900
C                                                                       00503000
C EXPAND SYMMETRY OPERATORS                                             00503100
C                                                                       00503200
      NS=IN(1)                                                          00503300
      NL=IN(18)*3                                                       00503400
      L=INT(2.1-C(23))                                                  00503500
      KP=598                                                            00503600
      W=1.                                                              00503700
      IF(IABS(IN(14)).EQ.1)KP=0                                         00503800
      IF(IABS(IN(14)).EQ.6)KP=0                                         00503900
      IF(KP.NE.0)GOTO 1                                                 00504000
      W=0.                                                              00504100
      L=2                                                               00504200
1     DO 2 I=4,12                                                       00504300
2     F(I)=0.5                                                          00504400
      DO 3 I=1,3                                                        00504500
3     F(I)=0.                                                           00504600
      IF(NL-12)6,4,10                                                   00504700
4     DO 5 I=4,12,4                                                     00504800
5     F(I)=0.                                                           00504900
6     IF(NL-9)11,7,11                                                   00505000
7     DO 8 I=4,9                                                        00505100
8     F(I)=.6666667                                                     00505200
      DO 9 I=5,7                                                        00505300
9     F(I)=.3333333                                                     00505400
      GOTO 11                                                           00505500
10    K=IN(18)-1                                                        00505600
      F(K)=0.                                                           00505700
      NL=4                                                              00505800
11    NY=0                                                              00505900
      DO 14 I=61,NS,12                                                  00506000
      M=I+11                                                            00506100
      Q=1.                                                              00506200
      DO 14 K=1,L                                                       00506300
      DO 13 N=1,NL,3                                                    00506400
      DO 12 J=I,M                                                       00506500
      NY=NY+1                                                           00506600
12    H(NY)=Q*C(J)                                                      00506700
      H(NY-2)=H(NY-2)*W+F(N)                                            00506800
      H(NY-1)=H(NY-1)*W+F(N+1)                                          00506900
13    H(NY)=H(NY)*W+F(N+2)                                              00507000
14    Q=-1.                                                             00507100
C                                                                       00507200
C ATOMS                                                                 00507300
C                                                                       00507400
      NM=0                                                              00507500
      ASSIGN 16 TO NQ                                                   00507600
      ASSIGN 16 TO NU                                                   00507700
      IG=IN(6)                                                          00507800
      MA=-5                                                             00507900
      MI=-1                                                             00508000
      ND=0                                                              00508100
      NT=0                                                              00508200
      JV=(IN(9)+500)/1000                                               00508300
      NN=1000*JV-IN(9)                                                  00508400
      NP=IABS(NN)                                                       00508500
      JV=MIN0(JV,3)                                                     00508600
      IF(JV.LT.1)GOTO 15                                                00508700
      JD=MOD(JV,3)+1                                                    00508800
      JA=MOD(JD,3)+1                                                    00508900
      AA=SQRT(19.73921/C(JA+13))                                        00509000
      AD=-C(JA+1)*SIN(.0174533*C(JD+4))*C(JV+16)/C(JV+19)               00509100
      DD=C(JD+1)*SIN(.0174533*C(JA+4))                                  00509200
15    I=17                                                              00509300
      K=IN(5)+1                                                         00509400
      IF(NN)16,16,26                                                    00509500
16    I=I+4                                                             00509600
      IF(IG-I)26,17,17                                                  00509700
17    MA=MA+6                                                           00509800
      MI=MI+2                                                           00509900
      A(MA)=0.                                                          00510000
      A(MA+1)=C(K)                                                      00510100
      A(MA+2)=C(K+1)                                                    00510200
      A(MA+3)=C(K+2)                                                    00510300
      J=NS+12+103*((IN(I+2)-12)/2)                                      00510400
      A(MA+5)=C(J)+0.25                                                 00510500
      K=K+IN(I)                                                         00510600
C                                                                       00510700
C BONDS                                                                 00510800
C                                                                       00510900
18    P=0.                                                              00511000
      NA=ND                                                             00511100
      XA=0.                                                             00511200
      YA=0.                                                             00511300
      ZA=0.                                                             00511400
      IN(MI+1)=0                                                        00511500
      DO 25 L=1,NY,12                                                   00511600
      X=A(MA+1)*H(L)+A(MA+2)*H(L+1)+A(MA+3)*H(L+2)+H(L+9)               00511700
      Y=A(MA+1)*H(L+3)+A(MA+2)*H(L+4)+A(MA+3)*H(L+5)+H(L+10)            00511800
      Z=A(MA+1)*H(L+6)+A(MA+2)*H(L+7)+A(MA+3)*H(L+8)+H(L+11)            00511900
      NJ=2                                                              00512000
      DO 25 J=1,MA,6                                                    00512100
      IF(IN(NJ))25,19,19                                                00512200
19    U=A(J+1)-X                                                        00512300
      V=A(J+2)-Y                                                        00512400
      W=A(J+3)-Z                                                        00512500
      U=U-AINT(U+SIGN(0.5,.000001+U))                                   00512600
      V=V-AINT(V+SIGN(0.5,.000001+V))                                   00512700
      W=W-AINT(W+SIGN(0.5,.000001+W))                                   00512800
      R=SQRT(U*U*C(8)+V*V*C(9)+W*W*C(10)+V*W*C(11)+U*W*C(12)+U*V*C(13)) 00512900
      IF(A(J+5)+A(MA+5)-R)25,20,20                                      00513000
20    IF(0.5-R)24,21,21                                                 00513100
21    IF(J-MA)23,22,22                                                  00513200
22    P=P+1.                                                            00513300
      XA=XA+U                                                           00513400
      YA=YA+V                                                           00513500
      ZA=ZA+W                                                           00513600
      GOTO 25                                                           00513700
23    A(MA+4)=R                                                         00513800
      IN(MI+1)=-(J+5)/6                                                 00513900
      GOTO NU,(16,27)                                                   00514000
24    IB(NA+1)=(J+5)/3                                                  00514100
      IC(NA+1)=(MA+5)/3                                                 00514200
      B(NA+1)=R                                                         00514300
      NA=MIN0(1+KP,NA+1)                                                00514400
25    NJ=NJ+2                                                           00514500
      P=AMAX1(P,1.)                                                     00514600
      A(MA+4)=1./P                                                      00514700
      A(MA+1)=A(MA+1)-XA/P                                              00514800
      A(MA+2)=A(MA+2)-YA/P                                              00514900
      A(MA+3)=A(MA+3)-ZA/P                                              00515000
      IN(MI+1)=0                                                        00515100
      ND=NA                                                             00515200
      GOTO NQ,(16,30)                                                   00515300
C                                                                       00515400
C PEAKS                                                                 00515500
C                                                                       00515600
26    ASSIGN 30 TO NQ                                                   00515700
      ASSIGN 27 TO NU                                                   00515800
      IG=0                                                              00515900
      I=637                                                             00516000
      IF(NP.EQ.0)GOTO 31                                                00516100
27    I=I+4                                                             00516200
      IF(IL(2)-I)31,28,28                                               00516300
28    IG=IG+1                                                           00516400
      IF(1974-MA)31,29,29                                               00516500
29    MA=MA+6                                                           00516600
      MI=MI+2                                                           00516700
      IN(MI)=IG                                                         00516800
      A(MA)=D(I)                                                        00516900
      A(MA+1)=D(I+1)                                                    00517000
      A(MA+2)=D(I+2)                                                    00517100
      A(MA+3)=D(I+3)                                                    00517200
      A(MA+5)=1.2+SIGN(0.3,D(I)-200.)                                   00517300
      GOTO 18                                                           00517400
30    NT=NT+1                                                           00517500
      IF(NT-NP)27,31,31                                                 00517600
C                                                                       00517700
C ASSEMBLE MOLECULES                                                    00517800
C                                                                       00517900
31    NA=0                                                              00518000
      NM=0                                                              00518100
32    NA=NA+1                                                           00518200
      ASSIGN 32 TO NQ                                                   00518300
      IF(ND-NA)51,33,33                                                 00518400
33    I=IB(NA)                                                          00518500
      J=IC(NA)                                                          00518600
      IF(I-J)34,32,34                                                   00518700
34    NB=NA                                                             00518800
      IF(IN(I)+IN(J))35,35,37                                           00518900
35    NB=NB+1                                                           00519000
      IF(ND-NB)32,36,36                                                 00519100
36    IF((IB(NB)-I)*(IB(NB)-J)*(IC(NB)-J))35,40,35                      00519200
37    IF(IN(I))43,43,38                                                 00519300
38    IF(IN(J))39,39,47                                                 00519400
39    N=3*J-4                                                           00519500
      M=3*I-4                                                           00519600
      IN(J)=IN(I)                                                       00519700
      GOTO 44                                                           00519800
40    IF(IABS(IB(NB)-I)+IABS(IC(NB)-J))35,35,41                         00519900
41    IF(IB(NB)-IC(NB))42,35,42                                         00520000
42    NM=MIN0(NM+1,10)                                                  00520100
      IN(J)=NM                                                          00520200
      NB=NA                                                             00520300
43    IN(I)=IN(J)                                                       00520400
      N=3*I-4                                                           00520500
      M=3*J-4                                                           00520600
44    DO 45 L=1,NY,12                                                   00520700
      X=A(N)*H(L)+A(N+1)*H(L+1)+A(N+2)*H(L+2)+H(L+9)                    00520800
      Y=A(N)*H(L+3)+A(N+1)*H(L+4)+A(N+2)*H(L+5)+H(L+10)                 00520900
      Z=A(N)*H(L+6)+A(N+1)*H(L+7)+A(N+2)*H(L+8)+H(L+11)                 00521000
      U=A(M)-X                                                          00521100
      V=A(M+1)-Y                                                        00521200
      W=A(M+2)-Z                                                        00521300
      U=U-AINT(U+SIGN(0.5,.000001+U))                                   00521400
      V=V-AINT(V+SIGN(0.5,.000001+V))                                   00521500
      W=W-AINT(W+SIGN(0.5,.000001+W))                                   00521600
      IF(A(N+4)+A(M+4)-SQRT(U*U*C(8)+V*V*C(9)+W*W*C(10)+V*W*C(11)+      00521700
     *U*W*C(12)+U*V*C(13)))45,45,46                                     00521800
45    CONTINUE                                                          00521900
46    A(N)=A(M)-U                                                       00522000
      A(N+1)=A(M+1)-V                                                   00522100
      A(N+2)=A(M+2)-W                                                   00522200
      ASSIGN 50 TO NQ                                                   00522300
47    NB=NB+1                                                           00522400
      IF(ND-NB)49,48,48                                                 00522500
48    I=IB(NB)                                                          00522600
      J=IC(NB)                                                          00522700
      IF(IN(I)+IN(J))47,47,37                                           00522800
49    GOTO NQ,(50,32)                                                   00522900
50    ASSIGN 32 TO NQ                                                   00523000
      NB=NA                                                             00523100
      GOTO 47                                                           00523200
C                                                                       00523300
C ORIENTATION MATRICES                                                  00523400
C                                                                       00523500
51    ZA=C(2)*COS(.0174533*C(6))                                        00523600
      YB=C(3)*SIN(.0174533*C(5))                                        00523700
      ZB=C(3)*COS(.0174533*C(5))                                        00523800
      YA=(C(2)*C(3)*COS(.0174533*C(7))-ZB*ZA)/YB                        00523900
      XA=SQRT(C(2)*C(2)-ZA*ZA-YA*YA)                                    00524000
      ZC=C(4)                                                           00524100
      L=17                                                              00524200
      DO 52 K=1,178,3                                                   00524300
      H(K)=99999.                                                       00524400
      H(K+1)=-99999.                                                    00524500
52    H(K+2)=.01                                                        00524600
53    N=2                                                               00524700
      NI=-2                                                             00524800
      DO 60 I=1,MA,6                                                    00524900
      M=0                                                               00525000
      J=-2                                                              00525100
      NI=NI+3                                                           00525200
      C(NI)=XA*A(I+1)                                                   00525300
      C(NI+1)=YA*A(I+1)+YB*A(I+2)                                       00525400
      C(NI+2)=ZA*A(I+1)+ZB*A(I+2)+ZC*A(I+3)                             00525500
      K=IN(N)*18-L                                                      00525600
      IF(K)60,60,55                                                     00525700
54    H(K+5)=R                                                          00525800
      R=1./SQRT(R)                                                      00525900
      H(K)=X*R                                                          00526000
      H(K+1)=Y*R                                                        00526100
      H(K+2)=Z*R                                                        00526200
55    M=M+2                                                             00526300
      J=J+3                                                             00526400
      IF(NI-J)60,60,56                                                  00526500
56    IF(IN(N)-IN(M))55,57,55                                           00526600
57    X=C(J)-C(NI)                                                      00526700
      Y=C(J+1)-C(NI+1)                                                  00526800
      Z=C(J+2)-C(NI+2)                                                  00526900
      IF(14-L)59,58,58                                                  00527000
58    U=Y*H(K-4)-Z*H(K-5)                                               00527100
      V=Z*H(K-6)-X*H(K-4)                                               00527200
      Z=X*H(K-5)-Y*H(K-6)                                               00527300
      X=U                                                               00527400
      Y=V                                                               00527500
59    R=X*X+Y*Y+Z*Z                                                     00527600
      IF(R-H(K+5))55,54,54                                              00527700
60    N=N+2                                                             00527800
      L=L-6                                                             00527900
      IF(8-L)53,61,61                                                   00528000
61    NJ=MAX0(1,NM*18)                                                  00528100
      DO 62 J=1,NJ,18                                                   00528200
      H(J+3)=H(J+7)*H(J+2)-H(J+1)*H(J+8)                                00528300
      H(J+4)=H(J)*H(J+8)-H(J+2)*H(J+6)                                  00528400
62    H(J+5)=H(J+1)*H(J+6)-H(J)*H(J+7)                                  00528500
C                                                                       00528600
C SCALE PLOTS                                                           00528700
C                                                                       00528800
      I=1                                                               00528900
      DO 65 J=1,MI,2                                                    00529000
      IF(IN(J+1))65,65,63                                               00529100
63    L=IN(J+1)*18-17                                                   00529200
      M=L+6                                                             00529300
      DO 64 K=L,M,3                                                     00529400
      X=C(I)*H(K)+C(I+1)*H(K+1)+C(I+2)*H(K+2)                           00529500
      H(K+9)=AMIN1(X,H(K+9))                                            00529600
64    H(K+10)=AMAX1(X,H(K+10))                                          00529700
65    I=I+3                                                             00529800
      Y=117./HA                                                         00529900
      Z=114./HD                                                         00530000
      DO 69 K=1,NJ,18                                                   00530100
      H(K+11)=AMIN1(1.,Z/AMAX1(.1,H(K+10)-H(K+9)),Y/                    00530200
     *AMAX1(.1,H(K+13)-H(K+12)))                                        00530300
      IF(Y-H(K+10)+H(K+9))68,66,66                                      00530400
66    I=K+2                                                             00530500
      DO 67 J=K,I                                                       00530600
      U=H(J)                                                            00530700
      H(J)=H(J+3)                                                       00530800
67    H(J+3)=-U                                                         00530900
      H(K+9)=H(K+12)                                                    00531000
      H(K+12)=-H(K+10)                                                  00531100
68    H(K+16)=HD*H(K+11)                                                00531200
69    H(K+17)=HA*H(K+11)                                                00531300
C                                                                       00531400
C PRINT TABLES                                                          00531500
C                                                                       00531600
      WRITE(LI,70)                                                      00531700
70    FORMAT(//6X,                                                      00531800
     *61HATOM HEIGHT   X/A     Y/B     Z/C   S.O.F. MOLECULE ELEVATION/)00531900
71    FORMAT(I4,3X,A4,6X,4F8.4,I5,F11.2)                                00532000
72    FORMAT(I4,3X,1HQ,I3,F6.0,4F8.4,I5,F11.2)                          00532100
73    FORMAT(I4,3X,A4,6X,3F8.4,4H  **,F6.3,5H FROM,I4)                  00532200
74    FORMAT(I4,3X,1HQ,I3,F6.0,3F8.4,4H  **,F6.3,5H FROM,I4)            00532300
      N=1                                                               00532400
      I=-1                                                              00532500
      NB=0                                                              00532600
      DO 84 J=1,MA,6                                                    00532700
      NB=NB+1                                                           00532800
      NJ=J+1                                                            00532900
      I=I+2                                                             00533000
      L=IN(I+1)                                                         00533100
      K=J+4                                                             00533200
      IF(L)75,78,78                                                     00533300
75    L=-L                                                              00533400
      IF(ABS(A(J))-0.1)77,76,76                                         00533500
76    WRITE(LI,74)NB,IN(I),(A(M),M=J,K),L                               00533600
      GOTO 84                                                           00533700
77    WRITE(LI,73)NB,JN(NB),(A(M),M=NJ,K),L                             00533800
      GOTO 84                                                           00533900
78    A(J+5)=0.                                                         00534000
      IF(L)80,80,79                                                     00534100
79    M=18*L-17                                                         00534200
      A(J+5)=(C(N)*H(M+6)+C(N+1)*H(M+7)+C(N+2)*H(M+8)-H(M+15))*H(M+11)  00534300
80    IF(ABS(A(J))-0.1)82,81,81                                         00534400
81    WRITE(LI,72)NB,IN(I),(A(NI),NI=J,K),L,A(J+5)                      00534500
      GOTO 83                                                           00534600
82    WRITE(LI,71)NB,JN(NB),(A(NI),NI=NJ,K),L,A(J+5)                    00534700
83    IF(L.LT.1)GOTO 84                                                 00534800
      IN(I)=INT((C(N)*H(M)+C(N+1)*H(M+1)+C(N+2)*H(M+2)-H(M+9))*H(M+16)+ 00534900
     *1.01)*121+INT((C(N)*H(M+3)+C(N+1)*H(M+4)+C(N+2)*H(M+5)-H(M+12))*  00535000
     *H(M+17)+2.01)                                                     00535100
84    N=N+3                                                             00535200
      IF(KP.EQ.0)GOTO 110                                               00535300
85    FORMAT(//41H BONDS (INCLUDING SYMMETRY RELATED ATOMS)/)           00535400
      WRITE(LI,85)                                                      00535500
      DO 86 I=1,ND                                                      00535600
      IB(I)=IB(I)/2                                                     00535700
86    IC(I)=IC(I)/2                                                     00535800
87    FORMAT(7(I7,1H-,I3,F6.2)/)                                        00535900
      WRITE(LI,87)(IB(I),IC(I),B(I),I=1,ND)                             00536000
C                                                                       00536100
C PLOT MOLECULES                                                        00536200
C                                                                       00536300
88    FORMAT(9H1MOLECULE,I3,5H  FOR,40A1//7H MATRIX,9F8.4,10H   SCALE =,00536400
     *F6.3,20H INCHES PER ANGSTROM//)                                   00536500
      M=121                                                             00536600
      I=0                                                               00536700
      N=-17                                                             00536800
89    N=N+18                                                            00536900
      I=I+1                                                             00537000
      IF(I.GT.NM)GOTO 97                                                00537100
      NJ=N+8                                                            00537200
      WRITE(LI,88)I,IT,(H(J),J=N,NJ),H(N+11)                            00537300
      NJ=121                                                            00537400
      DO 90 J=1,MI,2                                                    00537500
90    IF(IN(J+1).EQ.I)NJ=MAX0(NJ,IN(J))                                 00537600
      NJ=NJ/121                                                         00537700
      DO 96 K=1,NJ                                                      00537800
      DO 91 J=1,M                                                       00537900
91    IB(J)=IH(11)                                                      00538000
      M=1                                                               00538100
      DO 94 J=1,MI,2                                                    00538200
      IF(IN(J+1).NE.I)GOTO 94                                           00538300
      IF(K.NE.(IN(J)/121))GOTO 94                                       00538400
      L=MOD(IN(J),121)                                                  00538500
      NB=(J+1)/2                                                        00538600
      NI=MOD(NB,10)+1                                                   00538700
      M=MAX0(L+2,M)                                                     00538800
      IF(IB(L+2).NE.IH(11))NI=12                                        00538900
      IB(L+2)=IH(NI)                                                    00539000
      NI=NB/10                                                          00539100
      IF(NI)94,94,92                                                    00539200
92    NI=MOD(NI,10)+1                                                   00539300
      IF(IB(L+1).NE.IH(11))NI=12                                        00539400
      IB(L+1)=IH(NI)                                                    00539500
      NI=NB/100                                                         00539600
      IF(NI)94,94,93                                                    00539700
93    IF(IB(L).NE.IH(11))NI=11                                          00539800
      IB(L)=IH(NI+1)                                                    00539900
94    CONTINUE                                                          00540000
95    FORMAT(121A1)                                                     00540100
96    WRITE(LI,95)(IB(L),L=1,M)                                         00540200
      GOTO 89                                                           00540300
C                                                                       00540400
C SCALE PROJECTION                                                      00540500
C                                                                       00540600
97    IF(JV.EQ.0)GOTO 110                                               00540700
      Q=AA                                                              00540800
      P=0.                                                              00540900
      R=AMIN1(0.,AD)                                                    00541000
      L=40                                                              00541100
      ASSIGN 100 TO NU                                                  00541200
      ASSIGN 102 TO NQ                                                  00541300
98    J=-5                                                              00541400
      NI=0                                                              00541500
99    J=J+6                                                             00541600
      IF(J.GT.MA)GOTO NQ,(102,104)                                      00541700
      NI=NI+2                                                           00541800
      IF(IN(NI).LT.0)GOTO 99                                            00541900
      I=J+JA                                                            00542000
      K=J+JD                                                            00542100
      W=A(I)*AA                                                         00542200
      U=A(I)*AD+A(K)*DD                                                 00542300
      GOTO NU,(100,101)                                                 00542400
100   Q=AMAX1(Q,W)                                                      00542500
      P=AMIN1(P,W)                                                      00542600
      R=AMIN1(R,U)                                                      00542700
      GOTO 99                                                           00542800
101   L=L+1                                                             00542900
      IB(L+300)=MOD(IN(NI),10)+1                                        00543000
      IC(L+300)=INT(S*(W-P)+2.1)                                        00543100
      IC(L)=INT(T*(U-R)+2.1)                                            00543200
      GOTO 99                                                           00543300
102   S=AMIN1(1.,Y/(Q-P))                                               00543400
      WRITE(LI,103)IH(JV+12),S                                          00543500
103   FORMAT(11H1VIEW DOWN ,A1,15H AXIS,  SCALE =,F6.3,                 00543600
     *20H INCHES PER ANGSTROM//)                                        00543700
      T=S*HD                                                            00543800
      S=S*HA                                                            00543900
      ASSIGN 101 TO NU                                                  00544000
      ASSIGN 104 TO NQ                                                  00544100
      GOTO 98                                                           00544200
C                                                                       00544300
C AXES                                                                  00544400
C                                                                       00544500
104   U=0.1                                                             00544600
      W=0.                                                              00544700
      V=0.                                                              00544800
      DO 105 I=1,40                                                     00544900
      IB(I+300)=12                                                      00545000
      IC(I+300)=INT(S*(W*AA-P)+2.1)                                     00545100
      IC(I)=INT(T*(V*DD+W*AD-R)+2.1)                                    00545200
      IF(I.EQ.21)U=-0.1                                                 00545300
      J=MOD((I-1)/10,2)                                                 00545400
      IF(J.EQ.0)W=W+U                                                   00545500
105   IF(J.EQ.1)V=V+U                                                   00545600
      IB(301)=JV+12                                                     00545700
      IB(311)=JA+12                                                     00545800
      IB(331)=JD+12                                                     00545900
C                                                                       00546000
C PLOT PROJECTION                                                       00546100
C                                                                       00546200
      NI=1                                                              00546300
      DO 106 J=1,L                                                      00546400
106   NI=MAX0(NI,IC(J))                                                 00546500
      DO 109 I=1,NI                                                     00546600
      DO 107 J=2,M                                                      00546700
107   IB(J)=IH(11)                                                      00546800
      M=1                                                               00546900
      DO 108 J=1,L                                                      00547000
      IF(IC(J).NE.I)GOTO 108                                            00547100
      K=IC(J+300)                                                       00547200
      M=MAX0(M,K)                                                       00547300
      N=IB(J+300)                                                       00547400
      IB(K)=IH(N)                                                       00547500
108   CONTINUE                                                          00547600
109   WRITE(LI,95)(IB(K),K=1,M)                                         00547700
110   RETURN                                                            00547800
      END                                                               00547900
C                                                                       00548000
      SUBROUTINE XERR                                                   00548100
      DIMENSION IL(5)                                                   00548200
      COMMON LM,LR,LH,LI,LP,LA,LB,LC,LF,LU,LV,HA,HD,JN(160),            00548300
     *IT(40),IN(660),C(1740),IG(1200),IK(1200),IP(20),F(84)             00548400
      DATA IL(1)/1HN/,IL(2)/1HV/,IL(3)/1HH/,IL(4)/1HK/,IL(5)/1HL/       00548500
      READ(LB)IT,JN,IN,C                                                00548600
      REWIND LB                                                         00548700
      KK=1                                                              00548800
C                                                                       00548900
C ERROR MESSAGES                                                        00549000
C                                                                       00549100
      IF(IN(20))1,41,41                                                 00549200
1     NER=-IN(20)                                                       00549300
2     WRITE(LI,3)                                                       00549400
3     FORMAT(///9H ** ERROR/)                                           00549500
      GOTO(4,6,11,13,15,17,29,20,9,22,24,27,31,33,35,37,39),NER         00549600
4     WRITE(LI,5)IN(1)                                                  00549700
5     FORMAT(12H UNSUITABLE ,A4,5H CARD)                                00549800
      GOTO 131                                                          00549900
6     WRITE(LI,7)                                                       00550000
7     FORMAT(19H CRYSTAL INCOMPLETE)                                    00550100
      GOTO 131                                                          00550200
8     FORMAT(/26H MAXIMUM NUMBER ALLOWED IS,I6)                         00550300
9     WRITE(LI,10)                                                      00550400
10    FORMAT(/18H PROBLEM TOO LARGE)                                    00550500
      GOTO 131                                                          00550600
11    WRITE(LI,12)                                                      00550700
12    FORMAT(15H TOO MANY ATOMS)                                        00550800
13    WRITE(LI,14)                                                      00550900
14    FORMAT(26H N(ISO)+2N(ANIS) TOO LARGE)                             00551000
      WRITE(LI,8)IN(1)                                                  00551100
      GOTO 131                                                          00551200
15    WRITE(LI,16)IN(1)                                                 00551300
16    FORMAT(29H ILLEGAL CONSTRAINTS TO ATOM ,A4)                       00551400
      GOTO 131                                                          00551500
17    WRITE(LI,18)                                                      00551600
18    FORMAT(25H CONDENSED DATA CORRUPTED)                              00551700
      GOTO 131                                                          00551800
19    FORMAT(17H USE LARGER STORE)                                      00551900
20    WRITE(LI,21)                                                      00552000
21    FORMAT(29H NOT ENOUGH STORE FOR FOURIER)                          00552100
      GOTO 26                                                           00552200
22    WRITE(LI,23)IN(1)                                                 00552300
23    FORMAT(1X,A4,13H CARD MISSING)                                    00552400
      GOTO 131                                                          00552500
24    WRITE(LI,25)                                                      00552600
25    FORMAT(49H TOO MANY INDEPENDENT VARIABLES FOR LEAST-SQUARES)      00552700
      WRITE(LI,8)IN(1)                                                  00552800
26    WRITE(LI,19)                                                      00552900
      GOTO 131                                                          00553000
27    WRITE(LI,28)                                                      00553100
28    FORMAT(28H SORTED F(OBS) DATA REQUIRED)                           00553200
      GOTO 131                                                          00553300
29    WRITE(LI,30)                                                      00553400
30    FORMAT(29H ATOMS REQUIRED BUT NOT GIVEN)                          00553500
      GOTO 131                                                          00553600
31    WRITE(LI,32)                                                      00553700
32    FORMAT(29H UNKNOWN ELEMENT ON SFAC CARD)                          00553800
      GOTO 131                                                          00553900
33    WRITE(LI,34)                                                      00554000
34    FORMAT(20H BLOC IN RIGID GROUP)                                   00554100
      GOTO 131                                                          00554200
35    WRITE(LI,36)                                                      00554300
36    FORMAT(22H BAD DATA OR HKLF CARD)                                 00554400
      GOTO 131                                                          00554500
37    WRITE(LI,38)                                                      00554600
38    FORMAT(35H TOO MANY LAYERS (OR BAD AXIS CARD))                    00554700
      GOTO 131                                                          00554800
39    WRITE(LI,40)                                                      00554900
40    FORMAT(15H NO F(OBS) DATA)                                        00555000
      GOTO 131                                                          00555100
C                                                                       00555200
C FO/FC TABLES                                                          00555300
C                                                                       00555400
41    NT=IABS(IN(11))                                                   00555500
      LS=MIN0(150*INT(HD+0.001),1200)                                   00555600
      KP=1                                                              00555700
      W=1.                                                              00555800
      J=0                                                               00555900
      IF(IN(11))42,67,43                                                00556000
42    W=10.                                                             00556100
43    I=-5                                                              00556200
      READ(LA)F                                                         00556300
44    I=I+6                                                             00556400
      IF(LV-I)43,45,45                                                  00556500
45    ASSIGN 66 TO NQ                                                   00556600
      IF(ABS(F(I))-.8)48,46,46                                          00556700
46    IF(C(46)-F(I+3))44,47,47                                          00556800
47    ASSIGN 64 TO NQ                                                   00556900
      CALL HKL(F(I),X,Y,Z)                                              00557000
      IF(LS-J)48,48,64                                                  00557100
48    K=1                                                               00557200
      NJ=(J-1)/25                                                       00557300
      NK=NJ*5                                                           00557400
      L=-4                                                              00557500
      NJ=(MOD(J+24,25)+1)*(NJ+1)                                        00557600
49    L=L+5                                                             00557700
      NI=NK                                                             00557800
      M=L                                                               00557900
50    IF(J-M)49,51,51                                                   00558000
51    DO 52 N=1,5                                                       00558100
      IK(K)=IG(M)                                                       00558200
      M=M+1                                                             00558300
52    K=K+1                                                             00558400
      M=M+NI                                                            00558500
      IF(M-NJ)54,53,53                                                  00558600
53    NI=NK-5                                                           00558700
54    IF(J-K)55,50,50                                                   00558800
55    DO 62 K=1,NT                                                      00558900
      WRITE(LI,56)                                                      00559000
56    FORMAT(1H1///////)                                                00559100
      WRITE(LI,57)IT,KP                                                 00559200
57    FORMAT(49H   OBSERVED AND CALCULATED STRUCTURE FACTORS FOR ,40A1, 00559300
     *12X,4HPAGE,I3/)                                                   00559400
      IF(IN(11))58,60,60                                                00559500
58    WRITE(LI,59)                                                      00559600
59    FORMAT(5(22H   H  K  L 10FO 10FC  )/)                             00559700
      GOTO 62                                                           00559800
60    WRITE(LI,61)                                                      00559900
61    FORMAT(5(22H   H  K  L   FO   FC  )/)                             00560000
62    WRITE(LI,63)(IK(NP),NP=1,J)                                       00560100
63    FORMAT(5(I4,2I3,2I5,2X))                                          00560200
      KP=KP+1                                                           00560300
      J=0                                                               00560400
      GOTO NQ,(64,66)                                                   00560500
64    IG(J+1)=X                                                         00560600
      IG(J+2)=Y                                                         00560700
      IG(J+3)=Z                                                         00560800
      IG(J+4)=INT(F(I+1)*W+0.5)                                         00560900
      J=J+5                                                             00561000
      IG(J)=INT(SQRT(F(I+4)*F(I+4)+F(I+5)*F(I+5))*W+0.5)                00561100
      IF(C(23)-0.1)65,65,44                                             00561200
65    IF(F(I+4).LT.0.)IG(J)=-IG(J)                                      00561300
      GOTO 44                                                           00561400
C                                                                       00561500
C F(OBS) CARDS ETC.                                                     00561600
C                                                                       00561700
66    REWIND LA                                                         00561800
67    LQ=LF                                                             00561900
      NJ=MIN0(IABS(IN(10))+1,7)                                         00562000
      NP=0                                                              00562100
      JK=0                                                              00562200
      NER=12                                                            00562300
      DO 68 I=1000,1600                                                 00562400
68    C(I)=0.                                                           00562500
      GOTO(115,74,71,79,79,69,78),NJ                                    00562600
69    WRITE(LI,75)IT                                                    00562700
      WRITE(LI,70)                                                      00562800
70    FORMAT(51H   H   K   L     FO      FC      A       B      PHI,    00562900
     *19H    DEL(F)  SIG*(F)/)                                          00563000
      GOTO 78                                                           00563100
71    WRITE(LP,72)IT                                                    00563200
72    FORMAT(/23H    CONDENSED DATA FOR ,40A1)                          00563300
      READ(LF)F                                                         00563400
      REWIND LF                                                         00563500
      NN=MIN0(INT(F(1)-1.1),0)                                          00563600
      WRITE(LP,73)NN                                                    00563700
73    FORMAT(/33HHKLF -1 1  1 0 0  0 1 0  0 0 1  1,I8)                  00563800
      GOTO 79                                                           00563900
74    WRITE(LI,75)IT                                                    00564000
75    FORMAT(1H1,40A1//)                                                00564100
      WRITE(LI,76)                                                      00564200
76    FORMAT(32H DEVIATIONS GREATER THAN 2 SIGMA/)                      00564300
      WRITE(LI,77)                                                      00564400
      SC=10000./C(26)                                                   00564500
77    FORMAT(37H   H   K   L     FO      FC   D/SIGMA/)                 00564600
78    LQ=LA                                                             00564700
79    READ(LQ)F                                                         00564800
      I=-5                                                              00564900
80    I=I+6                                                             00565000
      IF(LV-I)79,81,81                                                  00565100
81    IF(ABS(F(I))-.8)113,82,82                                         00565200
82    IF(NJ.EQ.3)GOTO 83                                                00565300
      IF(C(46)-F(I+3))80,83,83                                          00565400
83    CALL HKL(F(I),C(2),C(3),C(4))                                     00565500
      Q=SQRT(126.6515*F(I+3))*C(1)                                      00565600
      NH=C(2)                                                           00565700
      NK=C(3)                                                           00565800
      NL=C(4)                                                           00565900
      S=F(I+4)*F(I+4)+F(I+5)*F(I+5)                                     00566000
      U=SQRT(S)+1.E-8                                                   00566100
      V=F(I+1)-U                                                        00566200
      T=F(I+2)*V*V                                                      00566300
      SF=ABS(1.E-5/F(I+2))                                              00566400
      N=I+5                                                             00566500
      IF(NJ.EQ.7)GOTO 85                                                00566600
      N=I+2                                                             00566700
      F(I+2)=SQRT(F(I+2))                                               00566800
      GOTO(80,87,92,85,84,86),NJ                                        00566900
84    N=I+1                                                             00567000
      F(I+1)=AMOD(F(I+4),10.)                                           00567100
85    M=I+1                                                             00567200
      WRITE(LP,91)NH,NK,NL,(F(J),J=M,N)                                 00567300
      GOTO 80                                                           00567400
86    S=1./F(I+2)                                                       00567500
      T=AMOD(720.+ATAN2(F(I+5),F(I+4))*57.29578,360.)                   00567600
      WRITE(LI,91)NH,NK,NL,F(I+1),U,F(I+4),F(I+5),T,V,S                 00567700
      GOTO 80                                                           00567800
87    C(1309)=C(1309)+T                                                 00567900
      C(1009)=C(1009)+1.                                                00568000
      J=INT(AMOD(400.1+4.*C(4),8.)+AMOD(400.1+2.*C(3),4.)+              00568100
     *AMOD(400.1+C(2),2.))                                              00568200
      C(J+1301)=C(J+1301)+T                                             00568300
      C(J+1001)=C(J+1001)+1.                                            00568400
      N=1041                                                            00568500
      DO 88 K=2,4                                                       00568600
      J=MIN0(INT(ABS(C(K))+0.1),14)                                     00568700
      L=J+N                                                             00568800
      C(L)=C(L)+1.                                                      00568900
      C(L+300)=C(L+300)+T                                               00569000
88    N=N+15                                                            00569100
      DO 89 K=1101,1201,100                                             00569200
      J=K+INT(Q)                                                        00569300
      C(J+300)=C(J+300)+T                                               00569400
      C(J)=C(J)+1.                                                      00569500
89    Q=SQRT(ABS(SC*F(I+1)))-0.01                                       00569600
      IF(T-4.*C(29))80,80,90                                            00569700
90    T=SQRT(T/C(29))                                                   00569800
      WRITE(LI,91)NH,NK,NL,F(I+1),U,T                                   00569900
91    FORMAT(3I4,8F8.2)                                                 00570000
      GOTO 80                                                           00570100
C                                                                       00570200
C CONDENSED DATA                                                        00570300
C                                                                       00570400
92    J=NH+100*(NK+100*NL)-NN                                           00570500
      IF(J)2,2,98                                                       00570600
93    NN=NN+99900-J                                                     00570700
      J=J-99900                                                         00570800
      K=999                                                             00570900
      ASSIGN 98 TO NQ                                                   00571000
94    NP=NP+1                                                           00571100
      IP(NP)=K                                                          00571200
      JK=MOD(JK+K*KK,10000)                                             00571300
      IF(NP-20)97,95,95                                                 00571400
95    WRITE(LP,96)IP                                                    00571500
      KK=MOD(KK,99)+1                                                   00571600
96    FORMAT(20I4)                                                      00571700
      NP=0                                                              00571800
97    GOTO NQ,(80,98,101,104,109)                                       00571900
98    NN=NN+J                                                           00572000
      IF(J-100000)99,99,93                                              00572100
99    IF(J-1000)102,102,100                                             00572200
100   K=(J-1)/100                                                       00572300
      ASSIGN 101 TO NQ                                                  00572400
      GOTO 94                                                           00572500
101   J=J-(100*K)                                                       00572600
102   IF(J-10)105,103,103                                               00572700
103   K=1-J                                                             00572800
      ASSIGN 104 TO NQ                                                  00572900
      GOTO 94                                                           00573000
104   J=J+K                                                             00573100
105   K=1000                                                            00573200
      X=AMIN1(SF,9.89)                                                  00573300
106   K=K-100                                                           00573400
      X=X*10.                                                           00573500
      IF(K)107,108,107                                                  00573600
107   IF(X-9.9)106,108,108                                              00573700
108   K=K+INT(X+0.5)+(1000*J)                                           00573800
      ASSIGN 109 TO NQ                                                  00573900
      GOTO 94                                                           00574000
109   K=10000                                                           00574100
      X=AMIN1(ABS(F(I+1)*1.E-6),99.89)                                  00574200
110   K=K-1000                                                          00574300
      X=X*10.                                                           00574400
      IF(K-1000)111,112,111                                             00574500
111   IF(X-99.9)110,112,112                                             00574600
112   K=K+INT(X+0.5)                                                    00574700
      ASSIGN 80 TO NQ                                                   00574800
      GOTO 94                                                           00574900
C                                                                       00575000
C END OF DATA                                                           00575100
C                                                                       00575200
113   REWIND LQ                                                         00575300
      IF(NJ.NE.3)GOTO 115                                               00575400
      NP=NP+1                                                           00575500
      LS=0                                                              00575600
      IP(NP)=0                                                          00575700
      IF(20.GT.NP)GOTO 114                                              00575800
      WRITE(LP,96)IP                                                    00575900
      NP=0                                                              00576000
114   NP=NP+1                                                           00576100
      IP(NP)=JK                                                         00576200
      WRITE(LP,96)(IP(I),I=1,NP)                                        00576300
115   WRITE(LP,116)                                                     00576400
116   FORMAT(/3HEND//)                                                  00576500
      IF(NJ.NE.2)GOTO 131                                               00576600
C                                                                       00576700
C ANALYSIS OF VARIANCE                                                  00576800
C                                                                       00576900
      WRITE(LI,117)IT                                                   00577000
117   FORMAT(25H1ANALYSIS OF VARIANCE FOR ,40A1///19X,                  00577100
     *59HGGG    UGG    GUG    UUG    GGU    UGU    GUU    UUU    ALL)   00577200
118   FORMAT(/8X,A1,6X,15I7)                                            00577300
119   FORMAT(///19H SIN THETA     0.00,10(2H -,F5.2))                   00577400
120   FORMAT(///19H SQRT(F/FMAX)  0.00,10(2H -,F5.2))                   00577500
121   FORMAT(///9X,4HABS(,A1,8H)      0,13I7,4X,4HREST)                 00577600
      DO 122 I=1,13                                                     00577700
122   IG(I)=I                                                           00577800
      X=0.1*C(1009)                                                     00577900
      DO 125 L=10,20,10                                                 00578000
      M=L-10                                                            00578100
      W=0.001                                                           00578200
      N=(L*10)+1000                                                     00578300
      Y=-0.5                                                            00578400
      S=0.                                                              00578500
123   M=M+1                                                             00578600
      Y=Y+X                                                             00578700
      IF(L-M)125,124,124                                                00578800
124   W=W+0.01                                                          00578900
      N=N+1                                                             00579000
      S=S+C(N)                                                          00579100
      C(M+1020)=C(M+1020)+C(N)                                          00579200
      C(M+1320)=C(M+1320)+C(N+300)                                      00579300
      C(M+1400)=W                                                       00579400
      IF(Y-S)123,124,124                                                00579500
125   CONTINUE                                                          00579600
      M=9                                                               00579700
      I=1001                                                            00579800
      DO 130 NL=1,6                                                     00579900
      DO 126 L=1,M                                                      00580000
      X=100.*SQRT(C(I+300)*C(27)/AMAX1(C(I),1.))+0.5                    00580100
      IP(L)=X                                                           00580200
      IK(L)=C(I)                                                        00580300
126   I=I+1                                                             00580400
      WRITE(LI,118)IL(1),(IK(L),L=1,M)                                  00580500
      WRITE(LI,118)IL(2),(IP(L),L=1,M)                                  00580600
      GOTO(127,128,129,129,129,130),NL                                  00580700
127   WRITE(LI,119)(C(L),L=1401,1410)                                   00580800
      I=1021                                                            00580900
      M=10                                                              00581000
      GOTO 130                                                          00581100
128   WRITE(LI,120)(C(L),L=1411,1420)                                   00581200
      GOTO 130                                                          00581300
129   M=15                                                              00581400
      WRITE(LI,121)IL(NL),(IG(L),L=1,13)                                00581500
130   CONTINUE                                                          00581600
131   RETURN                                                            00581700
      END                                                               00581800
                                                                                
                                                                                
                                                                                
                                                                                
                                                                                
                                                                                

